--------------------------------------------------------------------------------
-- Copyright (c) 1995-2012 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 14.1
--  \   \         Application : sch2hdl
--  /   /         Filename : BNK_SWAP_DET.vhf
-- /___/   /\     Timestamp : 08/04/2018 13:57:31
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: sch2hdl -intstyle ise -family spartan3a -flat -suppress -vhdl C:/XilinxDesigns/KDL_V34_TestPoints/BNK_SWAP_DET.vhf -w C:/XilinxDesigns/KDL_V34_TestPoints/BNK_SWAP_DET.sch
--Design Name: BNK_SWAP_DET
--Device: spartan3a
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity BNK_SWAP_DET is
   port ( BANK_MSB        : in    std_logic; 
          CLK             : in    std_logic; 
          BANK_SWAP_PULSE : out   std_logic);
end BNK_SWAP_DET;

architecture BEHAVIORAL of BNK_SWAP_DET is
   attribute BOX_TYPE   : string ;
   signal FE_Q            : std_logic_vector (2 downto 0);
   signal RE_Q            : std_logic_vector (2 downto 0);
   signal XLXN_5          : std_logic;
   signal XLXN_6          : std_logic;
   component SP3A_Sipo3_Lsb
      port ( SDIN : in    std_logic; 
             Q    : out   std_logic_vector (2 downto 0); 
             CLK  : in    std_logic);
   end component;
   
   component AND2B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2B1 : component is "BLACK_BOX";
   
   component OR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2 : component is "BLACK_BOX";
   
begin
   FALL_EDGE_SIPO : SP3A_Sipo3_Lsb
      port map (CLK=>CLK,
                SDIN=>BANK_MSB,
                Q(2 downto 0)=>FE_Q(2 downto 0));
   
   RISE_EDGE_SIPO : SP3A_Sipo3_Lsb
      port map (CLK=>CLK,
                SDIN=>BANK_MSB,
                Q(2 downto 0)=>RE_Q(2 downto 0));
   
   XLXI_4 : AND2B1
      port map (I0=>RE_Q(2),
                I1=>RE_Q(1),
                O=>XLXN_6);
   
   XLXI_5 : AND2B1
      port map (I0=>FE_Q(1),
                I1=>FE_Q(2),
                O=>XLXN_5);
   
   XLXI_25 : OR2
      port map (I0=>XLXN_6,
                I1=>XLXN_5,
                O=>BANK_SWAP_PULSE);
   
end BEHAVIORAL;


