-- Generic Terminal counter
-- Dec 22, 2004
-- Anthony Medina
-- Made this a sync reset
--
LIBRARY IEEE ;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY BPCLK_COUNTER IS
	GENERIC(WIDTH	: INTEGER	:= 24);
PORT(
		CLK_BP	:IN		STD_LOGIC;							--	BP CLK TO MONITOR
		RST		:IN		STD_LOGIC;
		BPCOUNT	:OUT	STD_LOGIC_VECTOR (WIDTH-1 DOWNTO 0)	--	COUNTER ACTIVE
	);
END BPCLK_COUNTER;

ARCHITECTURE Behave OF BPCLK_COUNTER IS

SIGNAL	CNTTMP		:	STD_LOGIC_VECTOR (WIDTH-1 DOWNTO 0)	:=	(OTHERS => '0');

BEGIN

BPCOUNTER : PROCESS(CLK_BP,RST) IS
	-- Put declarations here.
BEGIN
	-- Put sequential statements here.
	IF RST = '1' THEN
		CNTTMP	<=	(OTHERS => '0');
	ELSIF RISING_EDGE(CLK_BP) THEN
		CNTTMP	<=	CNTTMP + '1';
	END IF;
	BPCOUNT	<=	CNTTMP;
END PROCESS BPCOUNTER;
END Behave;
