--------------------------------------------------------------------------------
-- Copyright (c) 1995-2012 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 14.1
--  \   \         Application : sch2hdl
--  /   /         Filename : BP_SCLKFX_ALIGN.vhf
-- /___/   /\     Timestamp : 08/11/2018 20:36:38
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: sch2hdl -intstyle ise -family spartan3a -flat -suppress -vhdl C:/XilinxDesigns/KDL_V38_SandBox/BP_SCLKFX_ALIGN.vhf -w C:/XilinxDesigns/KDL_V38_SandBox/BP_SCLKFX_ALIGN.sch
--Design Name: BP_SCLKFX_ALIGN
--Device: spartan3a
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity BP_SCLKFX_ALIGN is
   port ( BPLRCLK           : in    std_logic; 
          BPMCLK            : in    std_logic; 
          BPMCLK_DCM_LOCKED : in    std_logic; 
          BPMCLK_FB         : in    std_logic; 
          RST               : in    std_logic; 
          BPSCLKGEN_LOCK    : out   std_logic; 
          CLKGEN_DLRCLK     : out   std_logic; 
          CLKGEN_DSCLK      : out   std_logic; 
          SCLKGEN_FB        : out   std_logic; 
          SCLKGEN_3M        : out   std_logic; 
          SCLKGEN_180       : out   std_logic);
end BP_SCLKFX_ALIGN;

architecture BEHAVIORAL of BP_SCLKFX_ALIGN is
   attribute CLK_FEEDBACK          : string ;
   attribute CLKDV_DIVIDE          : string ;
   attribute CLKFX_DIVIDE          : string ;
   attribute CLKIN_PERIOD          : string ;
   attribute CLKFX_MULTIPLY        : string ;
   attribute CLKIN_DIVIDE_BY_2     : string ;
   attribute CLKOUT_PHASE_SHIFT    : string ;
   attribute DESKEW_ADJUST         : string ;
   attribute DFS_FREQUENCY_MODE    : string ;
   attribute DLL_FREQUENCY_MODE    : string ;
   attribute DSS_MODE              : string ;
   attribute DUTY_CYCLE_CORRECTION : string ;
   attribute PHASE_SHIFT           : string ;
   attribute STARTUP_WAIT          : string ;
   attribute FACTORY_JF            : string ;
   attribute BOX_TYPE              : string ;
   signal BPMCLK_LOCKED     : std_logic;
   signal CLKGEN            : std_logic_vector (9 downto 0);
   signal LREDGE_ALIGN      : std_logic;
   signal SCLKGEN_CLKIN     : std_logic;
   signal SCLKGEN_RESYNC    : std_logic;
   signal XLXN_421          : std_logic;
   signal XLXN_422          : std_logic;
   signal XLXN_429          : std_logic;
   signal XLXN_430          : std_logic;
   signal XLXN_461          : std_logic;
   signal XLXN_462          : std_logic;
   signal XLXN_570          : std_logic;
   signal SCLKGEN_FB_DUMMY  : std_logic;
   component DCM_SP
      -- synopsys translate_off
      generic( CLK_FEEDBACK : string :=  "1X";
               CLKDV_DIVIDE : real :=  2.0;
               CLKFX_DIVIDE : integer :=  1;
               CLKIN_PERIOD : real :=  10.0;
               CLKFX_MULTIPLY : integer :=  4;
               CLKIN_DIVIDE_BY_2 : boolean :=  FALSE;
               CLKOUT_PHASE_SHIFT : string :=  "NONE";
               DESKEW_ADJUST : string :=  "SYSTEM_SYNCHRONOUS";
               DFS_FREQUENCY_MODE : string :=  "LOW";
               DLL_FREQUENCY_MODE : string :=  "LOW";
               DSS_MODE : string :=  "NONE";
               DUTY_CYCLE_CORRECTION : boolean :=  TRUE;
               PHASE_SHIFT : integer :=  0;
               STARTUP_WAIT : boolean :=  FALSE;
               FACTORY_JF : bit_vector :=  x"C080");
      -- synopsys translate_on
      port ( CLKFB    : in    std_logic; 
             CLKIN    : in    std_logic; 
             DSSEN    : in    std_logic; 
             PSCLK    : in    std_logic; 
             PSEN     : in    std_logic; 
             PSINCDEC : in    std_logic; 
             RST      : in    std_logic; 
             CLK0     : out   std_logic; 
             CLK180   : out   std_logic; 
             CLK270   : out   std_logic; 
             CLK2X    : out   std_logic; 
             CLK2X180 : out   std_logic; 
             CLK90    : out   std_logic; 
             CLKDV    : out   std_logic; 
             CLKFX    : out   std_logic; 
             CLKFX180 : out   std_logic; 
             LOCKED   : out   std_logic; 
             PSDONE   : out   std_logic; 
             STATUS   : out   std_logic_vector (7 downto 0));
   end component;
   attribute CLK_FEEDBACK of DCM_SP : component is "1X";
   attribute CLKDV_DIVIDE of DCM_SP : component is "2.0";
   attribute CLKFX_DIVIDE of DCM_SP : component is "1";
   attribute CLKIN_PERIOD of DCM_SP : component is "10.0";
   attribute CLKFX_MULTIPLY of DCM_SP : component is "4";
   attribute CLKIN_DIVIDE_BY_2 of DCM_SP : component is "FALSE";
   attribute CLKOUT_PHASE_SHIFT of DCM_SP : component is "NONE";
   attribute DESKEW_ADJUST of DCM_SP : component is "SYSTEM_SYNCHRONOUS";
   attribute DFS_FREQUENCY_MODE of DCM_SP : component is "LOW";
   attribute DLL_FREQUENCY_MODE of DCM_SP : component is "LOW";
   attribute DSS_MODE of DCM_SP : component is "NONE";
   attribute DUTY_CYCLE_CORRECTION of DCM_SP : component is "TRUE";
   attribute PHASE_SHIFT of DCM_SP : component is "0";
   attribute STARTUP_WAIT of DCM_SP : component is "FALSE";
   attribute FACTORY_JF of DCM_SP : component is "C080";
   attribute BOX_TYPE of DCM_SP : component is "BLACK_BOX";
   
   component LRCLK_EdgeCount_1024
      port ( clk       : in    std_logic; 
             sclr      : in    std_logic; 
             q         : out   std_logic_vector (9 downto 0); 
             q_thresh0 : out   std_logic);
   end component;
   
   component Falling_Edge
      port ( EDGE_DETECT : out   std_logic; 
             CLK         : in    std_logic; 
             F_EDGE      : in    std_logic);
   end component;
   
   component TCNT8
      port ( CLK  : in    std_logic; 
             RST  : in    std_logic; 
             TCNT : out   std_logic);
   end component;
   
   component LRCLK_EdgeCount_1024_3FD
      port ( clk       : in    std_logic; 
             sclr      : in    std_logic; 
             q         : out   std_logic_vector (9 downto 0); 
             q_thresh0 : out   std_logic);
   end component;
   
   component BUFG
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of BUFG : component is "BLACK_BOX";
   
   component GND
      port ( G : out   std_logic);
   end component;
   attribute BOX_TYPE of GND : component is "BLACK_BOX";
   
   component OR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2 : component is "BLACK_BOX";
   
   component FDP
      generic( INIT : bit :=  '1');
      port ( C   : in    std_logic; 
             D   : in    std_logic; 
             PRE : in    std_logic; 
             Q   : out   std_logic);
   end component;
   attribute BOX_TYPE of FDP : component is "BLACK_BOX";
   
   component BUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of BUF : component is "BLACK_BOX";
   
   component INV
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of INV : component is "BLACK_BOX";
   
   attribute CLKOUT_PHASE_SHIFT of BPSCLK_GEN_DCM : label is "FIXED";
   attribute CLKIN_PERIOD of BPSCLK_GEN_DCM : label is "160.0";
   attribute PHASE_SHIFT of BPSCLK_GEN_DCM : label is "122";
begin
   SCLKGEN_FB <= SCLKGEN_FB_DUMMY;
   BPSCLK_GEN_DCM : DCM_SP
   -- synopsys translate_off
   generic map( CLKOUT_PHASE_SHIFT => "FIXED",
            CLKIN_PERIOD => 160.0,
            PHASE_SHIFT => 122)
   -- synopsys translate_on
      port map (CLKFB=>SCLKGEN_FB_DUMMY,
                CLKIN=>SCLKGEN_CLKIN,
                DSSEN=>XLXN_429,
                PSCLK=>XLXN_429,
                PSEN=>XLXN_429,
                PSINCDEC=>XLXN_429,
                RST=>XLXN_430,
                CLKDV=>XLXN_570,
                CLKFX=>open,
                CLKFX180=>open,
                CLK0=>XLXN_421,
                CLK2X=>open,
                CLK2X180=>open,
                CLK90=>open,
                CLK180=>XLXN_422,
                CLK270=>open,
                LOCKED=>BPSCLKGEN_LOCK,
                PSDONE=>open,
                STATUS=>open);
   
   BP_SCLK_GENERATOR : LRCLK_EdgeCount_1024
      port map (clk=>BPMCLK_FB,
                sclr=>SCLKGEN_RESYNC,
                q(9 downto 0)=>CLKGEN(9 downto 0),
                q_thresh0=>open);
   
   LRCLK_FALLING_EDGE : Falling_Edge
      port map (CLK=>BPMCLK_FB,
                F_EDGE=>BPLRCLK,
                EDGE_DETECT=>LREDGE_ALIGN);
   
   SCLKGEN_DCMRST_TCNT : TCNT8
      port map (CLK=>BPLRCLK,
                RST=>BPMCLK_LOCKED,
                TCNT=>XLXN_462);
   
   SCLKGEN_RESYNCER : LRCLK_EdgeCount_1024_3FD
      port map (clk=>BPMCLK_FB,
                sclr=>LREDGE_ALIGN,
                q=>open,
                q_thresh0=>SCLKGEN_RESYNC);
   
   XLXI_394 : BUFG
      port map (I=>XLXN_421,
                O=>SCLKGEN_FB_DUMMY);
   
   XLXI_395 : BUFG
      port map (I=>XLXN_422,
                O=>SCLKGEN_180);
   
   XLXI_396 : BUFG
      port map (I=>CLKGEN(2),
                O=>SCLKGEN_CLKIN);
   
   XLXI_399 : GND
      port map (G=>XLXN_429);
   
   XLXI_420 : OR2
      port map (I0=>BPMCLK_LOCKED,
                I1=>XLXN_462,
                O=>XLXN_461);
   
   XLXI_421 : FDP
      port map (C=>BPMCLK,
                D=>XLXN_461,
                PRE=>RST,
                Q=>XLXN_430);
   
   XLXI_422 : BUF
      port map (I=>CLKGEN(9),
                O=>CLKGEN_DLRCLK);
   
   XLXI_423 : BUF
      port map (I=>CLKGEN(0),
                O=>CLKGEN_DSCLK);
   
   XLXI_424 : INV
      port map (I=>BPMCLK_DCM_LOCKED,
                O=>BPMCLK_LOCKED);
   
   XLXI_425 : BUFG
      port map (I=>XLXN_570,
                O=>SCLKGEN_3M);
   
end BEHAVIORAL;


