-- Generic Terminal counter
-- Dec 22, 2004
-- Anthony Medina
-- Made this a sync reset
--
LIBRARY IEEE ;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY CNTR4_EN_PS1 IS
	GENERIC(WIDTH	: INTEGER	:= 4);
PORT(
		ENA		:IN	STD_LOGIC;
		CLK		:IN	STD_LOGIC;
		RSYNC	:IN	STD_LOGIC;
		COUNT	:OUT	STD_LOGIC_VECTOR (3 DOWNTO 0)
	);
END CNTR4_EN_PS1;

ARCHITECTURE Behave OF CNTR4_EN_PS1 IS

SIGNAL	QTMP			: STD_LOGIC_VECTOR (3 DOWNTO 0);

BEGIN
PROCESS(CLK,RSYNC)

BEGIN

	IF RISING_EDGE(CLK)THEN
		IF(RSYNC = '1') THEN
			QTMP	<= CONV_STD_LOGIC_VECTOR(1,WIDTH);
		ELSIF(ENA = '1')THEN
			QTMP		<= QTMP + '1';
		ELSE
		END IF;
	END IF;

END PROCESS;

	COUNT		<= QTMP;

END Behave;
