--------------------------------------------------------------------------------
-- Copyright (c) 1995-2007 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 9.2.04i
--  \   \         Application : sch2vhdl
--  /   /         Filename : DANTE_VCXO_OVERRIDE.vhf
-- /___/   /\     Timestamp : 11/03/2010 12:12:36
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: C:\Xilinx92i\bin\nt\sch2vhdl.exe -intstyle ise -family spartan3a -flat -suppress -w C:/XilinxWebPack92Designs/KRL_DANTE/DANTE_VCXO_OVERRIDE.sch DANTE_VCXO_OVERRIDE.vhf
--Design Name: DANTE_VCXO_OVERRIDE
--Device: spartan3a
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesis and simulted, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity DANTE_VCXO_OVERRIDE is
   port ( BPCLK_2X         : in    std_logic; 
          BPCLK_2X180      : in    std_logic; 
          BPCLK_90         : in    std_logic; 
          BPCLK_180        : in    std_logic; 
          BPCLK_270        : in    std_logic; 
          BP_FRAMESYNC     : in    std_logic; 
          CLK_OVRRIDE_SELn : in    std_logic; 
          BPLRCLK_OUT_A    : out   std_logic; 
          BPLRCLK_OUT_B    : out   std_logic; 
          BPMCLK_OUT_A     : out   std_logic; 
          BPMCLK_OUT_B     : out   std_logic; 
          BPMCLK_OUT_C     : out   std_logic);
end DANTE_VCXO_OVERRIDE;

architecture BEHAVIORAL of DANTE_VCXO_OVERRIDE is
   signal BP_FRAMESYNC_LRCLK_NEG : std_logic;
   signal BP_FRAMESYNC_LRCLK_POS : std_logic;
   signal PSLRCLK_N              : std_logic_vector (10 downto 0);
   signal PSLRCLK_P              : std_logic_vector (10 downto 0);
   component EdgeDetectRising
      port ( CLK    : in    std_logic; 
             EDGE   : in    std_logic; 
             DETECT : out   std_logic);
   end component;
   
   component OUT_CLK_PIN_MUX
      port ( LRCLK_IN_A  : in    std_logic; 
             LRCLK_IN_B  : in    std_logic; 
             LRCLKSELn   : in    std_logic; 
             MCLKSELn    : in    std_logic; 
             MCLK_IN_A   : in    std_logic; 
             MCLK_IN_B   : in    std_logic; 
             MCLK_IN_C   : in    std_logic; 
             LRCLK_OUT_A : out   std_logic; 
             LRCLK_OUT_B : out   std_logic; 
             MCLK_OUT_A  : out   std_logic; 
             MCLK_OUT_B  : out   std_logic; 
             MCLK_OUT_C  : out   std_logic);
   end component;
   
   component LRCLK_CLK2X_DIV
      port ( clk  : in    std_logic; 
             sclr : in    std_logic; 
             q    : out   std_logic_vector (10 downto 0));
   end component;
   
begin
   LREDGE_GEN_RS_NEG : EdgeDetectRising
      port map (CLK=>BPCLK_2X180,
                EDGE=>BP_FRAMESYNC,
                DETECT=>BP_FRAMESYNC_LRCLK_NEG);
   
   LREDGE_GEN_RS_POS : EdgeDetectRising
      port map (CLK=>BPCLK_2X,
                EDGE=>BP_FRAMESYNC,
                DETECT=>BP_FRAMESYNC_LRCLK_POS);
   
   PIN_MUX_CLK_GND : OUT_CLK_PIN_MUX
      port map (LRCLKSELn=>CLK_OVRRIDE_SELn,
                LRCLK_IN_A=>PSLRCLK_P(10),
                LRCLK_IN_B=>PSLRCLK_N(10),
                MCLKSELn=>CLK_OVRRIDE_SELn,
                MCLK_IN_A=>BPCLK_90,
                MCLK_IN_B=>BPCLK_180,
                MCLK_IN_C=>BPCLK_270,
                LRCLK_OUT_A=>BPLRCLK_OUT_A,
                LRCLK_OUT_B=>BPLRCLK_OUT_B,
                MCLK_OUT_A=>BPMCLK_OUT_A,
                MCLK_OUT_B=>BPMCLK_OUT_B,
                MCLK_OUT_C=>BPMCLK_OUT_C);
   
   PSUDEO_LRCLK_NEDGE : LRCLK_CLK2X_DIV
      port map (clk=>BPCLK_2X180,
                sclr=>BP_FRAMESYNC_LRCLK_NEG,
                q(10 downto 0)=>PSLRCLK_N(10 downto 0));
   
   PSUDEO_LRCLK_PEDGE : LRCLK_CLK2X_DIV
      port map (clk=>BPCLK_2X,
                sclr=>BP_FRAMESYNC_LRCLK_POS,
                q(10 downto 0)=>PSLRCLK_P(10 downto 0));
   
end BEHAVIORAL;


