--------------------------------------------------------------------------------
-- Copyright (c) 1995-2012 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 14.1
--  \   \         Application : sch2hdl
--  /   /         Filename : DeadClock.vhf
-- /___/   /\     Timestamp : 08/04/2018 13:57:35
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: sch2hdl -intstyle ise -family spartan3a -flat -suppress -vhdl C:/XilinxDesigns/KDL_V34_TestPoints/DeadClock.vhf -w C:/XilinxDesigns/KDL_V34_TestPoints/DeadClock.sch
--Design Name: DeadClock
--Device: spartan3a
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity DeadClock is
   port ( BP_MCLK    : in    std_logic; 
          D_MCLK     : in    std_logic; 
          POR        : in    std_logic; 
          RESET      : in    std_logic; 
          BPCLK_CNT  : out   std_logic_vector (23 downto 0); 
          DEAD_CLOCK : out   std_logic);
end DeadClock;

architecture BEHAVIORAL of DeadClock is
   attribute BOX_TYPE   : string ;
   signal XLXN_4          : std_logic;
   signal BPCLK_CNT_DUMMY : std_logic_vector (23 downto 0);
   component BPCLK_COUNTER
      port ( CLK_BP  : in    std_logic; 
             RST     : in    std_logic; 
             BPCOUNT : out   std_logic_vector (23 downto 0));
   end component;
   
   component BPCLK_MONITOR
      port ( CLK_D    : in    std_logic; 
             RST      : in    std_logic; 
             BPCOUNT  : in    std_logic_vector (23 downto 0); 
             INACTIVE : out   std_logic);
   end component;
   
   component OR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2 : component is "BLACK_BOX";
   
begin
   BPCLK_CNT(23 downto 0) <= BPCLK_CNT_DUMMY(23 downto 0);
   BPCLK_COUNT : BPCLK_COUNTER
      port map (CLK_BP=>BP_MCLK,
                RST=>RESET,
                BPCOUNT(23 downto 0)=>BPCLK_CNT_DUMMY(23 downto 0));
   
   BPCLK_MON : BPCLK_MONITOR
      port map (BPCOUNT(23 downto 0)=>BPCLK_CNT_DUMMY(23 downto 0),
                CLK_D=>D_MCLK,
                RST=>XLXN_4,
                INACTIVE=>DEAD_CLOCK);
   
   XLXI_12 : OR2
      port map (I0=>POR,
                I1=>RESET,
                O=>XLXN_4);
   
end BEHAVIORAL;


