-- Generic Terminal counter
-- Dec 22, 2004
-- Anthony Medina
-- Made this a sync reset
--
LIBRARY IEEE ;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY EDGE_COUNT IS
	GENERIC(WIDTH	: INTEGER	:= 8);
PORT(
		CLK		:IN	STD_LOGIC;
		LRCLK	:IN	STD_LOGIC;
		RST		:IN	STD_LOGIC;
		COUNT	:OUT	STD_LOGIC_VECTOR	(WIDTH-1	DOWNTO	0);
		ECNT	:OUT	STD_LOGIC;
		SR48K	:OUT	STD_LOGIC;
		SR44K	:OUT	STD_LOGIC
	);
END EDGE_COUNT;

ARCHITECTURE BEHAVE OF EDGE_COUNT IS

SIGNAL			QTMP			:	STD_LOGIC_VECTOR (WIDTH-1 DOWNTO 0);
SIGNAL			ENDCOUNT	:	STD_LOGIC;

BEGIN
PROCESS(CLK,RST,QTMP)
	CONSTANT	EDGECHK	:	INTEGER	:=	16#83#;	--	131 Dec/ 83 Hex
BEGIN

IF RISING_EDGE(CLK) THEN
	IF(RST = '1') THEN
		QTMP			<=	CONV_STD_LOGIC_VECTOR(2,WIDTH);
		ENDCOUNT	<=	'0';
	ELSIF(QTMP	=	CONV_STD_LOGIC_VECTOR(EDGECHK,WIDTH)) THEN
		QTMP			<=	QTMP + '1';
		ENDCOUNT	<=	'1';
	ELSE
		QTMP			<=	QTMP + '1';
		ENDCOUNT	<=	'0';
	END IF;
END IF;
END PROCESS;

PROCESS(CLK, ENDCOUNT, LRCLK)
BEGIN

IF RISING_EDGE(CLK) THEN
	IF(ENDCOUNT	=	'1') THEN
		IF(LRCLK	=	'1') THEN
			SR48K	<=	'1';
			SR44K	<=	'0';
		ELSE
			SR48K	<=	'0';
			SR44K	<=	'1';
		END IF;
	ELSE
	END IF;
END IF;
END PROCESS;

	COUNT	<=	QTMP;
	ECNT	<=	ENDCOUNT;

END Behave;
