--------------------------------------------------------------------------------
-- Copyright (c) 1995-2012 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 14.1
--  \   \         Application : sch2hdl
--  /   /         Filename : ERROR_STATUS.vhf
-- /___/   /\     Timestamp : 08/04/2018 13:57:32
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: sch2hdl -intstyle ise -family spartan3a -flat -suppress -vhdl C:/XilinxDesigns/KDL_V34_TestPoints/ERROR_STATUS.vhf -w C:/XilinxDesigns/KDL_V34_TestPoints/ERROR_STATUS.sch
--Design Name: ERROR_STATUS
--Device: spartan3a
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--
----- CELL OR8_HXILINX_ERROR_STATUS -----
  
library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity OR8_HXILINX_ERROR_STATUS is
  
port(
    O  : out std_logic;

    I0  : in std_logic;
    I1  : in std_logic;
    I2  : in std_logic;
    I3  : in std_logic;
    I4  : in std_logic;
    I5  : in std_logic;
    I6  : in std_logic;
    I7  : in std_logic
  );
end OR8_HXILINX_ERROR_STATUS;

architecture OR8_HXILINX_ERROR_STATUS_V of OR8_HXILINX_ERROR_STATUS is
begin
  O <= (I0 or I1 or I2 or I3 or I4 or I5 or I6 or I7);
end OR8_HXILINX_ERROR_STATUS_V;

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity ERROR_STATUS is
   port ( CLK            : in    std_logic; 
          ERR_INPUT      : in    std_logic_vector (7 downto 0); 
          ERR_STATUS_RD  : in    std_logic; 
          ERR_STATUS_SEL : in    std_logic; 
          RST            : in    std_logic; 
          ERROR_STATUS   : out   std_logic_vector (7 downto 0); 
          ERR_INTn       : out   std_logic);
end ERROR_STATUS;

architecture BEHAVIORAL of ERROR_STATUS is
   attribute BOX_TYPE   : string ;
   attribute HU_SET     : string ;
   signal ASSERT_INT     : std_logic;
   signal CLR_ERR        : std_logic;
   signal CLR_ERR_INT    : std_logic;
   signal CLR_INT        : std_logic;
   signal ERR_FB         : std_logic_vector (7 downto 0);
   signal ERR_STATUS_ENA : std_logic;
   signal PS_INTn        : std_logic;
   signal ERR_INTn_DUMMY : std_logic;
   component FD
      generic( INIT : bit :=  '0');
      port ( C : in    std_logic; 
             D : in    std_logic; 
             Q : out   std_logic);
   end component;
   attribute BOX_TYPE of FD : component is "BLACK_BOX";
   
   component FDCP
      generic( INIT : bit :=  '0');
      port ( C   : in    std_logic; 
             CLR : in    std_logic; 
             D   : in    std_logic; 
             PRE : in    std_logic; 
             Q   : out   std_logic);
   end component;
   attribute BOX_TYPE of FDCP : component is "BLACK_BOX";
   
   component FDE
      generic( INIT : bit :=  '0');
      port ( C  : in    std_logic; 
             CE : in    std_logic; 
             D  : in    std_logic; 
             Q  : out   std_logic);
   end component;
   attribute BOX_TYPE of FDE : component is "BLACK_BOX";
   
   component INV
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of INV : component is "BLACK_BOX";
   
   component OR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2 : component is "BLACK_BOX";
   
   component OR8_HXILINX_ERROR_STATUS
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             I3 : in    std_logic; 
             I4 : in    std_logic; 
             I5 : in    std_logic; 
             I6 : in    std_logic; 
             I7 : in    std_logic; 
             O  : out   std_logic);
   end component;
   
   component BUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of BUF : component is "BLACK_BOX";
   
   attribute HU_SET of XLXI_101 : label is "XLXI_101_2";
begin
   ERR_INTn <= ERR_INTn_DUMMY;
   CLR_INT_DLY_FD : FD
      port map (C=>CLK,
                D=>CLR_ERR_INT,
                Q=>CLR_INT);
   
   ERRINT_FD : FDCP
      port map (C=>CLK,
                CLR=>ASSERT_INT,
                D=>ERR_INTn_DUMMY,
                PRE=>PS_INTn,
                Q=>ERR_INTn_DUMMY);
   
   ERRSTAT_HLD_FD_0 : FDE
      port map (C=>CLK,
                CE=>ERR_STATUS_ENA,
                D=>ERR_FB(0),
                Q=>ERROR_STATUS(0));
   
   ERRSTAT_HLD_FD_1 : FDE
      port map (C=>CLK,
                CE=>ERR_STATUS_ENA,
                D=>ERR_FB(1),
                Q=>ERROR_STATUS(1));
   
   ERRSTAT_HLD_FD_2 : FDE
      port map (C=>CLK,
                CE=>ERR_STATUS_ENA,
                D=>ERR_FB(2),
                Q=>ERROR_STATUS(2));
   
   ERRSTAT_HLD_FD_3 : FDE
      port map (C=>CLK,
                CE=>ERR_STATUS_ENA,
                D=>ERR_FB(3),
                Q=>ERROR_STATUS(3));
   
   ERRSTAT_HLD_FD_4 : FDE
      port map (C=>CLK,
                CE=>ERR_STATUS_ENA,
                D=>ERR_FB(4),
                Q=>ERROR_STATUS(4));
   
   ERRSTAT_HLD_FD_5 : FDE
      port map (C=>CLK,
                CE=>ERR_STATUS_ENA,
                D=>ERR_FB(5),
                Q=>ERROR_STATUS(5));
   
   ERRSTAT_HLD_FD_6 : FDE
      port map (C=>CLK,
                CE=>ERR_STATUS_ENA,
                D=>ERR_FB(6),
                Q=>ERROR_STATUS(6));
   
   ERRSTAT_HLD_FD_7 : FDE
      port map (C=>CLK,
                CE=>ERR_STATUS_ENA,
                D=>ERR_FB(7),
                Q=>ERROR_STATUS(7));
   
   ERR_FD_0 : FDCP
      port map (C=>CLK,
                CLR=>CLR_ERR_INT,
                D=>ERR_FB(0),
                PRE=>ERR_INPUT(0),
                Q=>ERR_FB(0));
   
   ERR_FD_1 : FDCP
      port map (C=>CLK,
                CLR=>CLR_ERR_INT,
                D=>ERR_FB(1),
                PRE=>ERR_INPUT(1),
                Q=>ERR_FB(1));
   
   ERR_FD_2 : FDCP
      port map (C=>CLK,
                CLR=>CLR_ERR_INT,
                D=>ERR_FB(2),
                PRE=>ERR_INPUT(2),
                Q=>ERR_FB(2));
   
   ERR_FD_3 : FDCP
      port map (C=>CLK,
                CLR=>CLR_ERR_INT,
                D=>ERR_FB(3),
                PRE=>ERR_INPUT(3),
                Q=>ERR_FB(3));
   
   ERR_FD_4 : FDCP
      port map (C=>CLK,
                CLR=>CLR_ERR_INT,
                D=>ERR_FB(4),
                PRE=>ERR_INPUT(4),
                Q=>ERR_FB(4));
   
   ERR_FD_5 : FDCP
      port map (C=>CLK,
                CLR=>CLR_ERR_INT,
                D=>ERR_FB(5),
                PRE=>ERR_INPUT(5),
                Q=>ERR_FB(5));
   
   ERR_FD_6 : FDCP
      port map (C=>CLK,
                CLR=>CLR_ERR_INT,
                D=>ERR_FB(6),
                PRE=>ERR_INPUT(6),
                Q=>ERR_FB(6));
   
   ERR_FD_7 : FDCP
      port map (C=>CLK,
                CLR=>CLR_ERR_INT,
                D=>ERR_FB(7),
                PRE=>ERR_INPUT(7),
                Q=>ERR_FB(7));
   
   XLXI_76 : INV
      port map (I=>ERR_STATUS_SEL,
                O=>ERR_STATUS_ENA);
   
   XLXI_97 : OR2
      port map (I0=>CLR_ERR,
                I1=>RST,
                O=>CLR_ERR_INT);
   
   XLXI_101 : OR8_HXILINX_ERROR_STATUS
      port map (I0=>ERR_FB(0),
                I1=>ERR_FB(1),
                I2=>ERR_FB(2),
                I3=>ERR_FB(3),
                I4=>ERR_FB(4),
                I5=>ERR_FB(5),
                I6=>ERR_FB(6),
                I7=>ERR_FB(7),
                O=>ASSERT_INT);
   
   XLXI_106 : OR2
      port map (I0=>CLR_INT,
                I1=>RST,
                O=>PS_INTn);
   
   XLXI_107 : BUF
      port map (I=>ERR_STATUS_RD,
                O=>CLR_ERR);
   
end BEHAVIORAL;


