--------------------------------------------------------------------------------
-- Copyright (c) 1995-2012 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 14.1
--  \   \         Application : sch2hdl
--  /   /         Filename : FallingEdgeDetect.vhf
-- /___/   /\     Timestamp : 08/04/2018 13:57:31
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: sch2hdl -intstyle ise -family spartan3a -flat -suppress -vhdl C:/XilinxDesigns/KDL_V34_TestPoints/FallingEdgeDetect.vhf -w C:/XilinxDesigns/KDL_V34_TestPoints/FallingEdgeDetect.sch
--Design Name: FallingEdgeDetect
--Device: spartan3a
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity FallingEdgeDetect is
   port ( CLK       : in    std_logic; 
          EDGEn     : in    std_logic; 
          ENA       : in    std_logic; 
          RST       : in    std_logic; 
          DET_PULSE : out   std_logic);
end FallingEdgeDetect;

architecture BEHAVIORAL of FallingEdgeDetect is
   attribute BOX_TYPE   : string ;
   signal Q         : std_logic_vector (2 downto 0);
   signal XLXN_1    : std_logic;
   component SP3A_SipoAClr3_Lsb
      port ( SDIN : in    std_logic; 
             Q    : out   std_logic_vector (2 downto 0); 
             CLK  : in    std_logic; 
             ACLR : in    std_logic);
   end component;
   
   component NAND2B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of NAND2B1 : component is "BLACK_BOX";
   
   component AND2B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2B1 : component is "BLACK_BOX";
   
begin
   EDGEDET_SIPO : SP3A_SipoAClr3_Lsb
      port map (ACLR=>RST,
                CLK=>CLK,
                SDIN=>XLXN_1,
                Q(2 downto 0)=>Q(2 downto 0));
   
   XLXI_5 : NAND2B1
      port map (I0=>EDGEn,
                I1=>ENA,
                O=>XLXN_1);
   
   XLXI_6 : AND2B1
      port map (I0=>Q(0),
                I1=>Q(1),
                O=>DET_PULSE);
   
end BEHAVIORAL;


