----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    06:14:57 07/15/2009 
-- Design Name: 
-- Module Name:    Audio32_SIPO - BEHAVE 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY Audio32_SIPO IS
	PORT(	S_IN		:IN	STD_LOGIC;
				CLK		:IN	STD_LOGIC;
				RSYNC	:IN	STD_LOGIC;
				RST		:IN	STD_LOGIC;
				COUNT	:OUT	STD_LOGIC_VECTOR(4 downto 0);
				HOLD	:OUT	STD_LOGIC;
				P_OUT	:OUT	STD_LOGIC_VECTOR (31 downto 0)
		);
END Audio32_SIPO;

ARCHITECTURE BEHAVE of Audio32_SIPO IS

SIGNAL	TEMP:	STD_LOGIC_VECTOR(31 downto 0);	-- SHIFT REG INPUT
SIGNAL	CNTR:	STD_LOGIC_VECTOR(4 downto 0);		-- COUNTER FOR LOAD/HOLD

BEGIN

PROCESS(CLK,RST,S_IN)
	BEGIN
	IF RISING_EDGE (CLK) THEN
		IF (RST = '1') THEN
			TEMP	<= (OTHERS => '0');
		ELSE
			TEMP <= TEMP(30 downto 0)& S_IN;
		END IF;
	END IF;
END PROCESS;

PROCESS(CLK,RSYNC,TEMP)
	BEGIN
	IF RISING_EDGE (CLK) THEN
		IF (RSYNC = '1') THEN
			CNTR	<= (OTHERS => '1');
				IF (CNTR = "11111") THEN -- MAY NEED TO SET TO "11111"
					HOLD	<= '1';
				ELSE
					HOLD	<= '0';
				END IF;
		ELSE
			HOLD	<= '0';
			CNTR	<= CNTR + '1';
				IF (CNTR = "11111") THEN -- MAY NEED TO SET TO "11111"
					HOLD	<= '1';
				ELSIF(CNTR = "00000") THEN
					P_OUT	<= TEMP;
					HOLD	<= '0';
				ELSE
				END IF;
		END IF;
	END IF;
END PROCESS;

COUNT	<= CNTR;

END BEHAVE;
