--------------------------------------------------------------------------------
-- Copyright (c) 1995-2012 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 14.1
--  \   \         Application : sch2hdl
--  /   /         Filename : KDL.vhf
-- /___/   /\     Timestamp : 08/15/2018 15:59:53
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: sch2hdl -intstyle ise -family spartan3a -flat -suppress -vhdl C:/XilinxDesigns/KDL_V38_SandBox/KDL.vhf -w C:/XilinxDesigns/KDL_V38_SandBox/KDL.sch
--Design Name: KDL
--Device: spartan3a
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--
----- CELL OR8_HXILINX_KDL -----
  
library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity OR8_HXILINX_KDL is
  
port(
    O  : out std_logic;

    I0  : in std_logic;
    I1  : in std_logic;
    I2  : in std_logic;
    I3  : in std_logic;
    I4  : in std_logic;
    I5  : in std_logic;
    I6  : in std_logic;
    I7  : in std_logic
  );
end OR8_HXILINX_KDL;

architecture OR8_HXILINX_KDL_V of OR8_HXILINX_KDL is
begin
  O <= (I0 or I1 or I2 or I3 or I4 or I5 or I6 or I7);
end OR8_HXILINX_KDL_V;
----- CELL M2_1_HXILINX_KDL -----
  
library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity M2_1_HXILINX_KDL is
  
port(
    O   : out std_logic;

    D0  : in std_logic;
    D1  : in std_logic;
    S0  : in std_logic
  );
end M2_1_HXILINX_KDL;

architecture M2_1_HXILINX_KDL_V of M2_1_HXILINX_KDL is
begin
  process (D0, D1, S0)
  begin
    case S0 is
    when '0' => O <= D0;
    when '1' => O <= D1;
    when others => NULL;
    end case;
    end process; 
end M2_1_HXILINX_KDL_V;

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity DeadClock_MUSER_KDL is
   port ( BP_MCLK    : in    std_logic; 
          D_MCLK     : in    std_logic; 
          POR        : in    std_logic; 
          RESET      : in    std_logic; 
          BPCLK_CNT  : out   std_logic_vector (23 downto 0); 
          DEAD_CLOCK : out   std_logic);
end DeadClock_MUSER_KDL;

architecture BEHAVIORAL of DeadClock_MUSER_KDL is
   attribute BOX_TYPE   : string ;
   signal XLXN_4          : std_logic;
   signal BPCLK_CNT_DUMMY : std_logic_vector (23 downto 0);
   component BPCLK_COUNTER
      port ( CLK_BP  : in    std_logic; 
             RST     : in    std_logic; 
             BPCOUNT : out   std_logic_vector (23 downto 0));
   end component;
   
   component BPCLK_MONITOR
      port ( CLK_D    : in    std_logic; 
             RST      : in    std_logic; 
             BPCOUNT  : in    std_logic_vector (23 downto 0); 
             INACTIVE : out   std_logic);
   end component;
   
   component OR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2 : component is "BLACK_BOX";
   
begin
   BPCLK_CNT(23 downto 0) <= BPCLK_CNT_DUMMY(23 downto 0);
   BPCLK_COUNT : BPCLK_COUNTER
      port map (CLK_BP=>BP_MCLK,
                RST=>RESET,
                BPCOUNT(23 downto 0)=>BPCLK_CNT_DUMMY(23 downto 0));
   
   BPCLK_MON : BPCLK_MONITOR
      port map (BPCOUNT(23 downto 0)=>BPCLK_CNT_DUMMY(23 downto 0),
                CLK_D=>D_MCLK,
                RST=>XLXN_4,
                INACTIVE=>DEAD_CLOCK);
   
   XLXI_12 : OR2
      port map (I0=>POR,
                I1=>RESET,
                O=>XLXN_4);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity BP_SCLKFX_ALIGN_MUSER_KDL is
   port ( BPLRCLK           : in    std_logic; 
          BPMCLK            : in    std_logic; 
          BPMCLK_DCM_LOCKED : in    std_logic; 
          BPMCLK_FB         : in    std_logic; 
          RST               : in    std_logic; 
          BPSCLKGEN_LOCK    : out   std_logic; 
          CLKGEN_DLRCLK     : out   std_logic; 
          CLKGEN_DSCLK      : out   std_logic; 
          SCLKGEN_FB        : out   std_logic; 
          SCLKGEN_3M        : out   std_logic; 
          SCLKGEN_180       : out   std_logic);
end BP_SCLKFX_ALIGN_MUSER_KDL;

architecture BEHAVIORAL of BP_SCLKFX_ALIGN_MUSER_KDL is
   attribute CLK_FEEDBACK          : string ;
   attribute CLKDV_DIVIDE          : string ;
   attribute CLKFX_DIVIDE          : string ;
   attribute CLKIN_PERIOD          : string ;
   attribute CLKFX_MULTIPLY        : string ;
   attribute CLKIN_DIVIDE_BY_2     : string ;
   attribute CLKOUT_PHASE_SHIFT    : string ;
   attribute DESKEW_ADJUST         : string ;
   attribute DFS_FREQUENCY_MODE    : string ;
   attribute DLL_FREQUENCY_MODE    : string ;
   attribute DSS_MODE              : string ;
   attribute DUTY_CYCLE_CORRECTION : string ;
   attribute PHASE_SHIFT           : string ;
   attribute STARTUP_WAIT          : string ;
   attribute FACTORY_JF            : string ;
   attribute BOX_TYPE              : string ;
   signal BPMCLK_LOCKED     : std_logic;
   signal CLKGEN            : std_logic_vector (9 downto 0);
   signal LREDGE_ALIGN      : std_logic;
   signal SCLKGEN_CLKIN     : std_logic;
   signal SCLKGEN_RESYNC    : std_logic;
   signal XLXN_421          : std_logic;
   signal XLXN_422          : std_logic;
   signal XLXN_429          : std_logic;
   signal XLXN_430          : std_logic;
   signal XLXN_461          : std_logic;
   signal XLXN_462          : std_logic;
   signal XLXN_570          : std_logic;
   signal SCLKGEN_FB_DUMMY  : std_logic;
   component DCM_SP
      -- synopsys translate_off
      generic( CLK_FEEDBACK : string :=  "1X";
               CLKDV_DIVIDE : real :=  2.0;
               CLKFX_DIVIDE : integer :=  1;
               CLKIN_PERIOD : real :=  10.0;
               CLKFX_MULTIPLY : integer :=  4;
               CLKIN_DIVIDE_BY_2 : boolean :=  FALSE;
               CLKOUT_PHASE_SHIFT : string :=  "NONE";
               DESKEW_ADJUST : string :=  "SYSTEM_SYNCHRONOUS";
               DFS_FREQUENCY_MODE : string :=  "LOW";
               DLL_FREQUENCY_MODE : string :=  "LOW";
               DSS_MODE : string :=  "NONE";
               DUTY_CYCLE_CORRECTION : boolean :=  TRUE;
               PHASE_SHIFT : integer :=  0;
               STARTUP_WAIT : boolean :=  FALSE;
               FACTORY_JF : bit_vector :=  x"C080");
      -- synopsys translate_on
      port ( CLKFB    : in    std_logic; 
             CLKIN    : in    std_logic; 
             DSSEN    : in    std_logic; 
             PSCLK    : in    std_logic; 
             PSEN     : in    std_logic; 
             PSINCDEC : in    std_logic; 
             RST      : in    std_logic; 
             CLK0     : out   std_logic; 
             CLK180   : out   std_logic; 
             CLK270   : out   std_logic; 
             CLK2X    : out   std_logic; 
             CLK2X180 : out   std_logic; 
             CLK90    : out   std_logic; 
             CLKDV    : out   std_logic; 
             CLKFX    : out   std_logic; 
             CLKFX180 : out   std_logic; 
             LOCKED   : out   std_logic; 
             PSDONE   : out   std_logic; 
             STATUS   : out   std_logic_vector (7 downto 0));
   end component;
   attribute CLK_FEEDBACK of DCM_SP : component is "1X";
   attribute CLKDV_DIVIDE of DCM_SP : component is "2.0";
   attribute CLKFX_DIVIDE of DCM_SP : component is "1";
   attribute CLKIN_PERIOD of DCM_SP : component is "10.0";
   attribute CLKFX_MULTIPLY of DCM_SP : component is "4";
   attribute CLKIN_DIVIDE_BY_2 of DCM_SP : component is "FALSE";
   attribute CLKOUT_PHASE_SHIFT of DCM_SP : component is "NONE";
   attribute DESKEW_ADJUST of DCM_SP : component is "SYSTEM_SYNCHRONOUS";
   attribute DFS_FREQUENCY_MODE of DCM_SP : component is "LOW";
   attribute DLL_FREQUENCY_MODE of DCM_SP : component is "LOW";
   attribute DSS_MODE of DCM_SP : component is "NONE";
   attribute DUTY_CYCLE_CORRECTION of DCM_SP : component is "TRUE";
   attribute PHASE_SHIFT of DCM_SP : component is "0";
   attribute STARTUP_WAIT of DCM_SP : component is "FALSE";
   attribute FACTORY_JF of DCM_SP : component is "C080";
   attribute BOX_TYPE of DCM_SP : component is "BLACK_BOX";
   
   component LRCLK_EdgeCount_1024
      port ( clk       : in    std_logic; 
             sclr      : in    std_logic; 
             q         : out   std_logic_vector (9 downto 0); 
             q_thresh0 : out   std_logic);
   end component;
   
   component Falling_Edge
      port ( EDGE_DETECT : out   std_logic; 
             CLK         : in    std_logic; 
             F_EDGE      : in    std_logic);
   end component;
   
   component TCNT8
      port ( CLK  : in    std_logic; 
             RST  : in    std_logic; 
             TCNT : out   std_logic);
   end component;
   
   component LRCLK_EdgeCount_1024_3FD
      port ( clk       : in    std_logic; 
             sclr      : in    std_logic; 
             q         : out   std_logic_vector (9 downto 0); 
             q_thresh0 : out   std_logic);
   end component;
   
   component BUFG
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of BUFG : component is "BLACK_BOX";
   
   component GND
      port ( G : out   std_logic);
   end component;
   attribute BOX_TYPE of GND : component is "BLACK_BOX";
   
   component OR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2 : component is "BLACK_BOX";
   
   component FDP
      generic( INIT : bit :=  '1');
      port ( C   : in    std_logic; 
             D   : in    std_logic; 
             PRE : in    std_logic; 
             Q   : out   std_logic);
   end component;
   attribute BOX_TYPE of FDP : component is "BLACK_BOX";
   
   component BUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of BUF : component is "BLACK_BOX";
   
   component INV
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of INV : component is "BLACK_BOX";
   
   attribute CLKOUT_PHASE_SHIFT of BPSCLK_GEN_DCM : label is "FIXED";
   attribute CLKIN_PERIOD of BPSCLK_GEN_DCM : label is "160.0";
   attribute PHASE_SHIFT of BPSCLK_GEN_DCM : label is "122";
begin
   SCLKGEN_FB <= SCLKGEN_FB_DUMMY;
   BPSCLK_GEN_DCM : DCM_SP
   -- synopsys translate_off
   generic map( CLKOUT_PHASE_SHIFT => "FIXED",
            CLKIN_PERIOD => 160.0,
            PHASE_SHIFT => 122)
   -- synopsys translate_on
      port map (CLKFB=>SCLKGEN_FB_DUMMY,
                CLKIN=>SCLKGEN_CLKIN,
                DSSEN=>XLXN_429,
                PSCLK=>XLXN_429,
                PSEN=>XLXN_429,
                PSINCDEC=>XLXN_429,
                RST=>XLXN_430,
                CLKDV=>XLXN_570,
                CLKFX=>open,
                CLKFX180=>open,
                CLK0=>XLXN_421,
                CLK2X=>open,
                CLK2X180=>open,
                CLK90=>open,
                CLK180=>XLXN_422,
                CLK270=>open,
                LOCKED=>BPSCLKGEN_LOCK,
                PSDONE=>open,
                STATUS=>open);
   
   BP_SCLK_GENERATOR : LRCLK_EdgeCount_1024
      port map (clk=>BPMCLK_FB,
                sclr=>SCLKGEN_RESYNC,
                q(9 downto 0)=>CLKGEN(9 downto 0),
                q_thresh0=>open);
   
   LRCLK_FALLING_EDGE : Falling_Edge
      port map (CLK=>BPMCLK_FB,
                F_EDGE=>BPLRCLK,
                EDGE_DETECT=>LREDGE_ALIGN);
   
   SCLKGEN_DCMRST_TCNT : TCNT8
      port map (CLK=>BPLRCLK,
                RST=>BPMCLK_LOCKED,
                TCNT=>XLXN_462);
   
   SCLKGEN_RESYNCER : LRCLK_EdgeCount_1024_3FD
      port map (clk=>BPMCLK_FB,
                sclr=>LREDGE_ALIGN,
                q=>open,
                q_thresh0=>SCLKGEN_RESYNC);
   
   XLXI_394 : BUFG
      port map (I=>XLXN_421,
                O=>SCLKGEN_FB_DUMMY);
   
   XLXI_395 : BUFG
      port map (I=>XLXN_422,
                O=>SCLKGEN_180);
   
   XLXI_396 : BUFG
      port map (I=>CLKGEN(2),
                O=>SCLKGEN_CLKIN);
   
   XLXI_399 : GND
      port map (G=>XLXN_429);
   
   XLXI_420 : OR2
      port map (I0=>BPMCLK_LOCKED,
                I1=>XLXN_462,
                O=>XLXN_461);
   
   XLXI_421 : FDP
      port map (C=>BPMCLK,
                D=>XLXN_461,
                PRE=>RST,
                Q=>XLXN_430);
   
   XLXI_422 : BUF
      port map (I=>CLKGEN(9),
                O=>CLKGEN_DLRCLK);
   
   XLXI_423 : BUF
      port map (I=>CLKGEN(0),
                O=>CLKGEN_DSCLK);
   
   XLXI_424 : INV
      port map (I=>BPMCLK_DCM_LOCKED,
                O=>BPMCLK_LOCKED);
   
   XLXI_425 : BUFG
      port map (I=>XLXN_570,
                O=>SCLKGEN_3M);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity BNK_SWAP_DET_MUSER_KDL is
   port ( BANK_MSB        : in    std_logic; 
          CLK             : in    std_logic; 
          BANK_SWAP_PULSE : out   std_logic);
end BNK_SWAP_DET_MUSER_KDL;

architecture BEHAVIORAL of BNK_SWAP_DET_MUSER_KDL is
   attribute BOX_TYPE   : string ;
   signal FE_Q            : std_logic_vector (2 downto 0);
   signal RE_Q            : std_logic_vector (2 downto 0);
   signal XLXN_5          : std_logic;
   signal XLXN_6          : std_logic;
   component SP3A_Sipo3_Lsb
      port ( SDIN : in    std_logic; 
             Q    : out   std_logic_vector (2 downto 0); 
             CLK  : in    std_logic);
   end component;
   
   component AND2B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2B1 : component is "BLACK_BOX";
   
   component OR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2 : component is "BLACK_BOX";
   
begin
   FALL_EDGE_SIPO : SP3A_Sipo3_Lsb
      port map (CLK=>CLK,
                SDIN=>BANK_MSB,
                Q(2 downto 0)=>FE_Q(2 downto 0));
   
   RISE_EDGE_SIPO : SP3A_Sipo3_Lsb
      port map (CLK=>CLK,
                SDIN=>BANK_MSB,
                Q(2 downto 0)=>RE_Q(2 downto 0));
   
   XLXI_4 : AND2B1
      port map (I0=>RE_Q(2),
                I1=>RE_Q(1),
                O=>XLXN_6);
   
   XLXI_5 : AND2B1
      port map (I0=>FE_Q(1),
                I1=>FE_Q(2),
                O=>XLXN_5);
   
   XLXI_25 : OR2
      port map (I0=>XLXN_6,
                I1=>XLXN_5,
                O=>BANK_SWAP_PULSE);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity XFRMEM32_MUSER_KDL is
   port ( CLK           : in    std_logic; 
          LR_CLK        : in    std_logic; 
          RST           : in    std_logic; 
          RSYNC         : in    std_logic; 
          XFRMEM_DIN    : in    std_logic_vector (31 downto 0); 
          XFRMEM_WE     : in    std_logic; 
          XFRMEM_WRADDR : in    std_logic_vector (4 downto 0); 
          BS_DETECT     : out   std_logic; 
          RSYNC_2LR     : out   std_logic; 
          SDOUT1        : out   std_logic; 
          XFRHLD_EN     : out   std_logic; 
          XFRMEM_RDADDR : out   std_logic_vector (5 downto 0); 
          XFRMEM_WR     : out   std_logic_vector (5 downto 0); 
          XFRRDCNT_EN   : out   std_logic; 
          XFR_PISO_LD   : out   std_logic);
end XFRMEM32_MUSER_KDL;

architecture BEHAVIORAL of XFRMEM32_MUSER_KDL is
   attribute BOX_TYPE   : string ;
   signal DSP_ZERO          : std_logic_vector (7 downto 0);
   signal INIT              : std_logic;
   signal RSYNC_2LR_ENABLE  : std_logic;
   signal WR_BANK           : std_logic;
   signal XFRMEM_DHOLD_A    : std_logic_vector (31 downto 0);
   signal XFRMEM_DOUT       : std_logic_vector (31 downto 0);
   signal XFRMEM_RD         : std_logic_vector (5 downto 0);
   signal XLXN_14           : std_logic;
   signal XLXN_99           : std_logic;
   signal RSYNC_2LR_DUMMY   : std_logic;
   signal XFRMEM_WR_DUMMY   : std_logic_vector (5 downto 0);
   signal XFRHLD_EN_DUMMY   : std_logic;
   signal XFR_PISO_LD_DUMMY : std_logic;
   signal XFRRDCNT_EN_DUMMY : std_logic;
   component BNK_SWAP_DET_MUSER_KDL
      port ( BANK_SWAP_PULSE : out   std_logic; 
             CLK             : in    std_logic; 
             BANK_MSB        : in    std_logic);
   end component;
   
   component SP3A_Piso32_Lsb
      port ( D      : in    std_logic_vector (31 downto 0); 
             P_LOAD : in    std_logic; 
             CLK    : in    std_logic; 
             SDOUT  : out   std_logic);
   end component;
   
   component SP3A_DpRAM_64x32
      port ( addra : in    std_logic_vector (5 downto 0); 
             dina  : in    std_logic_vector (31 downto 0); 
             wea   : in    std_logic_vector (0 downto 0); 
             clka  : in    std_logic; 
             addrb : in    std_logic_vector (5 downto 0); 
             doutb : out   std_logic_vector (31 downto 0); 
             enb   : in    std_logic; 
             clkb  : in    std_logic);
   end component;
   
   component BUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of BUF : component is "BLACK_BOX";
   
   component SP3A_RegEn32
      port ( D   : in    std_logic_vector (31 downto 0); 
             CE  : in    std_logic; 
             CLK : in    std_logic; 
             Q   : out   std_logic_vector (31 downto 0));
   end component;
   
   component SP3A_CntPS15_5
      port ( CLK       : in    std_logic; 
             SINIT     : in    std_logic; 
             THRESH0   : out   std_logic; 
             Q_THRESH0 : out   std_logic; 
             Q         : out   std_logic_vector (4 downto 0));
   end component;
   
   component SP3A_CntSClrEn6
      port ( CE        : in    std_logic; 
             CLK       : in    std_logic; 
             SCLR      : in    std_logic; 
             THRESH0   : out   std_logic; 
             Q_THRESH0 : out   std_logic; 
             Q         : out   std_logic_vector (5 downto 0));
   end component;
   
   component SP3A_CntSClr5
      port ( CLK       : in    std_logic; 
             SCLR      : in    std_logic; 
             THRESH0   : out   std_logic; 
             Q_THRESH0 : out   std_logic; 
             Q         : out   std_logic_vector (4 downto 0));
   end component;
   
   component SP3A_CntSClrThrErly5
      port ( CLK       : in    std_logic; 
             SCLR      : in    std_logic; 
             THRESH0   : out   std_logic; 
             Q_THRESH0 : out   std_logic; 
             Q         : out   std_logic_vector (4 downto 0));
   end component;
   
   component VCC
      port ( P : out   std_logic);
   end component;
   attribute BOX_TYPE of VCC : component is "BLACK_BOX";
   
   component OR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2 : component is "BLACK_BOX";
   
   component INV
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of INV : component is "BLACK_BOX";
   
   component FD
      generic( INIT : bit :=  '0');
      port ( C : in    std_logic; 
             D : in    std_logic; 
             Q : out   std_logic);
   end component;
   attribute BOX_TYPE of FD : component is "BLACK_BOX";
   
   component AND2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2 : component is "BLACK_BOX";
   
   component GND
      port ( G : out   std_logic);
   end component;
   attribute BOX_TYPE of GND : component is "BLACK_BOX";
   
begin
   RSYNC_2LR <= RSYNC_2LR_DUMMY;
   XFRHLD_EN <= XFRHLD_EN_DUMMY;
   XFRMEM_WR(5 downto 0) <= XFRMEM_WR_DUMMY(5 downto 0);
   XFRRDCNT_EN <= XFRRDCNT_EN_DUMMY;
   XFR_PISO_LD <= XFR_PISO_LD_DUMMY;
   BSDETECT : BNK_SWAP_DET_MUSER_KDL
      port map (BANK_MSB=>WR_BANK,
                CLK=>CLK,
                BANK_SWAP_PULSE=>BS_DETECT);
   
   CH_XFERPISO_LSB : SP3A_Piso32_Lsb
      port map (CLK=>CLK,
                D(31 downto 0)=>XFRMEM_DHOLD_A(31 downto 0),
                P_LOAD=>XFR_PISO_LD_DUMMY,
                SDOUT=>SDOUT1);
   
   LVDS_TO_DSP_XFERMEM : SP3A_DpRAM_64x32
      port map (addra(5 downto 0)=>XFRMEM_WR_DUMMY(5 downto 0),
                addrb(5 downto 0)=>XFRMEM_RD(5 downto 0),
                clka=>CLK,
                clkb=>CLK,
                dina(31 downto 0)=>XFRMEM_DIN(31 downto 0),
                enb=>XLXN_14,
                wea(0)=>XFRMEM_WE,
                doutb(31 downto 0)=>XFRMEM_DOUT(31 downto 0));
   
   RDADDRBUF_0 : BUF
      port map (I=>XFRMEM_RD(0),
                O=>XFRMEM_RDADDR(0));
   
   RDADDRBUF_1 : BUF
      port map (I=>XFRMEM_RD(1),
                O=>XFRMEM_RDADDR(1));
   
   RDADDRBUF_2 : BUF
      port map (I=>XFRMEM_RD(2),
                O=>XFRMEM_RDADDR(2));
   
   RDADDRBUF_3 : BUF
      port map (I=>XFRMEM_RD(3),
                O=>XFRMEM_RDADDR(3));
   
   RDADDRBUF_4 : BUF
      port map (I=>XFRMEM_RD(4),
                O=>XFRMEM_RDADDR(4));
   
   RDADDRBUF_5 : BUF
      port map (I=>XFRMEM_RD(5),
                O=>XFRMEM_RDADDR(5));
   
   WRADDRBUF_0 : BUF
      port map (I=>XFRMEM_WRADDR(0),
                O=>XFRMEM_WR_DUMMY(0));
   
   WRADDRBUF_1 : BUF
      port map (I=>XFRMEM_WRADDR(1),
                O=>XFRMEM_WR_DUMMY(1));
   
   WRADDRBUF_2 : BUF
      port map (I=>XFRMEM_WRADDR(2),
                O=>XFRMEM_WR_DUMMY(2));
   
   WRADDRBUF_3 : BUF
      port map (I=>XFRMEM_WRADDR(3),
                O=>XFRMEM_WR_DUMMY(3));
   
   WRADDRBUF_4 : BUF
      port map (I=>XFRMEM_WRADDR(4),
                O=>XFRMEM_WR_DUMMY(4));
   
   WRADDRBUF_5 : BUF
      port map (I=>WR_BANK,
                O=>XFRMEM_WR_DUMMY(5));
   
   XFERHOLD_REG : SP3A_RegEn32
      port map (CE=>XFRHLD_EN_DUMMY,
                CLK=>CLK,
                D(31 downto 28)=>DSP_ZERO(7 downto 4),
                D(27 downto 4)=>XFRMEM_DOUT(31 downto 8),
                D(3 downto 0)=>DSP_ZERO(3 downto 0),
                Q(31 downto 0)=>XFRMEM_DHOLD_A(31 downto 0));
   
   XFERMEM_HOLD : SP3A_CntPS15_5
      port map (CLK=>CLK,
                SINIT=>INIT,
                Q=>open,
                Q_THRESH0=>XFRHLD_EN_DUMMY,
                THRESH0=>open);
   
   XFERMEM_RDCNT : SP3A_CntSClrEn6
      port map (CE=>XFRRDCNT_EN_DUMMY,
                CLK=>CLK,
                SCLR=>INIT,
                Q(5 downto 0)=>XFRMEM_RD(5 downto 0),
                Q_THRESH0=>open,
                THRESH0=>open);
   
   XFERMEM_RDEN : SP3A_CntSClr5
      port map (CLK=>CLK,
                SCLR=>INIT,
                Q=>open,
                Q_THRESH0=>XFRRDCNT_EN_DUMMY,
                THRESH0=>open);
   
   XFERPISO_LOAD : SP3A_CntSClrThrErly5
      port map (CLK=>CLK,
                SCLR=>INIT,
                Q=>open,
                Q_THRESH0=>XFR_PISO_LD_DUMMY,
                THRESH0=>open);
   
   XLXI_7 : VCC
      port map (P=>XLXN_14);
   
   XLXI_10 : OR2
      port map (I0=>RST,
                I1=>RSYNC_2LR_DUMMY,
                O=>INIT);
   
   XLXI_11 : INV
      port map (I=>XFRMEM_RD(5),
                O=>WR_BANK);
   
   XLXI_24 : FD
      port map (C=>LR_CLK,
                D=>RSYNC_2LR_ENABLE,
                Q=>XLXN_99);
   
   XLXI_25 : INV
      port map (I=>XLXN_99,
                O=>RSYNC_2LR_ENABLE);
   
   XLXI_26 : AND2
      port map (I0=>RSYNC,
                I1=>XLXN_99,
                O=>RSYNC_2LR_DUMMY);
   
   ZERODSPGND_0 : GND
      port map (G=>DSP_ZERO(0));
   
   ZERODSPGND_1 : GND
      port map (G=>DSP_ZERO(1));
   
   ZERODSPGND_2 : GND
      port map (G=>DSP_ZERO(2));
   
   ZERODSPGND_3 : GND
      port map (G=>DSP_ZERO(3));
   
   ZERODSPGND_4 : GND
      port map (G=>DSP_ZERO(4));
   
   ZERODSPGND_5 : GND
      port map (G=>DSP_ZERO(5));
   
   ZERODSPGND_6 : GND
      port map (G=>DSP_ZERO(6));
   
   ZERODSPGND_7 : GND
      port map (G=>DSP_ZERO(7));
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity DCM_UNLOCK_RESET_MUSER_KDL is
   port ( DCM_LOCKEDn : in    std_logic; 
          LRCLK       : in    std_logic; 
          RESET       : in    std_logic; 
          DCM_RESET   : out   std_logic);
end DCM_UNLOCK_RESET_MUSER_KDL;

architecture BEHAVIORAL of DCM_UNLOCK_RESET_MUSER_KDL is
   attribute BOX_TYPE   : string ;
   signal DCM_LOCK_DELAY  : std_logic;
   signal XLXN_1          : std_logic;
   signal XLXN_8          : std_logic;
   signal DCM_RESET_DUMMY : std_logic;
   component TCNT8
      port ( CLK  : in    std_logic; 
             RST  : in    std_logic; 
             TCNT : out   std_logic);
   end component;
   
   component OR2B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2B1 : component is "BLACK_BOX";
   
   component NAND2B2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of NAND2B2 : component is "BLACK_BOX";
   
begin
   DCM_RESET <= DCM_RESET_DUMMY;
   ALLOW_DCM_LOCK : TCNT8
      port map (CLK=>LRCLK,
                RST=>DCM_RESET_DUMMY,
                TCNT=>DCM_LOCK_DELAY);
   
   DCM_RST_TIMER : TCNT8
      port map (CLK=>LRCLK,
                RST=>XLXN_1,
                TCNT=>DCM_RESET_DUMMY);
   
   XLXI_8 : OR2B1
      port map (I0=>XLXN_8,
                I1=>RESET,
                O=>XLXN_1);
   
   XLXI_9 : NAND2B2
      port map (I0=>DCM_LOCK_DELAY,
                I1=>DCM_LOCKEDn,
                O=>XLXN_8);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity Dante_RW_Clocking_MUSER_KDL is
   port ( BPCLK_FB          : in    std_logic; 
          BPSCLK_FB         : in    std_logic; 
          BP_CHNDAT         : in    std_logic_vector (31 downto 0); 
          BP_RX_RDEN        : in    std_logic; 
          BP_RX_WREN        : in    std_logic; 
          BP_TX_RDEN        : in    std_logic; 
          BP_TX_WREN        : in    std_logic; 
          DANTE_TDM0_LD     : in    std_logic; 
          DANTE_TDM1_LD     : in    std_logic; 
          DANTE_TDM2_LD     : in    std_logic; 
          DANTE_TDM3_LD     : in    std_logic; 
          D_DCM_RST         : in    std_logic; 
          D_LRCLK           : in    std_logic; 
          D_MCLK            : in    std_logic; 
          D_RXTX_FIFO_RST   : in    std_logic; 
          D_RXWCH_SEL       : in    std_logic_vector (1 downto 0); 
          D_SCLK            : in    std_logic; 
          D_SCLK_SEL        : in    std_logic; 
          D_SDIN_0          : in    std_logic; 
          D_SDIN_1          : in    std_logic; 
          D_SDIN_2          : in    std_logic; 
          D_SDIN_3          : in    std_logic; 
          RST               : in    std_logic; 
          DANTE_BIT_STATE   : out   std_logic_vector (8 downto 0); 
          DANTE_CHNDAT      : out   std_logic_vector (31 downto 0); 
          DANTE_PISO_LD     : out   std_logic; 
          DANTE_PISO_LD_DLY : out   std_logic; 
          DANTE_RD_RESYNC   : out   std_logic; 
          DANTE_RX_STATE    : out   std_logic_vector (8 downto 0); 
          DANTE_TX_STATE    : out   std_logic_vector (8 downto 0); 
          DANTE_WR_RESYNC   : out   std_logic; 
          DCLK_25M          : out   std_logic; 
          DCLK_25M_INV      : out   std_logic; 
          DDCMS_LOCKED      : out   std_logic; 
          DDCM_RST          : out   std_logic; 
          D_CHNL_HOLD       : out   std_logic; 
          D_LRCLK_EDGE      : out   std_logic; 
          D_RXCHNL_COUNT    : out   std_logic_vector (3 downto 0); 
          D_RX_BP_DOUT      : out   std_logic_vector (31 downto 0); 
          D_RX_FAEMPTY      : out   std_logic; 
          D_RX_FAFULL       : out   std_logic; 
          D_RX_FEMPTY       : out   std_logic; 
          D_RX_FFULL        : out   std_logic; 
          D_RX_FIFOCNT      : out   std_logic_vector (9 downto 0); 
          D_RX_OVRFLOW      : out   std_logic; 
          D_RX_RDVALID      : out   std_logic; 
          D_RX_UDRFLOW      : out   std_logic; 
          D_RX_WR_ACK       : out   std_logic; 
          D_SDO_0           : out   std_logic; 
          D_SDO_1           : out   std_logic; 
          D_SDO_2           : out   std_logic; 
          D_SDO_3           : out   std_logic; 
          D_TXCHNL_COUNT    : out   std_logic_vector (3 downto 0); 
          D_TX_BP_DOUT      : out   std_logic_vector (31 downto 0); 
          D_TX_FAEMPTY      : out   std_logic; 
          D_TX_FAFULL       : out   std_logic; 
          D_TX_FEMPTY       : out   std_logic; 
          D_TX_FFULL        : out   std_logic; 
          D_TX_FIFOCNT      : out   std_logic_vector (9 downto 0); 
          D_TX_OVRFLOW      : out   std_logic; 
          D_TX_RDVALID      : out   std_logic; 
          D_TX_UDRFLOW      : out   std_logic; 
          D_TX_WR_ACK       : out   std_logic);
end Dante_RW_Clocking_MUSER_KDL;

architecture BEHAVIORAL of Dante_RW_Clocking_MUSER_KDL is
   attribute CLK_FEEDBACK          : string ;
   attribute CLKDV_DIVIDE          : string ;
   attribute CLKFX_DIVIDE          : string ;
   attribute CLKIN_PERIOD          : string ;
   attribute CLKFX_MULTIPLY        : string ;
   attribute CLKIN_DIVIDE_BY_2     : string ;
   attribute CLKOUT_PHASE_SHIFT    : string ;
   attribute DESKEW_ADJUST         : string ;
   attribute DFS_FREQUENCY_MODE    : string ;
   attribute DLL_FREQUENCY_MODE    : string ;
   attribute DSS_MODE              : string ;
   attribute DUTY_CYCLE_CORRECTION : string ;
   attribute PHASE_SHIFT           : string ;
   attribute STARTUP_WAIT          : string ;
   attribute FACTORY_JF            : string ;
   attribute BOX_TYPE              : string ;
   signal CLKFX                 : std_logic;
   signal CLKFX180              : std_logic;
   signal DMCLK_FB              : std_logic;
   signal DMCLK_LOCKED          : std_logic;
   signal DMCLK_2X              : std_logic;
   signal DMCLK0                : std_logic;
   signal DSCLK_FB              : std_logic;
   signal DSCLK_FX              : std_logic;
   signal DSCLK_FX180           : std_logic;
   signal DSCLK_IN              : std_logic;
   signal DSCLK_LOCKED          : std_logic;
   signal DSCLK_180             : std_logic;
   signal DSCLK0                : std_logic;
   signal DSCLK180              : std_logic;
   signal D_CHNLDAT_A           : std_logic_vector (31 downto 0);
   signal D_CHNLDAT_B           : std_logic_vector (31 downto 0);
   signal D_CHNLDAT_C           : std_logic_vector (31 downto 0);
   signal D_CHNLDAT_D           : std_logic_vector (31 downto 0);
   signal D_EXT_SCLK            : std_logic;
   signal D_EXT_SCLK180         : std_logic;
   signal D_RST_RDRSYNC         : std_logic;
   signal D_RST_RSYNC           : std_logic;
   signal OUT_TDM_0             : std_logic;
   signal OUT_TDM_1             : std_logic;
   signal OUT_TDM_2             : std_logic;
   signal OUT_TDM_3             : std_logic;
   signal SDIN0                 : std_logic;
   signal SDIN1                 : std_logic;
   signal SDIN2                 : std_logic;
   signal SDIN3                 : std_logic;
   signal TDM_A                 : std_logic_vector (31 downto 0);
   signal TDM_B                 : std_logic_vector (31 downto 0);
   signal TDM_C                 : std_logic_vector (31 downto 0);
   signal TDM_D                 : std_logic_vector (31 downto 0);
   signal XLXN_178              : std_logic;
   signal XLXN_179              : std_logic;
   signal XLXN_181              : std_logic;
   signal XLXN_209              : std_logic;
   signal XLXN_245              : std_logic;
   signal DCLK_25M_DUMMY        : std_logic;
   signal DANTE_WR_RESYNC_DUMMY : std_logic;
   signal DANTE_RX_STATE_DUMMY  : std_logic_vector (8 downto 0);
   signal D_LRCLK_EDGE_DUMMY    : std_logic;
   signal DCLK_25M_INV_DUMMY    : std_logic;
   signal D_CHNL_HOLD_DUMMY     : std_logic;
   signal D_TX_BP_DOUT_DUMMY    : std_logic_vector (31 downto 0);
   signal DANTE_CHNDAT_DUMMY    : std_logic_vector (31 downto 0);
   signal DANTE_RD_RESYNC_DUMMY : std_logic;
   signal DANTE_PISO_LD_DUMMY   : std_logic;
   component SP3A_Reg32EnInitClr
      port ( D     : in    std_logic_vector (31 downto 0); 
             CE    : in    std_logic; 
             CLK   : in    std_logic; 
             Q     : out   std_logic_vector (31 downto 0); 
             AINIT : in    std_logic);
   end component;
   
   component BUSMUX4X1X32
      port ( DAT_A  : in    std_logic_vector (31 downto 0); 
             DAT_B  : in    std_logic_vector (31 downto 0); 
             DAT_C  : in    std_logic_vector (31 downto 0); 
             DAT_D  : in    std_logic_vector (31 downto 0); 
             SEL    : in    std_logic_vector (1 downto 0); 
             MUXOUT : out   std_logic_vector (31 downto 0));
   end component;
   
   component LRCLK_EdgeCount_512_B
      port ( clk       : in    std_logic; 
             sclr      : in    std_logic; 
             q         : out   std_logic_vector (8 downto 0); 
             q_thresh0 : out   std_logic);
   end component;
   
   component DCM_SP
      -- synopsys translate_off
      generic( CLK_FEEDBACK : string :=  "1X";
               CLKDV_DIVIDE : real :=  2.0;
               CLKFX_DIVIDE : integer :=  1;
               CLKIN_PERIOD : real :=  10.0;
               CLKFX_MULTIPLY : integer :=  4;
               CLKIN_DIVIDE_BY_2 : boolean :=  FALSE;
               CLKOUT_PHASE_SHIFT : string :=  "NONE";
               DESKEW_ADJUST : string :=  "SYSTEM_SYNCHRONOUS";
               DFS_FREQUENCY_MODE : string :=  "LOW";
               DLL_FREQUENCY_MODE : string :=  "LOW";
               DSS_MODE : string :=  "NONE";
               DUTY_CYCLE_CORRECTION : boolean :=  TRUE;
               PHASE_SHIFT : integer :=  0;
               STARTUP_WAIT : boolean :=  FALSE;
               FACTORY_JF : bit_vector :=  x"C080");
      -- synopsys translate_on
      port ( CLKFB    : in    std_logic; 
             CLKIN    : in    std_logic; 
             DSSEN    : in    std_logic; 
             PSCLK    : in    std_logic; 
             PSEN     : in    std_logic; 
             PSINCDEC : in    std_logic; 
             RST      : in    std_logic; 
             CLK0     : out   std_logic; 
             CLK180   : out   std_logic; 
             CLK270   : out   std_logic; 
             CLK2X    : out   std_logic; 
             CLK2X180 : out   std_logic; 
             CLK90    : out   std_logic; 
             CLKDV    : out   std_logic; 
             CLKFX    : out   std_logic; 
             CLKFX180 : out   std_logic; 
             LOCKED   : out   std_logic; 
             PSDONE   : out   std_logic; 
             STATUS   : out   std_logic_vector (7 downto 0));
   end component;
   attribute CLK_FEEDBACK of DCM_SP : component is "1X";
   attribute CLKDV_DIVIDE of DCM_SP : component is "2.0";
   attribute CLKFX_DIVIDE of DCM_SP : component is "1";
   attribute CLKIN_PERIOD of DCM_SP : component is "10.0";
   attribute CLKFX_MULTIPLY of DCM_SP : component is "4";
   attribute CLKIN_DIVIDE_BY_2 of DCM_SP : component is "FALSE";
   attribute CLKOUT_PHASE_SHIFT of DCM_SP : component is "NONE";
   attribute DESKEW_ADJUST of DCM_SP : component is "SYSTEM_SYNCHRONOUS";
   attribute DFS_FREQUENCY_MODE of DCM_SP : component is "LOW";
   attribute DLL_FREQUENCY_MODE of DCM_SP : component is "LOW";
   attribute DSS_MODE of DCM_SP : component is "NONE";
   attribute DUTY_CYCLE_CORRECTION of DCM_SP : component is "TRUE";
   attribute PHASE_SHIFT of DCM_SP : component is "0";
   attribute STARTUP_WAIT of DCM_SP : component is "FALSE";
   attribute FACTORY_JF of DCM_SP : component is "C080";
   attribute BOX_TYPE of DCM_SP : component is "BLACK_BOX";
   
   component TDM_BITCOUNT_32B
      port ( clk       : in    std_logic; 
             sclr      : in    std_logic; 
             q_thresh0 : out   std_logic; 
             q         : out   std_logic_vector (4 downto 0));
   end component;
   
   component SP3A_Piso32_Lsb
      port ( D      : in    std_logic_vector (31 downto 0); 
             P_LOAD : in    std_logic; 
             CLK    : in    std_logic; 
             SDOUT  : out   std_logic);
   end component;
   
   component CNTR4_EN_PS14
      port ( ENA   : in    std_logic; 
             CLK   : in    std_logic; 
             RSYNC : in    std_logic; 
             COUNT : out   std_logic_vector (3 downto 0));
   end component;
   
   component SP3AN_FIFO_1KX32_B
      port ( din           : in    std_logic_vector (31 downto 0); 
             wr_en         : in    std_logic; 
             rst           : in    std_logic; 
             rd_en         : in    std_logic; 
             wr_data_count : out   std_logic_vector (9 downto 0); 
             full          : out   std_logic; 
             almost_full   : out   std_logic; 
             wr_ack        : out   std_logic; 
             overflow      : out   std_logic; 
             rd_data_count : out   std_logic_vector (9 downto 0); 
             empty         : out   std_logic; 
             almost_empty  : out   std_logic; 
             valid         : out   std_logic; 
             underflow     : out   std_logic; 
             dout          : out   std_logic_vector (31 downto 0); 
             rd_clk        : in    std_logic; 
             wr_clk        : in    std_logic);
   end component;
   
   component Audio32_SIPO
      port ( S_IN  : in    std_logic; 
             CLK   : in    std_logic; 
             RSYNC : in    std_logic; 
             RST   : in    std_logic; 
             P_OUT : out   std_logic_vector (31 downto 0); 
             HOLD  : out   std_logic; 
             COUNT : out   std_logic_vector (4 downto 0));
   end component;
   
   component FD
      generic( INIT : bit :=  '0');
      port ( C : in    std_logic; 
             D : in    std_logic; 
             Q : out   std_logic);
   end component;
   attribute BOX_TYPE of FD : component is "BLACK_BOX";
   
   component Falling_Edge
      port ( EDGE_DETECT : out   std_logic; 
             CLK         : in    std_logic; 
             F_EDGE      : in    std_logic);
   end component;
   
   component CNTR4_EN_PS1
      port ( ENA   : in    std_logic; 
             CLK   : in    std_logic; 
             RSYNC : in    std_logic; 
             COUNT : out   std_logic_vector (3 downto 0));
   end component;
   
   component SP3A_Siso4
      port ( SDIN  : in    std_logic; 
             SDOUT : out   std_logic; 
             CLK   : in    std_logic);
   end component;
   
   component BUFGMUX_1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             S  : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of BUFGMUX_1 : component is "BLACK_BOX";
   
   component SP3A_Reg9
      port ( D   : in    std_logic_vector (8 downto 0); 
             CLK : in    std_logic; 
             Q   : out   std_logic_vector (8 downto 0));
   end component;
   
   component OR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2 : component is "BLACK_BOX";
   
   component BUFG
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of BUFG : component is "BLACK_BOX";
   
   component GND
      port ( G : out   std_logic);
   end component;
   attribute BOX_TYPE of GND : component is "BLACK_BOX";
   
   component BUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of BUF : component is "BLACK_BOX";
   
   component OR2B2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2B2 : component is "BLACK_BOX";
   
   attribute CLKIN_PERIOD of DANTE_MCLK_DCM : label is "20.0";
   attribute CLKFX_MULTIPLY of DANTE_MCLK_DCM : label is "2";
   attribute CLKFX_DIVIDE of DANTE_MCLK_DCM : label is "4";
   attribute PHASE_SHIFT of DANTE_MCLK_DCM : label is "70";
   attribute CLKOUT_PHASE_SHIFT of DANTE_MCLK_DCM : label is "FIXED";
   attribute CLKFX_MULTIPLY of DANTE_SCLK_DCM : label is "2";
   attribute CLKFX_DIVIDE of DANTE_SCLK_DCM : label is "4";
   attribute PHASE_SHIFT of DANTE_SCLK_DCM : label is "72";
   attribute CLKOUT_PHASE_SHIFT of DANTE_SCLK_DCM : label is "FIXED";
begin
   DANTE_CHNDAT(31 downto 0) <= DANTE_CHNDAT_DUMMY(31 downto 0);
   DANTE_PISO_LD <= DANTE_PISO_LD_DUMMY;
   DANTE_RD_RESYNC <= DANTE_RD_RESYNC_DUMMY;
   DANTE_RX_STATE(8 downto 0) <= DANTE_RX_STATE_DUMMY(8 downto 0);
   DANTE_WR_RESYNC <= DANTE_WR_RESYNC_DUMMY;
   DCLK_25M <= DCLK_25M_DUMMY;
   DCLK_25M_INV <= DCLK_25M_INV_DUMMY;
   D_CHNL_HOLD <= D_CHNL_HOLD_DUMMY;
   D_LRCLK_EDGE <= D_LRCLK_EDGE_DUMMY;
   D_TX_BP_DOUT(31 downto 0) <= D_TX_BP_DOUT_DUMMY(31 downto 0);
   DANTE_CHNL_HOLD_0 : SP3A_Reg32EnInitClr
      port map (AINIT=>RST,
                CE=>DANTE_TDM0_LD,
                CLK=>BPCLK_FB,
                D(31 downto 0)=>D_TX_BP_DOUT_DUMMY(31 downto 0),
                Q(31 downto 0)=>D_CHNLDAT_A(31 downto 0));
   
   DANTE_CHNL_HOLD_1 : SP3A_Reg32EnInitClr
      port map (AINIT=>RST,
                CE=>DANTE_TDM1_LD,
                CLK=>BPCLK_FB,
                D(31 downto 0)=>D_TX_BP_DOUT_DUMMY(31 downto 0),
                Q(31 downto 0)=>D_CHNLDAT_B(31 downto 0));
   
   DANTE_CHNL_HOLD_2 : SP3A_Reg32EnInitClr
      port map (AINIT=>RST,
                CE=>DANTE_TDM2_LD,
                CLK=>BPCLK_FB,
                D(31 downto 0)=>D_TX_BP_DOUT_DUMMY(31 downto 0),
                Q(31 downto 0)=>D_CHNLDAT_C(31 downto 0));
   
   DANTE_CHNL_HOLD_3 : SP3A_Reg32EnInitClr
      port map (AINIT=>RST,
                CE=>DANTE_TDM3_LD,
                CLK=>BPCLK_FB,
                D(31 downto 0)=>D_TX_BP_DOUT_DUMMY(31 downto 0),
                Q(31 downto 0)=>D_CHNLDAT_D(31 downto 0));
   
   DANTE_CHNL_MUX : BUSMUX4X1X32
      port map (DAT_A(31 downto 0)=>TDM_A(31 downto 0),
                DAT_B(31 downto 0)=>TDM_B(31 downto 0),
                DAT_C(31 downto 0)=>TDM_C(31 downto 0),
                DAT_D(31 downto 0)=>TDM_D(31 downto 0),
                SEL(1 downto 0)=>D_RXWCH_SEL(1 downto 0),
                MUXOUT(31 downto 0)=>DANTE_CHNDAT_DUMMY(31 downto 0));
   
   DANTE_LR_EDGE : LRCLK_EdgeCount_512_B
      port map (clk=>DCLK_25M_DUMMY,
                sclr=>XLXN_178,
                q=>open,
                q_thresh0=>DANTE_WR_RESYNC_DUMMY);
   
   DANTE_LR_EDGE_B : LRCLK_EdgeCount_512_B
      port map (clk=>DCLK_25M_DUMMY,
                sclr=>D_RST_RDRSYNC,
                q=>open,
                q_thresh0=>DANTE_RD_RESYNC_DUMMY);
   
   DANTE_MCLK_DCM : DCM_SP
   -- synopsys translate_off
   generic map( CLKIN_PERIOD => 20.0,
            CLKFX_MULTIPLY => 2,
            CLKFX_DIVIDE => 4,
            PHASE_SHIFT => 70,
            CLKOUT_PHASE_SHIFT => "FIXED")
   -- synopsys translate_on
      port map (CLKFB=>DMCLK_FB,
                CLKIN=>XLXN_179,
                DSSEN=>XLXN_181,
                PSCLK=>XLXN_181,
                PSEN=>XLXN_181,
                PSINCDEC=>XLXN_181,
                RST=>D_DCM_RST,
                CLKDV=>open,
                CLKFX=>CLKFX,
                CLKFX180=>CLKFX180,
                CLK0=>DMCLK0,
                CLK2X=>XLXN_245,
                CLK2X180=>open,
                CLK90=>open,
                CLK180=>open,
                CLK270=>open,
                LOCKED=>DMCLK_LOCKED,
                PSDONE=>open,
                STATUS=>open);
   
   DANTE_PISO_LOADER : TDM_BITCOUNT_32B
      port map (clk=>DCLK_25M_DUMMY,
                sclr=>DANTE_RD_RESYNC_DUMMY,
                q=>open,
                q_thresh0=>DANTE_PISO_LD_DUMMY);
   
   DANTE_PISO_0 : SP3A_Piso32_Lsb
      port map (CLK=>DCLK_25M_DUMMY,
                D(31 downto 0)=>D_CHNLDAT_A(31 downto 0),
                P_LOAD=>DANTE_PISO_LD_DUMMY,
                SDOUT=>OUT_TDM_0);
   
   DANTE_PISO_1 : SP3A_Piso32_Lsb
      port map (CLK=>DCLK_25M_DUMMY,
                D(31 downto 0)=>D_CHNLDAT_B(31 downto 0),
                P_LOAD=>DANTE_PISO_LD_DUMMY,
                SDOUT=>OUT_TDM_1);
   
   DANTE_PISO_2 : SP3A_Piso32_Lsb
      port map (CLK=>DCLK_25M_DUMMY,
                D(31 downto 0)=>D_CHNLDAT_C(31 downto 0),
                P_LOAD=>DANTE_PISO_LD_DUMMY,
                SDOUT=>OUT_TDM_2);
   
   DANTE_PISO_3 : SP3A_Piso32_Lsb
      port map (CLK=>DCLK_25M_DUMMY,
                D(31 downto 0)=>D_CHNLDAT_D(31 downto 0),
                P_LOAD=>DANTE_PISO_LD_DUMMY,
                SDOUT=>OUT_TDM_3);
   
   DANTE_RXCHNL_COUNTER : CNTR4_EN_PS14
      port map (CLK=>DCLK_25M_DUMMY,
                ENA=>D_CHNL_HOLD_DUMMY,
                RSYNC=>D_RST_RSYNC,
                COUNT(3 downto 0)=>D_RXCHNL_COUNT(3 downto 0));
   
   DANTE_RX_FIFO : SP3AN_FIFO_1KX32_B
      port map (din(31 downto 0)=>DANTE_CHNDAT_DUMMY(31 downto 0),
                rd_clk=>BPCLK_FB,
                rd_en=>BP_RX_RDEN,
                rst=>D_RXTX_FIFO_RST,
                wr_clk=>DCLK_25M_DUMMY,
                wr_en=>BP_RX_WREN,
                almost_empty=>D_RX_FAEMPTY,
                almost_full=>D_RX_FAFULL,
                dout(31 downto 0)=>D_RX_BP_DOUT(31 downto 0),
                empty=>D_RX_FEMPTY,
                full=>D_RX_FFULL,
                overflow=>D_RX_OVRFLOW,
                rd_data_count=>open,
                underflow=>D_RX_UDRFLOW,
                valid=>D_RX_RDVALID,
                wr_ack=>D_RX_WR_ACK,
                wr_data_count(9 downto 0)=>D_RX_FIFOCNT(9 downto 0));
   
   DANTE_SCLK_DCM : DCM_SP
   -- synopsys translate_off
   generic map( CLKIN_PERIOD => 10.0,
            CLKFX_MULTIPLY => 2,
            CLKFX_DIVIDE => 4,
            PHASE_SHIFT => 72,
            CLKOUT_PHASE_SHIFT => "FIXED")
   -- synopsys translate_on
      port map (CLKFB=>DSCLK_FB,
                CLKIN=>DSCLK_IN,
                DSSEN=>XLXN_209,
                PSCLK=>XLXN_209,
                PSEN=>XLXN_209,
                PSINCDEC=>XLXN_209,
                RST=>D_DCM_RST,
                CLKDV=>open,
                CLKFX=>open,
                CLKFX180=>open,
                CLK0=>DSCLK0,
                CLK2X=>open,
                CLK2X180=>open,
                CLK90=>open,
                CLK180=>DSCLK180,
                CLK270=>open,
                LOCKED=>DSCLK_LOCKED,
                PSDONE=>open,
                STATUS=>open);
   
   DANTE_SIPO_0 : Audio32_SIPO
      port map (CLK=>DCLK_25M_DUMMY,
                RST=>RST,
                RSYNC=>DANTE_WR_RESYNC_DUMMY,
                S_IN=>SDIN0,
                COUNT=>open,
                HOLD=>D_CHNL_HOLD_DUMMY,
                P_OUT(31 downto 0)=>TDM_A(31 downto 0));
   
   DANTE_SIPO_1 : Audio32_SIPO
      port map (CLK=>DCLK_25M_DUMMY,
                RST=>RST,
                RSYNC=>DANTE_WR_RESYNC_DUMMY,
                S_IN=>SDIN1,
                COUNT=>open,
                HOLD=>open,
                P_OUT(31 downto 0)=>TDM_B(31 downto 0));
   
   DANTE_SIPO_2 : Audio32_SIPO
      port map (CLK=>DCLK_25M_DUMMY,
                RST=>RST,
                RSYNC=>DANTE_WR_RESYNC_DUMMY,
                S_IN=>SDIN2,
                COUNT=>open,
                HOLD=>open,
                P_OUT(31 downto 0)=>TDM_C(31 downto 0));
   
   DANTE_SIPO_3 : Audio32_SIPO
      port map (CLK=>DCLK_25M_DUMMY,
                RST=>RST,
                RSYNC=>DANTE_WR_RESYNC_DUMMY,
                S_IN=>SDIN3,
                COUNT=>open,
                HOLD=>open,
                P_OUT(31 downto 0)=>TDM_D(31 downto 0));
   
   DANTE_STATE_COUNT : LRCLK_EdgeCount_512_B
      port map (clk=>DCLK_25M_DUMMY,
                sclr=>DANTE_WR_RESYNC_DUMMY,
                q(8 downto 0)=>DANTE_RX_STATE_DUMMY(8 downto 0),
                q_thresh0=>open);
   
   DANTE_STATE_COUNT_B : LRCLK_EdgeCount_512_B
      port map (clk=>DCLK_25M_DUMMY,
                sclr=>DANTE_RD_RESYNC_DUMMY,
                q(8 downto 0)=>DANTE_TX_STATE(8 downto 0),
                q_thresh0=>open);
   
   DANTE_TX_FIFO : SP3AN_FIFO_1KX32_B
      port map (din(31 downto 0)=>BP_CHNDAT(31 downto 0),
                rd_clk=>BPCLK_FB,
                rd_en=>BP_TX_RDEN,
                rst=>D_RXTX_FIFO_RST,
                wr_clk=>BPCLK_FB,
                wr_en=>BP_TX_WREN,
                almost_empty=>D_TX_FAEMPTY,
                almost_full=>D_TX_FAFULL,
                dout(31 downto 0)=>D_TX_BP_DOUT_DUMMY(31 downto 0),
                empty=>D_TX_FEMPTY,
                full=>D_TX_FFULL,
                overflow=>D_TX_OVRFLOW,
                rd_data_count=>open,
                underflow=>D_TX_UDRFLOW,
                valid=>D_TX_RDVALID,
                wr_ack=>D_TX_WR_ACK,
                wr_data_count(9 downto 0)=>D_TX_FIFOCNT(9 downto 0));
   
   DDIN_REG0 : FD
      port map (C=>DCLK_25M_DUMMY,
                D=>D_SDIN_0,
                Q=>SDIN0);
   
   DDIN_REG1 : FD
      port map (C=>DCLK_25M_DUMMY,
                D=>D_SDIN_1,
                Q=>SDIN1);
   
   DDIN_REG2 : FD
      port map (C=>DCLK_25M_DUMMY,
                D=>D_SDIN_2,
                Q=>SDIN2);
   
   DDIN_REG3 : FD
      port map (C=>DCLK_25M_DUMMY,
                D=>D_SDIN_3,
                Q=>SDIN3);
   
   DLRCLK_FALLING_EDGE : Falling_Edge
      port map (CLK=>DSCLK_IN,
                F_EDGE=>D_LRCLK,
                EDGE_DETECT=>D_LRCLK_EDGE_DUMMY);
   
   D_FDOUT_0 : FD
      port map (C=>DCLK_25M_INV_DUMMY,
                D=>OUT_TDM_0,
                Q=>D_SDO_0);
   
   D_FDOUT_1 : FD
      port map (C=>DCLK_25M_INV_DUMMY,
                D=>OUT_TDM_1,
                Q=>D_SDO_1);
   
   D_FDOUT_2 : FD
      port map (C=>DCLK_25M_INV_DUMMY,
                D=>OUT_TDM_2,
                Q=>D_SDO_2);
   
   D_FDOUT_3 : FD
      port map (C=>DCLK_25M_INV_DUMMY,
                D=>OUT_TDM_3,
                Q=>D_SDO_3);
   
   D_TXCHNL_COUNTER : CNTR4_EN_PS1
      port map (CLK=>DCLK_25M_DUMMY,
                ENA=>DANTE_PISO_LD_DUMMY,
                RSYNC=>D_RST_RDRSYNC,
                COUNT(3 downto 0)=>D_TXCHNL_COUNT(3 downto 0));
   
   PISO_LD_DELAY : SP3A_Siso4
      port map (CLK=>DCLK_25M_DUMMY,
                SDIN=>DANTE_PISO_LD_DUMMY,
                SDOUT=>DANTE_PISO_LD_DLY);
   
   SCLK_MUX : BUFGMUX_1
      port map (I0=>D_EXT_SCLK,
                I1=>DSCLK_FX,
                S=>D_SCLK_SEL,
                O=>DCLK_25M_INV_DUMMY);
   
   SCLK180_MUX : BUFGMUX_1
      port map (I0=>D_EXT_SCLK180,
                I1=>DSCLK_FX180,
                S=>D_SCLK_SEL,
                O=>DCLK_25M_DUMMY);
   
   TempTestReg : SP3A_Reg9
      port map (CLK=>DCLK_25M_DUMMY,
                D(8 downto 0)=>DANTE_RX_STATE_DUMMY(8 downto 0),
                Q(8 downto 0)=>DANTE_BIT_STATE(8 downto 0));
   
   XLXI_141 : OR2
      port map (I0=>D_LRCLK_EDGE_DUMMY,
                I1=>RST,
                O=>XLXN_178);
   
   XLXI_143 : BUFG
      port map (I=>D_MCLK,
                O=>XLXN_179);
   
   XLXI_144 : BUFG
      port map (I=>DMCLK0,
                O=>DMCLK_FB);
   
   XLXI_145 : GND
      port map (G=>XLXN_181);
   
   XLXI_158 : OR2
      port map (I0=>DANTE_WR_RESYNC_DUMMY,
                I1=>RST,
                O=>D_RST_RSYNC);
   
   XLXI_232 : OR2
      port map (I0=>D_LRCLK_EDGE_DUMMY,
                I1=>RST,
                O=>D_RST_RDRSYNC);
   
   XLXI_238 : BUFG
      port map (I=>CLKFX,
                O=>DSCLK_FX);
   
   XLXI_261 : BUFG
      port map (I=>CLKFX180,
                O=>DSCLK_FX180);
   
   XLXI_279 : BUFG
      port map (I=>D_SCLK,
                O=>DSCLK_IN);
   
   XLXI_280 : GND
      port map (G=>XLXN_209);
   
   XLXI_281 : BUFG
      port map (I=>DSCLK0,
                O=>DSCLK_FB);
   
   XLXI_296 : BUFG
      port map (I=>DSCLK180,
                O=>DSCLK_180);
   
   XLXI_297 : BUF
      port map (I=>DSCLK_FB,
                O=>D_EXT_SCLK);
   
   XLXI_298 : BUF
      port map (I=>DSCLK_180,
                O=>D_EXT_SCLK180);
   
   XLXI_299 : FD
      port map (C=>BPSCLK_FB,
                D=>D_DCM_RST,
                Q=>DDCM_RST);
   
   XLXI_300 : BUFG
      port map (I=>XLXN_245,
                O=>DMCLK_2X);
   
   XLXI_301 : OR2B2
      port map (I0=>DSCLK_LOCKED,
                I1=>DMCLK_LOCKED,
                O=>DDCMS_LOCKED);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity ERROR_STATUS_MUSER_KDL is
   port ( CLK            : in    std_logic; 
          ERR_INPUT      : in    std_logic_vector (7 downto 0); 
          ERR_STATUS_RD  : in    std_logic; 
          ERR_STATUS_SEL : in    std_logic; 
          RST            : in    std_logic; 
          ERROR_STATUS   : out   std_logic_vector (7 downto 0); 
          ERR_INTn       : out   std_logic);
end ERROR_STATUS_MUSER_KDL;

architecture BEHAVIORAL of ERROR_STATUS_MUSER_KDL is
   attribute BOX_TYPE   : string ;
   attribute HU_SET     : string ;
   signal ASSERT_INT     : std_logic;
   signal CLR_ERR        : std_logic;
   signal CLR_ERR_INT    : std_logic;
   signal CLR_INT        : std_logic;
   signal ERR_FB         : std_logic_vector (7 downto 0);
   signal ERR_STATUS_ENA : std_logic;
   signal PS_INTn        : std_logic;
   signal ERR_INTn_DUMMY : std_logic;
   component FD
      generic( INIT : bit :=  '0');
      port ( C : in    std_logic; 
             D : in    std_logic; 
             Q : out   std_logic);
   end component;
   attribute BOX_TYPE of FD : component is "BLACK_BOX";
   
   component FDCP
      generic( INIT : bit :=  '0');
      port ( C   : in    std_logic; 
             CLR : in    std_logic; 
             D   : in    std_logic; 
             PRE : in    std_logic; 
             Q   : out   std_logic);
   end component;
   attribute BOX_TYPE of FDCP : component is "BLACK_BOX";
   
   component FDE
      generic( INIT : bit :=  '0');
      port ( C  : in    std_logic; 
             CE : in    std_logic; 
             D  : in    std_logic; 
             Q  : out   std_logic);
   end component;
   attribute BOX_TYPE of FDE : component is "BLACK_BOX";
   
   component INV
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of INV : component is "BLACK_BOX";
   
   component OR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2 : component is "BLACK_BOX";
   
   component OR8_HXILINX_KDL
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             I3 : in    std_logic; 
             I4 : in    std_logic; 
             I5 : in    std_logic; 
             I6 : in    std_logic; 
             I7 : in    std_logic; 
             O  : out   std_logic);
   end component;
   
   component BUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of BUF : component is "BLACK_BOX";
   
   attribute HU_SET of XLXI_101 : label is "XLXI_101_0";
begin
   ERR_INTn <= ERR_INTn_DUMMY;
   CLR_INT_DLY_FD : FD
      port map (C=>CLK,
                D=>CLR_ERR_INT,
                Q=>CLR_INT);
   
   ERRINT_FD : FDCP
      port map (C=>CLK,
                CLR=>ASSERT_INT,
                D=>ERR_INTn_DUMMY,
                PRE=>PS_INTn,
                Q=>ERR_INTn_DUMMY);
   
   ERRSTAT_HLD_FD_0 : FDE
      port map (C=>CLK,
                CE=>ERR_STATUS_ENA,
                D=>ERR_FB(0),
                Q=>ERROR_STATUS(0));
   
   ERRSTAT_HLD_FD_1 : FDE
      port map (C=>CLK,
                CE=>ERR_STATUS_ENA,
                D=>ERR_FB(1),
                Q=>ERROR_STATUS(1));
   
   ERRSTAT_HLD_FD_2 : FDE
      port map (C=>CLK,
                CE=>ERR_STATUS_ENA,
                D=>ERR_FB(2),
                Q=>ERROR_STATUS(2));
   
   ERRSTAT_HLD_FD_3 : FDE
      port map (C=>CLK,
                CE=>ERR_STATUS_ENA,
                D=>ERR_FB(3),
                Q=>ERROR_STATUS(3));
   
   ERRSTAT_HLD_FD_4 : FDE
      port map (C=>CLK,
                CE=>ERR_STATUS_ENA,
                D=>ERR_FB(4),
                Q=>ERROR_STATUS(4));
   
   ERRSTAT_HLD_FD_5 : FDE
      port map (C=>CLK,
                CE=>ERR_STATUS_ENA,
                D=>ERR_FB(5),
                Q=>ERROR_STATUS(5));
   
   ERRSTAT_HLD_FD_6 : FDE
      port map (C=>CLK,
                CE=>ERR_STATUS_ENA,
                D=>ERR_FB(6),
                Q=>ERROR_STATUS(6));
   
   ERRSTAT_HLD_FD_7 : FDE
      port map (C=>CLK,
                CE=>ERR_STATUS_ENA,
                D=>ERR_FB(7),
                Q=>ERROR_STATUS(7));
   
   ERR_FD_0 : FDCP
      port map (C=>CLK,
                CLR=>CLR_ERR_INT,
                D=>ERR_FB(0),
                PRE=>ERR_INPUT(0),
                Q=>ERR_FB(0));
   
   ERR_FD_1 : FDCP
      port map (C=>CLK,
                CLR=>CLR_ERR_INT,
                D=>ERR_FB(1),
                PRE=>ERR_INPUT(1),
                Q=>ERR_FB(1));
   
   ERR_FD_2 : FDCP
      port map (C=>CLK,
                CLR=>CLR_ERR_INT,
                D=>ERR_FB(2),
                PRE=>ERR_INPUT(2),
                Q=>ERR_FB(2));
   
   ERR_FD_3 : FDCP
      port map (C=>CLK,
                CLR=>CLR_ERR_INT,
                D=>ERR_FB(3),
                PRE=>ERR_INPUT(3),
                Q=>ERR_FB(3));
   
   ERR_FD_4 : FDCP
      port map (C=>CLK,
                CLR=>CLR_ERR_INT,
                D=>ERR_FB(4),
                PRE=>ERR_INPUT(4),
                Q=>ERR_FB(4));
   
   ERR_FD_5 : FDCP
      port map (C=>CLK,
                CLR=>CLR_ERR_INT,
                D=>ERR_FB(5),
                PRE=>ERR_INPUT(5),
                Q=>ERR_FB(5));
   
   ERR_FD_6 : FDCP
      port map (C=>CLK,
                CLR=>CLR_ERR_INT,
                D=>ERR_FB(6),
                PRE=>ERR_INPUT(6),
                Q=>ERR_FB(6));
   
   ERR_FD_7 : FDCP
      port map (C=>CLK,
                CLR=>CLR_ERR_INT,
                D=>ERR_FB(7),
                PRE=>ERR_INPUT(7),
                Q=>ERR_FB(7));
   
   XLXI_76 : INV
      port map (I=>ERR_STATUS_SEL,
                O=>ERR_STATUS_ENA);
   
   XLXI_97 : OR2
      port map (I0=>CLR_ERR,
                I1=>RST,
                O=>CLR_ERR_INT);
   
   XLXI_101 : OR8_HXILINX_KDL
      port map (I0=>ERR_FB(0),
                I1=>ERR_FB(1),
                I2=>ERR_FB(2),
                I3=>ERR_FB(3),
                I4=>ERR_FB(4),
                I5=>ERR_FB(5),
                I6=>ERR_FB(6),
                I7=>ERR_FB(7),
                O=>ASSERT_INT);
   
   XLXI_106 : OR2
      port map (I0=>CLR_INT,
                I1=>RST,
                O=>PS_INTn);
   
   XLXI_107 : BUF
      port map (I=>ERR_STATUS_RD,
                O=>CLR_ERR);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity FallingEdgeDetect_MUSER_KDL is
   port ( CLK       : in    std_logic; 
          EDGEn     : in    std_logic; 
          ENA       : in    std_logic; 
          RST       : in    std_logic; 
          DET_PULSE : out   std_logic);
end FallingEdgeDetect_MUSER_KDL;

architecture BEHAVIORAL of FallingEdgeDetect_MUSER_KDL is
   attribute BOX_TYPE   : string ;
   signal Q         : std_logic_vector (2 downto 0);
   signal XLXN_1    : std_logic;
   component SP3A_SipoAClr3_Lsb
      port ( SDIN : in    std_logic; 
             Q    : out   std_logic_vector (2 downto 0); 
             CLK  : in    std_logic; 
             ACLR : in    std_logic);
   end component;
   
   component NAND2B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of NAND2B1 : component is "BLACK_BOX";
   
   component AND2B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2B1 : component is "BLACK_BOX";
   
begin
   EDGEDET_SIPO : SP3A_SipoAClr3_Lsb
      port map (ACLR=>RST,
                CLK=>CLK,
                SDIN=>XLXN_1,
                Q(2 downto 0)=>Q(2 downto 0));
   
   XLXI_5 : NAND2B1
      port map (I0=>EDGEn,
                I1=>ENA,
                O=>XLXN_1);
   
   XLXI_6 : AND2B1
      port map (I0=>Q(0),
                I1=>Q(1),
                O=>DET_PULSE);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity RD_DEVICE_MUSER_KDL is
   port ( CLK      : in    std_logic; 
          DevRD    : in    std_logic; 
          DevRDSel : in    std_logic_vector (7 downto 0); 
          RST      : in    std_logic; 
          RD_PULSE : out   std_logic_vector (7 downto 0));
end RD_DEVICE_MUSER_KDL;

architecture BEHAVIORAL of RD_DEVICE_MUSER_KDL is
   attribute BOX_TYPE   : string ;
   signal RDEDGE   : std_logic_vector (7 downto 0);
   signal XLXN_56  : std_logic;
   component FallingEdgeDetect_MUSER_KDL
      port ( EDGEn     : in    std_logic; 
             ENA       : in    std_logic; 
             CLK       : in    std_logic; 
             RST       : in    std_logic; 
             DET_PULSE : out   std_logic);
   end component;
   
   component NAND2B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of NAND2B1 : component is "BLACK_BOX";
   
   component VCC
      port ( P : out   std_logic);
   end component;
   attribute BOX_TYPE of VCC : component is "BLACK_BOX";
   
begin
   RDDETECT_0 : FallingEdgeDetect_MUSER_KDL
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(0),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(0));
   
   RDDETECT_1 : FallingEdgeDetect_MUSER_KDL
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(1),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(1));
   
   RDDETECT_2 : FallingEdgeDetect_MUSER_KDL
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(2),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(2));
   
   RDDETECT_3 : FallingEdgeDetect_MUSER_KDL
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(3),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(3));
   
   RDDETECT_4 : FallingEdgeDetect_MUSER_KDL
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(4),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(4));
   
   RDDETECT_5 : FallingEdgeDetect_MUSER_KDL
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(5),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(5));
   
   RDDETECT_6 : FallingEdgeDetect_MUSER_KDL
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(6),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(6));
   
   RDDETECT_7 : FallingEdgeDetect_MUSER_KDL
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(7),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(7));
   
   RDNAND_0 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(0),
                O=>RDEDGE(0));
   
   RDNAND_1 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(1),
                O=>RDEDGE(1));
   
   RDNAND_2 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(2),
                O=>RDEDGE(2));
   
   RDNAND_3 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(3),
                O=>RDEDGE(3));
   
   RDNAND_4 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(4),
                O=>RDEDGE(4));
   
   RDNAND_5 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(5),
                O=>RDEDGE(5));
   
   RDNAND_6 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(6),
                O=>RDEDGE(6));
   
   RDNAND_7 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(7),
                O=>RDEDGE(7));
   
   XLXI_43 : VCC
      port map (P=>XLXN_56);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity WR_DEVICE_MUSER_KDL is
   port ( CLK         : in    std_logic; 
          DevAddr     : in    std_logic_vector (6 downto 0); 
          DevData     : in    std_logic_vector (7 downto 0); 
          DevWR       : in    std_logic; 
          DevWRSel    : in    std_logic_vector (7 downto 0); 
          RST         : in    std_logic; 
          WR_DEV_ADDR : out   std_logic_vector (6 downto 0); 
          WR_DEV_DATA : out   std_logic_vector (7 downto 0); 
          WR_PULSE    : out   std_logic_vector (7 downto 0));
end WR_DEVICE_MUSER_KDL;

architecture BEHAVIORAL of WR_DEVICE_MUSER_KDL is
   attribute BOX_TYPE   : string ;
   attribute HU_SET     : string ;
   signal DEVICE_WRITE : std_logic;
   signal WR_HOLD_EN   : std_logic;
   signal XLXN_53      : std_logic;
   component FallingEdgeDetect_MUSER_KDL
      port ( EDGEn     : in    std_logic; 
             ENA       : in    std_logic; 
             CLK       : in    std_logic; 
             RST       : in    std_logic; 
             DET_PULSE : out   std_logic);
   end component;
   
   component SP3A_Reg7AClrEn
      port ( D    : in    std_logic_vector (6 downto 0); 
             CE   : in    std_logic; 
             CLK  : in    std_logic; 
             Q    : out   std_logic_vector (6 downto 0); 
             ACLR : in    std_logic);
   end component;
   
   component SP3A_Reg8AClrEn
      port ( D    : in    std_logic_vector (7 downto 0); 
             CE   : in    std_logic; 
             CLK  : in    std_logic; 
             Q    : out   std_logic_vector (7 downto 0); 
             ACLR : in    std_logic);
   end component;
   
   component AND2B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2B1 : component is "BLACK_BOX";
   
   component OR8_HXILINX_KDL
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             I3 : in    std_logic; 
             I4 : in    std_logic; 
             I5 : in    std_logic; 
             I6 : in    std_logic; 
             I7 : in    std_logic; 
             O  : out   std_logic);
   end component;
   
   component VCC
      port ( P : out   std_logic);
   end component;
   attribute BOX_TYPE of VCC : component is "BLACK_BOX";
   
   attribute HU_SET of XLXI_88 : label is "XLXI_88_1";
begin
   WRDETECT_0 : FallingEdgeDetect_MUSER_KDL
      port map (CLK=>CLK,
                EDGEn=>DevWRSel(0),
                ENA=>XLXN_53,
                RST=>RST,
                DET_PULSE=>WR_PULSE(0));
   
   WRDETECT_1 : FallingEdgeDetect_MUSER_KDL
      port map (CLK=>CLK,
                EDGEn=>DevWRSel(1),
                ENA=>XLXN_53,
                RST=>RST,
                DET_PULSE=>WR_PULSE(1));
   
   WRDETECT_2 : FallingEdgeDetect_MUSER_KDL
      port map (CLK=>CLK,
                EDGEn=>DevWRSel(2),
                ENA=>XLXN_53,
                RST=>RST,
                DET_PULSE=>WR_PULSE(2));
   
   WRDETECT_3 : FallingEdgeDetect_MUSER_KDL
      port map (CLK=>CLK,
                EDGEn=>DevWRSel(3),
                ENA=>XLXN_53,
                RST=>RST,
                DET_PULSE=>WR_PULSE(3));
   
   WRDETECT_4 : FallingEdgeDetect_MUSER_KDL
      port map (CLK=>CLK,
                EDGEn=>DevWRSel(4),
                ENA=>XLXN_53,
                RST=>RST,
                DET_PULSE=>WR_PULSE(4));
   
   WRDETECT_5 : FallingEdgeDetect_MUSER_KDL
      port map (CLK=>CLK,
                EDGEn=>DevWRSel(5),
                ENA=>XLXN_53,
                RST=>RST,
                DET_PULSE=>WR_PULSE(5));
   
   WRDETECT_6 : FallingEdgeDetect_MUSER_KDL
      port map (CLK=>CLK,
                EDGEn=>DevWRSel(6),
                ENA=>XLXN_53,
                RST=>RST,
                DET_PULSE=>WR_PULSE(6));
   
   WRDETECT_7 : FallingEdgeDetect_MUSER_KDL
      port map (CLK=>CLK,
                EDGEn=>DevWRSel(7),
                ENA=>XLXN_53,
                RST=>RST,
                DET_PULSE=>WR_PULSE(7));
   
   WR_DEVADDR_HOLD : SP3A_Reg7AClrEn
      port map (ACLR=>RST,
                CE=>WR_HOLD_EN,
                CLK=>CLK,
                D(6 downto 0)=>DevAddr(6 downto 0),
                Q(6 downto 0)=>WR_DEV_ADDR(6 downto 0));
   
   WR_DEVDATA_HOLD : SP3A_Reg8AClrEn
      port map (ACLR=>RST,
                CE=>WR_HOLD_EN,
                CLK=>CLK,
                D(7 downto 0)=>DevData(7 downto 0),
                Q(7 downto 0)=>WR_DEV_DATA(7 downto 0));
   
   XLXI_35 : AND2B1
      port map (I0=>DevWR,
                I1=>DEVICE_WRITE,
                O=>WR_HOLD_EN);
   
   XLXI_88 : OR8_HXILINX_KDL
      port map (I0=>DevWRSel(0),
                I1=>DevWRSel(1),
                I2=>DevWRSel(2),
                I3=>DevWRSel(3),
                I4=>DevWRSel(4),
                I5=>DevWRSel(5),
                I6=>DevWRSel(6),
                I7=>DevWRSel(7),
                O=>DEVICE_WRITE);
   
   XLXI_91 : VCC
      port map (P=>XLXN_53);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity MICRO_IF_MUSER_KDL is
   port ( CLK          : in    std_logic; 
          CPU_ADD      : in    std_logic_vector (6 downto 0); 
          CPU_DIN      : in    std_logic_vector (7 downto 0); 
          CPU_READn    : in    std_logic; 
          CPU_WRITEn   : in    std_logic; 
          FPGA_SELECTn : in    std_logic; 
          RESET        : in    std_logic; 
          DevRDSel     : out   std_logic_vector (7 downto 0); 
          DevWRSel     : out   std_logic_vector (7 downto 0); 
          RdOEn        : out   std_logic; 
          RdSel        : out   std_logic_vector (2 downto 0); 
          RD_PULSE     : out   std_logic_vector (7 downto 0); 
          WR_DEV_ADDR  : out   std_logic_vector (6 downto 0); 
          WR_DEV_DATA  : out   std_logic_vector (7 downto 0); 
          WR_PULSE     : out   std_logic_vector (7 downto 0));
end MICRO_IF_MUSER_KDL;

architecture BEHAVIORAL of MICRO_IF_MUSER_KDL is
   signal DevAddr        : std_logic_vector (6 downto 0);
   signal DevData        : std_logic_vector (7 downto 0);
   signal DevRD          : std_logic;
   signal DevWR          : std_logic;
   signal DevRDSel_DUMMY : std_logic_vector (7 downto 0);
   signal DevWRSel_DUMMY : std_logic_vector (7 downto 0);
   component KRL_DANTE_ADDR_DECODE
      port ( CPU_CSn  : in    std_logic; 
             CPU_RDn  : in    std_logic; 
             CPU_WRn  : in    std_logic; 
             FPGA_Clk : in    std_logic; 
             FPGA_Rst : in    std_logic; 
             CPU_ADDR : in    std_logic_vector (6 downto 0); 
             CPU_DATA : in    std_logic_vector (7 downto 0); 
             DevRd    : out   std_logic; 
             DevWr    : out   std_logic; 
             RdOE     : out   std_logic; 
             DevAddr  : out   std_logic_vector (6 downto 0); 
             DevData  : out   std_logic_vector (7 downto 0); 
             DevRdSel : out   std_logic_vector (7 downto 0); 
             DevWrSel : out   std_logic_vector (7 downto 0); 
             RdSel    : out   std_logic_vector (2 downto 0));
   end component;
   
   component RD_DEVICE_MUSER_KDL
      port ( RST      : in    std_logic; 
             CLK      : in    std_logic; 
             DevRD    : in    std_logic; 
             DevRDSel : in    std_logic_vector (7 downto 0); 
             RD_PULSE : out   std_logic_vector (7 downto 0));
   end component;
   
   component WR_DEVICE_MUSER_KDL
      port ( RST         : in    std_logic; 
             CLK         : in    std_logic; 
             DevWRSel    : in    std_logic_vector (7 downto 0); 
             DevWR       : in    std_logic; 
             DevData     : in    std_logic_vector (7 downto 0); 
             DevAddr     : in    std_logic_vector (6 downto 0); 
             WR_PULSE    : out   std_logic_vector (7 downto 0); 
             WR_DEV_DATA : out   std_logic_vector (7 downto 0); 
             WR_DEV_ADDR : out   std_logic_vector (6 downto 0));
   end component;
   
begin
   DevRDSel(7 downto 0) <= DevRDSel_DUMMY(7 downto 0);
   DevWRSel(7 downto 0) <= DevWRSel_DUMMY(7 downto 0);
   ADDRESS_DECODER : KRL_DANTE_ADDR_DECODE
      port map (CPU_ADDR(6 downto 0)=>CPU_ADD(6 downto 0),
                CPU_CSn=>FPGA_SELECTn,
                CPU_DATA(7 downto 0)=>CPU_DIN(7 downto 0),
                CPU_RDn=>CPU_READn,
                CPU_WRn=>CPU_WRITEn,
                FPGA_Clk=>CLK,
                FPGA_Rst=>RESET,
                DevAddr(6 downto 0)=>DevAddr(6 downto 0),
                DevData(7 downto 0)=>DevData(7 downto 0),
                DevRd=>DevRD,
                DevRdSel(7 downto 0)=>DevRDSel_DUMMY(7 downto 0),
                DevWr=>DevWR,
                DevWrSel(7 downto 0)=>DevWRSel_DUMMY(7 downto 0),
                RdOE=>RdOEn,
                RdSel(2 downto 0)=>RdSel(2 downto 0));
   
   READDEVICESELECT : RD_DEVICE_MUSER_KDL
      port map (CLK=>CLK,
                DevRD=>DevRD,
                DevRDSel(7 downto 0)=>DevRDSel_DUMMY(7 downto 0),
                RST=>RESET,
                RD_PULSE(7 downto 0)=>RD_PULSE(7 downto 0));
   
   WRITEDEVICESELECT : WR_DEVICE_MUSER_KDL
      port map (CLK=>CLK,
                DevAddr(6 downto 0)=>DevAddr(6 downto 0),
                DevData(7 downto 0)=>DevData(7 downto 0),
                DevWR=>DevWR,
                DevWRSel(7 downto 0)=>DevWRSel_DUMMY(7 downto 0),
                RST=>RESET,
                WR_DEV_ADDR(6 downto 0)=>WR_DEV_ADDR(6 downto 0),
                WR_DEV_DATA(7 downto 0)=>WR_DEV_DATA(7 downto 0),
                WR_PULSE(7 downto 0)=>WR_PULSE(7 downto 0));
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity I2S16_TDM32_MUSER_KDL is
   port ( BP_AUD_SEL : in    std_logic_vector (3 downto 0); 
          I2S_IN     : in    std_logic_vector (15 downto 0); 
          RESYNC     : in    std_logic; 
          RST        : in    std_logic; 
          SCLK       : in    std_logic; 
          BP_AUD_OUT : out   std_logic_vector (31 downto 0); 
          I2S_BITCNT : out   std_logic_vector (4 downto 0); 
          I2S_HOLD   : out   std_logic);
end I2S16_TDM32_MUSER_KDL;

architecture BEHAVIORAL of I2S16_TDM32_MUSER_KDL is
   signal AOUT_A     : std_logic_vector (31 downto 0);
   signal AOUT_B     : std_logic_vector (31 downto 0);
   signal AOUT_C     : std_logic_vector (31 downto 0);
   signal AOUT_D     : std_logic_vector (31 downto 0);
   signal AOUT_E     : std_logic_vector (31 downto 0);
   signal AOUT_F     : std_logic_vector (31 downto 0);
   signal AOUT_G     : std_logic_vector (31 downto 0);
   signal AOUT_H     : std_logic_vector (31 downto 0);
   signal AOUT_I     : std_logic_vector (31 downto 0);
   signal AOUT_J     : std_logic_vector (31 downto 0);
   signal AOUT_K     : std_logic_vector (31 downto 0);
   signal AOUT_L     : std_logic_vector (31 downto 0);
   signal AOUT_M     : std_logic_vector (31 downto 0);
   signal AOUT_N     : std_logic_vector (31 downto 0);
   signal AOUT_O     : std_logic_vector (31 downto 0);
   signal AOUT_P     : std_logic_vector (31 downto 0);
   component Audio32_SIPO
      port ( S_IN  : in    std_logic; 
             CLK   : in    std_logic; 
             RSYNC : in    std_logic; 
             RST   : in    std_logic; 
             P_OUT : out   std_logic_vector (31 downto 0); 
             HOLD  : out   std_logic; 
             COUNT : out   std_logic_vector (4 downto 0));
   end component;
   
   component BUSMUX16X1X32
      port ( DAT_A  : in    std_logic_vector (31 downto 0); 
             DAT_B  : in    std_logic_vector (31 downto 0); 
             DAT_C  : in    std_logic_vector (31 downto 0); 
             DAT_D  : in    std_logic_vector (31 downto 0); 
             DAT_E  : in    std_logic_vector (31 downto 0); 
             DAT_F  : in    std_logic_vector (31 downto 0); 
             DAT_G  : in    std_logic_vector (31 downto 0); 
             DAT_H  : in    std_logic_vector (31 downto 0); 
             DAT_I  : in    std_logic_vector (31 downto 0); 
             DAT_J  : in    std_logic_vector (31 downto 0); 
             DAT_K  : in    std_logic_vector (31 downto 0); 
             DAT_L  : in    std_logic_vector (31 downto 0); 
             DAT_M  : in    std_logic_vector (31 downto 0); 
             DAT_N  : in    std_logic_vector (31 downto 0); 
             DAT_O  : in    std_logic_vector (31 downto 0); 
             DAT_P  : in    std_logic_vector (31 downto 0); 
             SEL    : in    std_logic_vector (3 downto 0); 
             MUXOUT : out   std_logic_vector (31 downto 0));
   end component;
   
begin
   AUDIN_SIPO0 : Audio32_SIPO
      port map (CLK=>SCLK,
                RST=>RST,
                RSYNC=>RESYNC,
                S_IN=>I2S_IN(0),
                COUNT(4 downto 0)=>I2S_BITCNT(4 downto 0),
                HOLD=>I2S_HOLD,
                P_OUT(31 downto 0)=>AOUT_A(31 downto 0));
   
   AUDIN_SIPO1 : Audio32_SIPO
      port map (CLK=>SCLK,
                RST=>RST,
                RSYNC=>RESYNC,
                S_IN=>I2S_IN(1),
                COUNT=>open,
                HOLD=>open,
                P_OUT(31 downto 0)=>AOUT_B(31 downto 0));
   
   AUDIN_SIPO2 : Audio32_SIPO
      port map (CLK=>SCLK,
                RST=>RST,
                RSYNC=>RESYNC,
                S_IN=>I2S_IN(2),
                COUNT=>open,
                HOLD=>open,
                P_OUT(31 downto 0)=>AOUT_C(31 downto 0));
   
   AUDIN_SIPO3 : Audio32_SIPO
      port map (CLK=>SCLK,
                RST=>RST,
                RSYNC=>RESYNC,
                S_IN=>I2S_IN(3),
                COUNT=>open,
                HOLD=>open,
                P_OUT(31 downto 0)=>AOUT_D(31 downto 0));
   
   AUDIN_SIPO4 : Audio32_SIPO
      port map (CLK=>SCLK,
                RST=>RST,
                RSYNC=>RESYNC,
                S_IN=>I2S_IN(4),
                COUNT=>open,
                HOLD=>open,
                P_OUT(31 downto 0)=>AOUT_E(31 downto 0));
   
   AUDIN_SIPO5 : Audio32_SIPO
      port map (CLK=>SCLK,
                RST=>RST,
                RSYNC=>RESYNC,
                S_IN=>I2S_IN(5),
                COUNT=>open,
                HOLD=>open,
                P_OUT(31 downto 0)=>AOUT_F(31 downto 0));
   
   AUDIN_SIPO6 : Audio32_SIPO
      port map (CLK=>SCLK,
                RST=>RST,
                RSYNC=>RESYNC,
                S_IN=>I2S_IN(6),
                COUNT=>open,
                HOLD=>open,
                P_OUT(31 downto 0)=>AOUT_G(31 downto 0));
   
   AUDIN_SIPO7 : Audio32_SIPO
      port map (CLK=>SCLK,
                RST=>RST,
                RSYNC=>RESYNC,
                S_IN=>I2S_IN(7),
                COUNT=>open,
                HOLD=>open,
                P_OUT(31 downto 0)=>AOUT_H(31 downto 0));
   
   AUDIN_SIPO8 : Audio32_SIPO
      port map (CLK=>SCLK,
                RST=>RST,
                RSYNC=>RESYNC,
                S_IN=>I2S_IN(8),
                COUNT=>open,
                HOLD=>open,
                P_OUT(31 downto 0)=>AOUT_I(31 downto 0));
   
   AUDIN_SIPO9 : Audio32_SIPO
      port map (CLK=>SCLK,
                RST=>RST,
                RSYNC=>RESYNC,
                S_IN=>I2S_IN(9),
                COUNT=>open,
                HOLD=>open,
                P_OUT(31 downto 0)=>AOUT_J(31 downto 0));
   
   AUDIN_SIPO10 : Audio32_SIPO
      port map (CLK=>SCLK,
                RST=>RST,
                RSYNC=>RESYNC,
                S_IN=>I2S_IN(10),
                COUNT=>open,
                HOLD=>open,
                P_OUT(31 downto 0)=>AOUT_K(31 downto 0));
   
   AUDIN_SIPO11 : Audio32_SIPO
      port map (CLK=>SCLK,
                RST=>RST,
                RSYNC=>RESYNC,
                S_IN=>I2S_IN(11),
                COUNT=>open,
                HOLD=>open,
                P_OUT(31 downto 0)=>AOUT_L(31 downto 0));
   
   AUDIN_SIPO12 : Audio32_SIPO
      port map (CLK=>SCLK,
                RST=>RST,
                RSYNC=>RESYNC,
                S_IN=>I2S_IN(12),
                COUNT=>open,
                HOLD=>open,
                P_OUT(31 downto 0)=>AOUT_M(31 downto 0));
   
   AUDIN_SIPO13 : Audio32_SIPO
      port map (CLK=>SCLK,
                RST=>RST,
                RSYNC=>RESYNC,
                S_IN=>I2S_IN(13),
                COUNT=>open,
                HOLD=>open,
                P_OUT(31 downto 0)=>AOUT_N(31 downto 0));
   
   AUDIN_SIPO14 : Audio32_SIPO
      port map (CLK=>SCLK,
                RST=>RST,
                RSYNC=>RESYNC,
                S_IN=>I2S_IN(14),
                COUNT=>open,
                HOLD=>open,
                P_OUT(31 downto 0)=>AOUT_O(31 downto 0));
   
   AUDIN_SIPO15 : Audio32_SIPO
      port map (CLK=>SCLK,
                RST=>RST,
                RSYNC=>RESYNC,
                S_IN=>I2S_IN(15),
                COUNT=>open,
                HOLD=>open,
                P_OUT(31 downto 0)=>AOUT_P(31 downto 0));
   
   I2S_TO_DANTE_MUX : BUSMUX16X1X32
      port map (DAT_A(31 downto 0)=>AOUT_A(31 downto 0),
                DAT_B(31 downto 0)=>AOUT_B(31 downto 0),
                DAT_C(31 downto 0)=>AOUT_C(31 downto 0),
                DAT_D(31 downto 0)=>AOUT_D(31 downto 0),
                DAT_E(31 downto 0)=>AOUT_E(31 downto 0),
                DAT_F(31 downto 0)=>AOUT_F(31 downto 0),
                DAT_G(31 downto 0)=>AOUT_G(31 downto 0),
                DAT_H(31 downto 0)=>AOUT_H(31 downto 0),
                DAT_I(31 downto 0)=>AOUT_I(31 downto 0),
                DAT_J(31 downto 0)=>AOUT_J(31 downto 0),
                DAT_K(31 downto 0)=>AOUT_K(31 downto 0),
                DAT_L(31 downto 0)=>AOUT_L(31 downto 0),
                DAT_M(31 downto 0)=>AOUT_M(31 downto 0),
                DAT_N(31 downto 0)=>AOUT_N(31 downto 0),
                DAT_O(31 downto 0)=>AOUT_O(31 downto 0),
                DAT_P(31 downto 0)=>AOUT_P(31 downto 0),
                SEL(3 downto 0)=>BP_AUD_SEL(3 downto 0),
                MUXOUT(31 downto 0)=>BP_AUD_OUT(31 downto 0));
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity BPI2S_MEMSTOR_MUSER_KDL is
   port ( BPCLK_FB         : in    std_logic; 
          BPI2S_DAT        : in    std_logic_vector (15 downto 0); 
          BPI2S_MRD        : in    std_logic; 
          BPI2S_MRDADDR    : in    std_logic_vector (4 downto 0); 
          I2S_RSYNC        : in    std_logic; 
          RST              : in    std_logic; 
          S_CLK            : in    std_logic; 
          BPI2S_AUD_DATA   : out   std_logic_vector (31 downto 0); 
          BPI2S_CHNCNT     : out   std_logic_vector (4 downto 0); 
          BPI2S_HOLD       : out   std_logic; 
          BPI2S_MADDR      : out   std_logic_vector (4 downto 0); 
          BPI2S_MSTOR_DAT  : out   std_logic_vector (31 downto 0); 
          BPI2S_MUXSEL     : out   std_logic_vector (3 downto 0); 
          BPI2S_MWR        : out   std_logic; 
          BPI2S_MXFR_STATE : out   std_logic_vector (2 downto 0); 
          BPI2S_XFRCYCLE   : out   std_logic);
end BPI2S_MEMSTOR_MUSER_KDL;

architecture BEHAVIORAL of BPI2S_MEMSTOR_MUSER_KDL is
   signal BPI2S_BITCNT         : std_logic_vector (4 downto 0);
   signal BPI2S_MUXSEL_DUMMY   : std_logic_vector (3 downto 0);
   signal BPI2S_CHNCNT_DUMMY   : std_logic_vector (4 downto 0);
   signal BPI2S_AUD_DATA_DUMMY : std_logic_vector (31 downto 0);
   signal BPI2S_MADDR_DUMMY    : std_logic_vector (4 downto 0);
   signal BPI2S_HOLD_DUMMY     : std_logic;
   signal BPI2S_MWR_DUMMY      : std_logic;
   component BPI2S_XFERMEM_WRITE
      port ( BPI2SRSYNC : in    std_logic; 
             BPI2SHOLD  : in    std_logic; 
             BPMCLK     : in    std_logic; 
             RST        : in    std_logic; 
             BPI2SCHNL  : in    std_logic_vector (4 downto 0); 
             BPI2S_SEL  : out   std_logic_vector (3 downto 0); 
             BPI2S_ADDR : out   std_logic_vector (4 downto 0); 
             BPI2S_WR   : out   std_logic; 
             STATE      : out   std_logic_vector (2 downto 0); 
             TRANSFER   : out   std_logic);
   end component;
   
   component SP3A_Cnt32_PS15
      port ( CE        : in    std_logic; 
             CLK       : in    std_logic; 
             SINIT     : in    std_logic; 
             Q_THRESH0 : out   std_logic; 
             Q         : out   std_logic_vector (4 downto 0));
   end component;
   
   component I2S16_TDM32_MUSER_KDL
      port ( I2S_IN     : in    std_logic_vector (15 downto 0); 
             RST        : in    std_logic; 
             SCLK       : in    std_logic; 
             RESYNC     : in    std_logic; 
             BP_AUD_SEL : in    std_logic_vector (3 downto 0); 
             BP_AUD_OUT : out   std_logic_vector (31 downto 0); 
             I2S_BITCNT : out   std_logic_vector (4 downto 0); 
             I2S_HOLD   : out   std_logic);
   end component;
   
   component SP3A_DpRAM_32x32
      port ( addra : in    std_logic_vector (4 downto 0); 
             dina  : in    std_logic_vector (31 downto 0); 
             wea   : in    std_logic_vector (0 downto 0); 
             clka  : in    std_logic; 
             addrb : in    std_logic_vector (4 downto 0); 
             doutb : out   std_logic_vector (31 downto 0); 
             enb   : in    std_logic; 
             clkb  : in    std_logic);
   end component;
   
begin
   BPI2S_AUD_DATA(31 downto 0) <= BPI2S_AUD_DATA_DUMMY(31 downto 0);
   BPI2S_CHNCNT(4 downto 0) <= BPI2S_CHNCNT_DUMMY(4 downto 0);
   BPI2S_HOLD <= BPI2S_HOLD_DUMMY;
   BPI2S_MADDR(4 downto 0) <= BPI2S_MADDR_DUMMY(4 downto 0);
   BPI2S_MUXSEL(3 downto 0) <= BPI2S_MUXSEL_DUMMY(3 downto 0);
   BPI2S_MWR <= BPI2S_MWR_DUMMY;
   BPI2S_MSTOR_WRITE : BPI2S_XFERMEM_WRITE
      port map (BPI2SCHNL(4 downto 0)=>BPI2S_CHNCNT_DUMMY(4 downto 0),
                BPI2SHOLD=>BPI2S_HOLD_DUMMY,
                BPI2SRSYNC=>I2S_RSYNC,
                BPMCLK=>BPCLK_FB,
                RST=>RST,
                BPI2S_ADDR(4 downto 0)=>BPI2S_MADDR_DUMMY(4 downto 0),
                BPI2S_SEL(3 downto 0)=>BPI2S_MUXSEL_DUMMY(3 downto 0),
                BPI2S_WR=>BPI2S_MWR_DUMMY,
                STATE(2 downto 0)=>BPI2S_MXFR_STATE(2 downto 0),
                TRANSFER=>BPI2S_XFRCYCLE);
   
   BPI2S_PSUEDO_CHNCNT : SP3A_Cnt32_PS15
      port map (CE=>BPI2S_BITCNT(0),
                CLK=>S_CLK,
                SINIT=>I2S_RSYNC,
                Q(4 downto 0)=>BPI2S_CHNCNT_DUMMY(4 downto 0),
                Q_THRESH0=>open);
   
   BPI2S_TO_BPMSTOR_MUX : I2S16_TDM32_MUSER_KDL
      port map (BP_AUD_SEL(3 downto 0)=>BPI2S_MUXSEL_DUMMY(3 downto 0),
                I2S_IN(15 downto 0)=>BPI2S_DAT(15 downto 0),
                RESYNC=>I2S_RSYNC,
                RST=>RST,
                SCLK=>S_CLK,
                BP_AUD_OUT(31 downto 0)=>BPI2S_AUD_DATA_DUMMY(31 downto 0),
                I2S_BITCNT(4 downto 0)=>BPI2S_BITCNT(4 downto 0),
                I2S_HOLD=>BPI2S_HOLD_DUMMY);
   
   BPI2S_XFER_MSTOR : SP3A_DpRAM_32x32
      port map (addra(4 downto 0)=>BPI2S_MADDR_DUMMY(4 downto 0),
                addrb(4 downto 0)=>BPI2S_MRDADDR(4 downto 0),
                clka=>BPCLK_FB,
                clkb=>BPCLK_FB,
                dina(31 downto 0)=>BPI2S_AUD_DATA_DUMMY(31 downto 0),
                enb=>BPI2S_MRD,
                wea(0)=>BPI2S_MWR_DUMMY,
                doutb(31 downto 0)=>BPI2S_MSTOR_DAT(31 downto 0));
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity KDL is
   port ( BPI2S_DIN         : in    std_logic_vector (15 downto 0); 
          BP_LRCLK          : in    std_logic; 
          BP_MCLK           : in    std_logic; 
          DANTE_LRCLK       : in    std_logic; 
          DANTE_MCLK        : in    std_logic; 
          DANTE_PHY_RST     : in    std_logic; 
          DANTE_SCLK        : in    std_logic; 
          D_DIN0            : in    std_logic; 
          D_DIN1            : in    std_logic; 
          D_DIN2            : in    std_logic; 
          D_DIN3            : in    std_logic; 
          FPGA_CSn          : in    std_logic; 
          GE_STATUS         : in    std_logic_vector (4 downto 0); 
          MCU_ADDR          : in    std_logic_vector (6 downto 0); 
          MCU_RDn           : in    std_logic; 
          MCU_WRn           : in    std_logic; 
          RSTn              : in    std_logic; 
          BP_FRAMESYNC      : out   std_logic; 
          BP_LVDS_OUT       : out   std_logic; 
          BP_RSYNC          : out   std_logic; 
          BP_STATE_FD       : out   std_logic_vector (9 downto 0); 
          CLKDSTRB_ST       : out   std_logic_vector (3 downto 0); 
          CLK_DCM_RST       : out   std_logic; 
          DANTE_RSTn        : out   std_logic; 
          DANTE_SCLK_FX     : out   std_logic; 
          DANTE_SCLK_FX180  : out   std_logic; 
          DLRCLK_OUT        : out   std_logic; 
          DSCLK_OUT         : out   std_logic; 
          D_SDOUT_LD        : out   std_logic; 
          D_SDO_0           : out   std_logic; 
          D_SDO_1           : out   std_logic; 
          D_SDO_2           : out   std_logic; 
          D_SDO_3           : out   std_logic; 
          ENABLE_TRANSFERSn : out   std_logic; 
          ERR_INTn          : out   std_logic; 
          GE_LED            : out   std_logic_vector (1 downto 0); 
          I2S_FRAMESYNC     : out   std_logic; 
          I2S_RSYNC         : out   std_logic; 
          I2S_STATE         : out   std_logic_vector (5 downto 0); 
          PHY_RSTn          : out   std_logic; 
          TP_A0             : out   std_logic; 
          TP_A1             : out   std_logic; 
          TP_A2             : out   std_logic; 
          TP_A3             : out   std_logic; 
          TP_A4             : out   std_logic; 
          TP_A5             : out   std_logic; 
          TP_A6             : out   std_logic; 
          TP_A7             : out   std_logic; 
          TP_B0             : out   std_logic; 
          TP_B1             : out   std_logic; 
          TP_B2             : out   std_logic; 
          TP_B3             : out   std_logic; 
          TP_B4             : out   std_logic; 
          TP_B5             : out   std_logic; 
          TP_B6             : out   std_logic; 
          TP_B7             : out   std_logic; 
          MCU_BIDAT         : inout std_logic_vector (7 downto 0));
end KDL;

architecture BEHAVIORAL of KDL is
   attribute IOSTANDARD            : string ;
   attribute SLEW                  : string ;
   attribute DRIVE                 : string ;
   attribute IBUF_DELAY_VALUE      : string ;
   attribute IFD_DELAY_VALUE       : string ;
   attribute BOX_TYPE              : string ;
   attribute CLK_FEEDBACK          : string ;
   attribute CLKDV_DIVIDE          : string ;
   attribute CLKFX_DIVIDE          : string ;
   attribute CLKIN_PERIOD          : string ;
   attribute CLKFX_MULTIPLY        : string ;
   attribute CLKIN_DIVIDE_BY_2     : string ;
   attribute CLKOUT_PHASE_SHIFT    : string ;
   attribute DESKEW_ADJUST         : string ;
   attribute DFS_FREQUENCY_MODE    : string ;
   attribute DLL_FREQUENCY_MODE    : string ;
   attribute DSS_MODE              : string ;
   attribute DUTY_CYCLE_CORRECTION : string ;
   attribute PHASE_SHIFT           : string ;
   attribute STARTUP_WAIT          : string ;
   attribute FACTORY_JF            : string ;
   attribute HU_SET                : string ;
   signal ALLOW_WRDCLK_RSYNC      : std_logic;
   signal AT_MCLK                 : std_logic;
   signal BGND                    : std_logic_vector (7 downto 0);
   signal BKII_RST                : std_logic;
   signal BPCLK_FB                : std_logic;
   signal BPCLK0_FB               : std_logic;
   signal BPCLK270                : std_logic;
   signal BPDCM_WRD_RSYNC         : std_logic;
   signal BPI2S_DAT               : std_logic_vector (15 downto 0);
   signal BPI2S_FIFO_WR           : std_logic;
   signal BPI2S_FIFO_WR_DLY       : std_logic;
   signal BPI2S_MRD               : std_logic;
   signal BPI2S_MRD_ADDR          : std_logic_vector (4 downto 0);
   signal BPI2S_MSTOR_DAT         : std_logic_vector (31 downto 0);
   signal BPI2S_XFRCYCLE          : std_logic;
   signal BPMCLK_IN               : std_logic;
   signal BPMEM_WR                : std_logic;
   signal BPMEM_WRADDR            : std_logic_vector (4 downto 0);
   signal BPMSTOR_WR              : std_logic;
   signal BPMSTOR_WRADDR          : std_logic_vector (4 downto 0);
   signal BP_DCM_ALLOW_RST        : std_logic;
   signal BP_DCM_RST              : std_logic;
   signal BP_DMSTOR_WADDR         : std_logic_vector (4 downto 0);
   signal BP_DMSTOR_WREN          : std_logic;
   signal BP_FRAME_DELAY          : std_logic_vector (4 downto 0);
   signal BP_LOCKED               : std_logic;
   signal BP_LRCLK_EDGE           : std_logic;
   signal BP_RXFIFO_XFRCYCLE      : std_logic;
   signal BP_RXFRAME_DLY          : std_logic_vector (10 downto 0);
   signal BP_RXRDEN               : std_logic;
   signal BP_RXWREN               : std_logic;
   signal BP_STATE                : std_logic_vector (9 downto 0);
   signal BP_TXFRAME_DLY          : std_logic_vector (10 downto 0);
   signal BROOK_WRD_RSYNC         : std_logic;
   signal CHECK_WINDOW            : std_logic;
   signal CLKGEN_DSCLK            : std_logic;
   signal CLR_ALLOW               : std_logic;
   signal CONTROL                 : std_logic_vector (7 downto 0);
   signal CPHS_RST                : std_logic;
   signal DANTE_CHNL_HOLD         : std_logic;
   signal DANTE_FRAME_DELAY       : std_logic_vector (4 downto 0);
   signal DANTE_MSTOR_DAT         : std_logic_vector (31 downto 0);
   signal DANTE_RD_RESYNC         : std_logic;
   signal DANTE_RESET             : std_logic;
   signal DANTE_WR_RESYNC         : std_logic;
   signal DC_RST                  : std_logic;
   signal DDCMS_LOCKED            : std_logic;
   signal DEAD_CLOCK              : std_logic;
   signal DMSTOR_RD               : std_logic;
   signal DMSTOR_RDADDR           : std_logic_vector (4 downto 0);
   signal DSCKMUX                 : std_logic;
   signal DTDM0_LD                : std_logic;
   signal DTDM1_LD                : std_logic;
   signal DTXPISO_SIG             : std_logic_vector (7 downto 0);
   signal DTX_FIFO_RD             : std_logic;
   signal D_AUD_RXTX_RST          : std_logic;
   signal D_LRCLK                 : std_logic;
   signal D_MCLK                  : std_logic;
   signal D_RXCHNL_COUNT          : std_logic_vector (3 downto 0);
   signal D_RXFIFO_BPDATA         : std_logic_vector (31 downto 0);
   signal D_RXFIFO_RD_VALID       : std_logic;
   signal D_RXWCH_SEL             : std_logic_vector (1 downto 0);
   signal D_RX_MEM_BSWAP          : std_logic;
   signal D_RX_OVRFLOW            : std_logic;
   signal D_RX_UDRFLOW            : std_logic;
   signal D_SCLK                  : std_logic;
   signal D_SDOUT_LD_DLY          : std_logic;
   signal D_TXCHNL_COUNT          : std_logic_vector (3 downto 0);
   signal D_TXFIFO_XPT_RADDR      : std_logic_vector (4 downto 0);
   signal D_TXLD_ENA              : std_logic;
   signal D_TX_OVRFLOW            : std_logic;
   signal D_TX_UDRFLOW            : std_logic;
   signal ERROR_STAT              : std_logic_vector (7 downto 0);
   signal ERR_INTERRUPTn          : std_logic;
   signal FIFO_STAT               : std_logic_vector (3 downto 0);
   signal FPGATYPE                : std_logic_vector (7 downto 0);
   signal FPGAVERS                : std_logic_vector (7 downto 0);
   signal GE_STAT                 : std_logic_vector (4 downto 0);
   signal I2S_LRCLK_EDGE          : std_logic;
   signal MCLK_SCLK_FB            : std_logic;
   signal MCU_DIN                 : std_logic_vector (7 downto 0);
   signal MCU_DOUT                : std_logic_vector (7 downto 0);
   signal PHY_RESET               : std_logic;
   signal PWR_ON_RST              : std_logic;
   signal RDMUX_SEL               : std_logic_vector (2 downto 0);
   signal RD_DEV                  : std_logic_vector (7 downto 0);
   signal RD_DEVSEL               : std_logic_vector (7 downto 0);
   signal RD_OEn                  : std_logic;
   signal READ_DATAn              : std_logic;
   signal RELEASE_D_LOGICn        : std_logic;
   signal RESET                   : std_logic;
   signal RST                     : std_logic;
   signal RXFIFO_CHNCNT           : std_logic_vector (9 downto 0);
   signal SET_ALLOW               : std_logic;
   signal THREE_SEC_BLOCK         : std_logic;
   signal TXFIFO_CHNCNT           : std_logic_vector (9 downto 0);
   signal WINDOWRSYNC             : std_logic;
   signal WORDCLK_RESYNC          : std_logic;
   signal WRDCNTSYNC              : std_logic;
   signal WR_DATA                 : std_logic_vector (7 downto 0);
   signal WR_DEV                  : std_logic_vector (7 downto 0);
   signal XLXN_181                : std_logic;
   signal XLXN_220                : std_logic;
   signal XLXN_277                : std_logic;
   signal XLXN_278                : std_logic;
   signal XLXN_290                : std_logic;
   signal XLXN_291                : std_logic;
   signal XLXN_301                : std_logic;
   signal XLXN_314                : std_logic;
   signal XLXN_416                : std_logic;
   signal XLXN_502                : std_logic;
   signal XLXN_950                : std_logic;
   signal XLXN_951                : std_logic;
   signal XLXN_952                : std_logic;
   signal XLXN_953                : std_logic;
   signal XLXN_954                : std_logic;
   signal XLXN_955                : std_logic;
   signal XLXN_956                : std_logic;
   signal XLXN_957                : std_logic;
   signal XLXN_964                : std_logic;
   signal XLXN_1120               : std_logic;
   signal XLXN_1121               : std_logic;
   signal XLXN_1123               : std_logic;
   signal XLXN_1125               : std_logic;
   signal XLXN_1127               : std_logic;
   signal XLXN_1128               : std_logic;
   signal XLXN_1129               : std_logic;
   signal XLXN_1194               : std_logic;
   signal XLXN_1218               : std_logic;
   signal XLXN_1266               : std_logic;
   signal XLXN_1267               : std_logic;
   signal XLXN_1276               : std_logic;
   signal XLXN_1284               : std_logic;
   signal XLXN_1288               : std_logic;
   signal XLXN_1289               : std_logic;
   signal XLXN_1291               : std_logic;
   signal XLXN_1296               : std_logic;
   signal XLXN_1299               : std_logic;
   signal XLXN_1300               : std_logic;
   signal ZG                      : std_logic;
   signal ZV                      : std_logic;
   signal BP_LVDS_OUT_DUMMY       : std_logic;
   signal DANTE_SCLK_FX_DUMMY     : std_logic;
   signal CLK_DCM_RST_DUMMY       : std_logic;
   signal ENABLE_TRANSFERSn_DUMMY : std_logic;
   signal I2S_RSYNC_DUMMY         : std_logic;
   signal I2S_FRAMESYNC_DUMMY     : std_logic;
   signal BP_RSYNC_DUMMY          : std_logic;
   signal BP_FRAMESYNC_DUMMY      : std_logic;
   component BP_SCLKFX_ALIGN_MUSER_KDL
      port ( BPLRCLK           : in    std_logic; 
             BPMCLK            : in    std_logic; 
             RST               : in    std_logic; 
             BPMCLK_FB         : in    std_logic; 
             BPMCLK_DCM_LOCKED : in    std_logic; 
             SCLKGEN_FB        : out   std_logic; 
             SCLKGEN_180       : out   std_logic; 
             BPSCLKGEN_LOCK    : out   std_logic; 
             CLKGEN_DSCLK      : out   std_logic; 
             SCLKGEN_3M        : out   std_logic; 
             CLKGEN_DLRCLK     : out   std_logic);
   end component;
   
   component IOBUF
      port ( I  : in    std_logic; 
             IO : inout std_logic; 
             O  : out   std_logic; 
             T  : in    std_logic);
   end component;
   attribute IOSTANDARD of IOBUF : component is "DEFAULT";
   attribute SLEW of IOBUF : component is "SLOW";
   attribute DRIVE of IOBUF : component is "12";
   attribute IBUF_DELAY_VALUE of IOBUF : component is "0";
   attribute IFD_DELAY_VALUE of IOBUF : component is "AUTO";
   attribute BOX_TYPE of IOBUF : component is "BLACK_BOX";
   
   component BROOKLYN_RESET
      port ( CLK  : in    std_logic; 
             RST  : in    std_logic; 
             TCNT : out   std_logic);
   end component;
   
   component FD
      generic( INIT : bit :=  '0');
      port ( C : in    std_logic; 
             D : in    std_logic; 
             Q : out   std_logic);
   end component;
   attribute BOX_TYPE of FD : component is "BLACK_BOX";
   
   component BPI2S_MEMSTOR_MUSER_KDL
      port ( BPI2S_AUD_DATA   : out   std_logic_vector (31 downto 0); 
             BPI2S_DAT        : in    std_logic_vector (15 downto 0); 
             I2S_RSYNC        : in    std_logic; 
             S_CLK            : in    std_logic; 
             BPI2S_HOLD       : out   std_logic; 
             BPI2S_MUXSEL     : out   std_logic_vector (3 downto 0); 
             BPI2S_CHNCNT     : out   std_logic_vector (4 downto 0); 
             RST              : in    std_logic; 
             BPCLK_FB         : in    std_logic; 
             BPI2S_MRD        : in    std_logic; 
             BPI2S_MRDADDR    : in    std_logic_vector (4 downto 0); 
             BPI2S_MADDR      : out   std_logic_vector (4 downto 0); 
             BPI2S_MWR        : out   std_logic; 
             BPI2S_MSTOR_DAT  : out   std_logic_vector (31 downto 0); 
             BPI2S_MXFR_STATE : out   std_logic_vector (2 downto 0); 
             BPI2S_XFRCYCLE   : out   std_logic);
   end component;
   
   component BPI2S_MEMXFER
      port ( MSTOR_CYC_DONE : in    std_logic; 
             BPMCLK         : in    std_logic; 
             RST            : in    std_logic; 
             STATE          : out   std_logic_vector (1 downto 0); 
             BPI2S_MRD      : out   std_logic; 
             BPI2S_MRD_ADDR : out   std_logic_vector (4 downto 0); 
             BPI2S_FIFO_WR  : out   std_logic);
   end component;
   
   component LRCLK_EdgeCount_1024_3FD
      port ( clk       : in    std_logic; 
             sclr      : in    std_logic; 
             q         : out   std_logic_vector (9 downto 0); 
             q_thresh0 : out   std_logic);
   end component;
   
   component BUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of BUF : component is "BLACK_BOX";
   
   component WDCLKSYNC_TCNT
      port ( CLK  : in    std_logic; 
             RST  : in    std_logic; 
             TCNT : out   std_logic);
   end component;
   
   component DCM_UNLOCK_RESET_MUSER_KDL
      port ( LRCLK       : in    std_logic; 
             DCM_LOCKEDn : in    std_logic; 
             RESET       : in    std_logic; 
             DCM_RESET   : out   std_logic);
   end component;
   
   component DCM_SP
      -- synopsys translate_off
      generic( CLK_FEEDBACK : string :=  "1X";
               CLKDV_DIVIDE : real :=  2.0;
               CLKFX_DIVIDE : integer :=  1;
               CLKIN_PERIOD : real :=  10.0;
               CLKFX_MULTIPLY : integer :=  4;
               CLKIN_DIVIDE_BY_2 : boolean :=  FALSE;
               CLKOUT_PHASE_SHIFT : string :=  "NONE";
               DESKEW_ADJUST : string :=  "SYSTEM_SYNCHRONOUS";
               DFS_FREQUENCY_MODE : string :=  "LOW";
               DLL_FREQUENCY_MODE : string :=  "LOW";
               DSS_MODE : string :=  "NONE";
               DUTY_CYCLE_CORRECTION : boolean :=  TRUE;
               PHASE_SHIFT : integer :=  0;
               STARTUP_WAIT : boolean :=  FALSE;
               FACTORY_JF : bit_vector :=  x"C080");
      -- synopsys translate_on
      port ( CLKFB    : in    std_logic; 
             CLKIN    : in    std_logic; 
             DSSEN    : in    std_logic; 
             PSCLK    : in    std_logic; 
             PSEN     : in    std_logic; 
             PSINCDEC : in    std_logic; 
             RST      : in    std_logic; 
             CLK0     : out   std_logic; 
             CLK180   : out   std_logic; 
             CLK270   : out   std_logic; 
             CLK2X    : out   std_logic; 
             CLK2X180 : out   std_logic; 
             CLK90    : out   std_logic; 
             CLKDV    : out   std_logic; 
             CLKFX    : out   std_logic; 
             CLKFX180 : out   std_logic; 
             LOCKED   : out   std_logic; 
             PSDONE   : out   std_logic; 
             STATUS   : out   std_logic_vector (7 downto 0));
   end component;
   attribute CLK_FEEDBACK of DCM_SP : component is "1X";
   attribute CLKDV_DIVIDE of DCM_SP : component is "2.0";
   attribute CLKFX_DIVIDE of DCM_SP : component is "1";
   attribute CLKIN_PERIOD of DCM_SP : component is "10.0";
   attribute CLKFX_MULTIPLY of DCM_SP : component is "4";
   attribute CLKIN_DIVIDE_BY_2 of DCM_SP : component is "FALSE";
   attribute CLKOUT_PHASE_SHIFT of DCM_SP : component is "NONE";
   attribute DESKEW_ADJUST of DCM_SP : component is "SYSTEM_SYNCHRONOUS";
   attribute DFS_FREQUENCY_MODE of DCM_SP : component is "LOW";
   attribute DLL_FREQUENCY_MODE of DCM_SP : component is "LOW";
   attribute DSS_MODE of DCM_SP : component is "NONE";
   attribute DUTY_CYCLE_CORRECTION of DCM_SP : component is "TRUE";
   attribute PHASE_SHIFT of DCM_SP : component is "0";
   attribute STARTUP_WAIT of DCM_SP : component is "FALSE";
   attribute FACTORY_JF of DCM_SP : component is "C080";
   attribute BOX_TYPE of DCM_SP : component is "BLACK_BOX";
   
   component SP3A_Reg5En_PS8
      port ( D     : in    std_logic_vector (4 downto 0); 
             CE    : in    std_logic; 
             CLK   : in    std_logic; 
             SINIT : in    std_logic; 
             Q     : out   std_logic_vector (4 downto 0));
   end component;
   
   component LRCLK_EdgeCount_1024_29
      port ( clk       : in    std_logic; 
             sclr      : in    std_logic; 
             q         : out   std_logic_vector (9 downto 0); 
             q_thresh0 : out   std_logic);
   end component;
   
   component SP3A_Reg6
      port ( D   : in    std_logic_vector (5 downto 0); 
             Q   : out   std_logic_vector (5 downto 0); 
             CLK : in    std_logic);
   end component;
   
   component ClockDisturbance_SM
      port ( POR         : in    std_logic; 
             DeadClk     : in    std_logic; 
             ClkPhse     : in    std_logic; 
             Clk         : in    std_logic; 
             LRClk       : in    std_logic; 
             Reset       : in    std_logic; 
             StateOut    : out   std_logic_vector (3 downto 0); 
             DeadClk_RST : out   std_logic; 
             ClkPhse_RST : out   std_logic);
   end component;
   
   component Rising_Edge
      port ( CLK         : in    std_logic; 
             R_EDGE      : in    std_logic; 
             EDGE_DETECT : out   std_logic);
   end component;
   
   component SP3A_Reg8E_PS_12
      port ( D     : in    std_logic_vector (7 downto 0); 
             CE    : in    std_logic; 
             CLK   : in    std_logic; 
             Q     : out   std_logic_vector (7 downto 0); 
             SINIT : in    std_logic);
   end component;
   
   component Dante_RW_Clocking_MUSER_KDL
      port ( D_RXWCH_SEL       : in    std_logic_vector (1 downto 0); 
             BP_RX_WREN        : in    std_logic; 
             BP_RX_RDEN        : in    std_logic; 
             BP_TX_WREN        : in    std_logic; 
             BP_TX_RDEN        : in    std_logic; 
             BP_CHNDAT         : in    std_logic_vector (31 downto 0); 
             D_RX_FIFOCNT      : out   std_logic_vector (9 downto 0); 
             D_RX_FFULL        : out   std_logic; 
             D_RX_FAFULL       : out   std_logic; 
             D_RX_WR_ACK       : out   std_logic; 
             D_RX_OVRFLOW      : out   std_logic; 
             D_RX_BP_DOUT      : out   std_logic_vector (31 downto 0); 
             D_RX_FEMPTY       : out   std_logic; 
             D_RX_FAEMPTY      : out   std_logic; 
             D_RX_RDVALID      : out   std_logic; 
             D_RX_UDRFLOW      : out   std_logic; 
             D_TX_FIFOCNT      : out   std_logic_vector (9 downto 0); 
             D_TX_FFULL        : out   std_logic; 
             D_TX_FAFULL       : out   std_logic; 
             D_TX_WR_ACK       : out   std_logic; 
             D_TX_OVRFLOW      : out   std_logic; 
             D_TX_FEMPTY       : out   std_logic; 
             D_TX_FAEMPTY      : out   std_logic; 
             D_TX_RDVALID      : out   std_logic; 
             D_TX_UDRFLOW      : out   std_logic; 
             D_TX_BP_DOUT      : out   std_logic_vector (31 downto 0); 
             D_SDO_0           : out   std_logic; 
             D_SDO_1           : out   std_logic; 
             D_SDO_2           : out   std_logic; 
             D_SDO_3           : out   std_logic; 
             DANTE_TDM0_LD     : in    std_logic; 
             DANTE_TDM1_LD     : in    std_logic; 
             DANTE_TDM2_LD     : in    std_logic; 
             DANTE_TDM3_LD     : in    std_logic; 
             DANTE_PISO_LD     : out   std_logic; 
             D_SCLK            : in    std_logic; 
             D_SDIN_0          : in    std_logic; 
             D_SDIN_1          : in    std_logic; 
             D_SDIN_2          : in    std_logic; 
             D_SDIN_3          : in    std_logic; 
             D_LRCLK           : in    std_logic; 
             D_LRCLK_EDGE      : out   std_logic; 
             DANTE_WR_RESYNC   : out   std_logic; 
             DANTE_RX_STATE    : out   std_logic_vector (8 downto 0); 
             DANTE_CHNDAT      : out   std_logic_vector (31 downto 0); 
             D_CHNL_HOLD       : out   std_logic; 
             DANTE_BIT_STATE   : out   std_logic_vector (8 downto 0); 
             D_RXCHNL_COUNT    : out   std_logic_vector (3 downto 0); 
             DANTE_RD_RESYNC   : out   std_logic; 
             DANTE_TX_STATE    : out   std_logic_vector (8 downto 0); 
             D_TXCHNL_COUNT    : out   std_logic_vector (3 downto 0); 
             D_MCLK            : in    std_logic; 
             DCLK_25M_INV      : out   std_logic; 
             DCLK_25M          : out   std_logic; 
             D_DCM_RST         : in    std_logic; 
             D_SCLK_SEL        : in    std_logic; 
             BPCLK_FB          : in    std_logic; 
             BPSCLK_FB         : in    std_logic; 
             DANTE_PISO_LD_DLY : out   std_logic; 
             DDCM_RST          : out   std_logic; 
             D_RXTX_FIFO_RST   : in    std_logic; 
             RST               : in    std_logic; 
             DDCMS_LOCKED      : out   std_logic);
   end component;
   
   component TCNT_30SEC
      port ( CLK  : in    std_logic; 
             RST  : in    std_logic; 
             TCNT : out   std_logic);
   end component;
   
   component SP3A_DpRAM_32x32
      port ( addra : in    std_logic_vector (4 downto 0); 
             dina  : in    std_logic_vector (31 downto 0); 
             wea   : in    std_logic_vector (0 downto 0); 
             clka  : in    std_logic; 
             addrb : in    std_logic_vector (4 downto 0); 
             doutb : out   std_logic_vector (31 downto 0); 
             enb   : in    std_logic; 
             clkb  : in    std_logic);
   end component;
   
   component krl_dante_rom_32x32
      port ( a   : in    std_logic_vector (4 downto 0); 
             spo : out   std_logic_vector (4 downto 0));
   end component;
   
   component SP3A_Siso4_PSet
      port ( SDIN  : in    std_logic; 
             CLK   : in    std_logic; 
             ASET  : in    std_logic; 
             SDOUT : out   std_logic);
   end component;
   
   component DeadClock_MUSER_KDL
      port ( BP_MCLK    : in    std_logic; 
             RESET      : in    std_logic; 
             POR        : in    std_logic; 
             D_MCLK     : in    std_logic; 
             BPCLK_CNT  : out   std_logic_vector (23 downto 0); 
             DEAD_CLOCK : out   std_logic);
   end component;
   
   component M2_1_HXILINX_KDL
      port ( D0 : in    std_logic; 
             D1 : in    std_logic; 
             S0 : in    std_logic; 
             O  : out   std_logic);
   end component;
   
   component OBUFT
      port ( I : in    std_logic; 
             T : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute IOSTANDARD of OBUFT : component is "DEFAULT";
   attribute SLEW of OBUFT : component is "SLOW";
   attribute DRIVE of OBUFT : component is "12";
   attribute BOX_TYPE of OBUFT : component is "BLACK_BOX";
   
   component DANTE_RX_FIFO_READ
      port ( RST              : in    std_logic; 
             D_RXFIFO_RDVALID : in    std_logic; 
             D_RSYNC_RESET    : in    std_logic; 
             D_RXFIFO_CHNCNT  : in    std_logic_vector (12 downto 0); 
             D_RXFIFO_RDEN    : out   std_logic; 
             STATE            : out   std_logic_vector (2 downto 0); 
             BP_FRAME_DELAY   : in    std_logic_vector (12 downto 0); 
             BP_RESYNC        : in    std_logic; 
             BP_DMSTOR_BSWAP  : in    std_logic; 
             BP_CLK           : in    std_logic; 
             BP_DMSTOR_WREN   : out   std_logic; 
             BP_DMSTOR_WADDR  : out   std_logic_vector (4 downto 0); 
             D_RXFIFO_XFREN   : out   std_logic);
   end component;
   
   component DANTE_RXMEM_TO_BPMEM
      port ( FIFO_XFR_DONE : in    std_logic; 
             BP_CLK        : in    std_logic; 
             RST           : in    std_logic; 
             MEM_RDADDR    : out   std_logic_vector (4 downto 0); 
             MEM_RD        : out   std_logic; 
             MEM_WRADDR    : out   std_logic_vector (4 downto 0); 
             MEM_WR        : out   std_logic; 
             STATE         : out   std_logic_vector (2 downto 0));
   end component;
   
   component XFRMEM32_MUSER_KDL
      port ( XFRMEM_WE     : in    std_logic; 
             XFRMEM_DIN    : in    std_logic_vector (31 downto 0); 
             XFRMEM_WRADDR : in    std_logic_vector (4 downto 0); 
             XFRHLD_EN     : out   std_logic; 
             XFRMEM_RDADDR : out   std_logic_vector (5 downto 0); 
             BS_DETECT     : out   std_logic; 
             XFRMEM_WR     : out   std_logic_vector (5 downto 0); 
             XFRRDCNT_EN   : out   std_logic; 
             XFR_PISO_LD   : out   std_logic; 
             SDOUT1        : out   std_logic; 
             RST           : in    std_logic; 
             RSYNC         : in    std_logic; 
             CLK           : in    std_logic; 
             LR_CLK        : in    std_logic; 
             RSYNC_2LR     : out   std_logic);
   end component;
   
   component DANTE_TX_HOLD_WRITE
      port ( D_RDRSYNC       : in    std_logic; 
             D_CHN_LD        : in    std_logic; 
             BP_CLK          : in    std_logic; 
             RST             : in    std_logic; 
             D_CHNCNT        : in    std_logic_vector (3 downto 0); 
             D_TXFIFO_CHNCNT : in    std_logic_vector (12 downto 0); 
             D_TXFRAME_DELAY : in    std_logic_vector (12 downto 0); 
             D_TXLD_ENA      : out   std_logic; 
             STATE           : out   std_logic_vector (2 downto 0));
   end component;
   
   component SP3A_SIPO8_PS1
      port ( SDIN  : in    std_logic; 
             Q     : out   std_logic_vector (7 downto 0); 
             CLK   : in    std_logic; 
             SINIT : in    std_logic);
   end component;
   
   component DANTE_RX_FIFO_WRITE
      port ( D_RESYNC  : in    std_logic; 
             D_CHNHLD  : in    std_logic; 
             D_FIFO_WR : out   std_logic; 
             STATE     : out   std_logic_vector (2 downto 0); 
             D_SCLK    : in    std_logic; 
             RST       : in    std_logic; 
             D_CHNCNT  : in    std_logic_vector (3 downto 0); 
             D_CHNSEL  : out   std_logic_vector (1 downto 0));
   end component;
   
   component WRDCLKWINDOW
      port ( CLK       : in    std_logic; 
             RST       : in    std_logic; 
             CHKWINDOW : out   std_logic);
   end component;
   
   component ERROR_STATUS_MUSER_KDL
      port ( RST            : in    std_logic; 
             CLK            : in    std_logic; 
             ERROR_STATUS   : out   std_logic_vector (7 downto 0); 
             ERR_INPUT      : in    std_logic_vector (7 downto 0); 
             ERR_INTn       : out   std_logic; 
             ERR_STATUS_SEL : in    std_logic; 
             ERR_STATUS_RD  : in    std_logic);
   end component;
   
   component Falling_Edge
      port ( EDGE_DETECT : out   std_logic; 
             CLK         : in    std_logic; 
             F_EDGE      : in    std_logic);
   end component;
   
   component MICRO_IF_MUSER_KDL
      port ( CLK          : in    std_logic; 
             RESET        : in    std_logic; 
             CPU_ADD      : in    std_logic_vector (6 downto 0); 
             CPU_DIN      : in    std_logic_vector (7 downto 0); 
             DevWRSel     : out   std_logic_vector (7 downto 0); 
             WR_DEV_ADDR  : out   std_logic_vector (6 downto 0); 
             WR_DEV_DATA  : out   std_logic_vector (7 downto 0); 
             WR_PULSE     : out   std_logic_vector (7 downto 0); 
             DevRDSel     : out   std_logic_vector (7 downto 0); 
             RD_PULSE     : out   std_logic_vector (7 downto 0); 
             RdSel        : out   std_logic_vector (2 downto 0); 
             RdOEn        : out   std_logic; 
             CPU_WRITEn   : in    std_logic; 
             CPU_READn    : in    std_logic; 
             FPGA_SELECTn : in    std_logic);
   end component;
   
   component LRCLK_I2SEdgeCount_64_3E
      port ( clk       : in    std_logic; 
             sclr      : in    std_logic; 
             q         : out   std_logic_vector (5 downto 0); 
             q_thresh0 : out   std_logic);
   end component;
   
   component LRCLK_I2SEdgeCount_64
      port ( clk       : in    std_logic; 
             sclr      : in    std_logic; 
             q         : out   std_logic_vector (5 downto 0); 
             q_thresh0 : out   std_logic);
   end component;
   
   component BUSMUX8X1X8
      port ( DAT_A  : in    std_logic_vector (7 downto 0); 
             DAT_B  : in    std_logic_vector (7 downto 0); 
             DAT_C  : in    std_logic_vector (7 downto 0); 
             DAT_D  : in    std_logic_vector (7 downto 0); 
             DAT_E  : in    std_logic_vector (7 downto 0); 
             DAT_F  : in    std_logic_vector (7 downto 0); 
             DAT_G  : in    std_logic_vector (7 downto 0); 
             DAT_H  : in    std_logic_vector (7 downto 0); 
             SEL    : in    std_logic_vector (2 downto 0); 
             MUXOUT : out   std_logic_vector (7 downto 0));
   end component;
   
   component GND
      port ( G : out   std_logic);
   end component;
   attribute BOX_TYPE of GND : component is "BLACK_BOX";
   
   component MULTx32
      port ( a    : in    std_logic_vector (4 downto 0); 
             clk  : in    std_logic; 
             ce   : in    std_logic; 
             sclr : in    std_logic; 
             p    : out   std_logic_vector (10 downto 0));
   end component;
   
   component VerTypeInfo
      port ( FPGA_VERS : out   std_logic_vector (7 downto 0); 
             FPGA_TYPE : out   std_logic_vector (7 downto 0));
   end component;
   
   component OR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2 : component is "BLACK_BOX";
   
   component AND2B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2B1 : component is "BLACK_BOX";
   
   component INV
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of INV : component is "BLACK_BOX";
   
   component VCC
      port ( P : out   std_logic);
   end component;
   attribute BOX_TYPE of VCC : component is "BLACK_BOX";
   
   component IBUFG
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute IOSTANDARD of IBUFG : component is "DEFAULT";
   attribute IBUF_DELAY_VALUE of IBUFG : component is "0";
   attribute BOX_TYPE of IBUFG : component is "BLACK_BOX";
   
   component OBUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute IOSTANDARD of OBUF : component is "DEFAULT";
   attribute SLEW of OBUF : component is "SLOW";
   attribute DRIVE of OBUF : component is "12";
   attribute BOX_TYPE of OBUF : component is "BLACK_BOX";
   
   component NAND3B3
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of NAND3B3 : component is "BLACK_BOX";
   
   component OR3
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR3 : component is "BLACK_BOX";
   
   component OR3B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR3B1 : component is "BLACK_BOX";
   
   component NAND2B2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of NAND2B2 : component is "BLACK_BOX";
   
   component BUFG
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of BUFG : component is "BLACK_BOX";
   
   component FDCP
      generic( INIT : bit :=  '0');
      port ( C   : in    std_logic; 
             CLR : in    std_logic; 
             D   : in    std_logic; 
             PRE : in    std_logic; 
             Q   : out   std_logic);
   end component;
   attribute BOX_TYPE of FDCP : component is "BLACK_BOX";
   
   component AND4B2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             I3 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND4B2 : component is "BLACK_BOX";
   
   attribute CLKIN_PERIOD of BP_MCLK_DCM : label is "20.0";
   attribute CLKOUT_PHASE_SHIFT of BP_MCLK_DCM : label is "FIXED";
   attribute HU_SET of DLRCLKOUT_MUX : label is "DLRCLKOUT_MUX_3";
   attribute HU_SET of DSCLKOUT_MUX : label is "DSCLKOUT_MUX_2";
begin
   BP_FRAMESYNC <= BP_FRAMESYNC_DUMMY;
   BP_LVDS_OUT <= BP_LVDS_OUT_DUMMY;
   BP_RSYNC <= BP_RSYNC_DUMMY;
   CLK_DCM_RST <= CLK_DCM_RST_DUMMY;
   DANTE_SCLK_FX <= DANTE_SCLK_FX_DUMMY;
   ENABLE_TRANSFERSn <= ENABLE_TRANSFERSn_DUMMY;
   I2S_FRAMESYNC <= I2S_FRAMESYNC_DUMMY;
   I2S_RSYNC <= I2S_RSYNC_DUMMY;
   ALIGN_BP_SCLK : BP_SCLKFX_ALIGN_MUSER_KDL
      port map (BPLRCLK=>BP_LRCLK,
                BPMCLK=>BPCLK_FB,
                BPMCLK_DCM_LOCKED=>BP_LOCKED,
                BPMCLK_FB=>BPCLK_FB,
                RST=>RST,
                BPSCLKGEN_LOCK=>open,
                CLKGEN_DLRCLK=>open,
                CLKGEN_DSCLK=>CLKGEN_DSCLK,
                SCLKGEN_FB=>open,
                SCLKGEN_3M=>MCLK_SCLK_FB,
                SCLKGEN_180=>open);
   
   BIDATBUF_0 : IOBUF
      port map (I=>MCU_DOUT(0),
                T=>READ_DATAn,
                O=>MCU_DIN(0),
                IO=>MCU_BIDAT(0));
   
   BIDATBUF_1 : IOBUF
      port map (I=>MCU_DOUT(1),
                T=>READ_DATAn,
                O=>MCU_DIN(1),
                IO=>MCU_BIDAT(1));
   
   BIDATBUF_2 : IOBUF
      port map (I=>MCU_DOUT(2),
                T=>READ_DATAn,
                O=>MCU_DIN(2),
                IO=>MCU_BIDAT(2));
   
   BIDATBUF_3 : IOBUF
      port map (I=>MCU_DOUT(3),
                T=>READ_DATAn,
                O=>MCU_DIN(3),
                IO=>MCU_BIDAT(3));
   
   BIDATBUF_4 : IOBUF
      port map (I=>MCU_DOUT(4),
                T=>READ_DATAn,
                O=>MCU_DIN(4),
                IO=>MCU_BIDAT(4));
   
   BIDATBUF_5 : IOBUF
      port map (I=>MCU_DOUT(5),
                T=>READ_DATAn,
                O=>MCU_DIN(5),
                IO=>MCU_BIDAT(5));
   
   BIDATBUF_6 : IOBUF
      port map (I=>MCU_DOUT(6),
                T=>READ_DATAn,
                O=>MCU_DIN(6),
                IO=>MCU_BIDAT(6));
   
   BIDATBUF_7 : IOBUF
      port map (I=>MCU_DOUT(7),
                T=>READ_DATAn,
                O=>MCU_DIN(7),
                IO=>MCU_BIDAT(7));
   
   BKII_MOD_RST : BROOKLYN_RESET
      port map (CLK=>BP_LRCLK,
                RST=>RESET,
                TCNT=>BKII_RST);
   
   BPI2SFIFO_WR_ALIGN : FD
      port map (C=>BPCLK_FB,
                D=>BPI2S_FIFO_WR,
                Q=>BPI2S_FIFO_WR_DLY);
   
   BPI2S_IBUF_FD_0 : FD
      port map (C=>MCLK_SCLK_FB,
                D=>BPI2S_DIN(0),
                Q=>BPI2S_DAT(0));
   
   BPI2S_IBUF_FD_1 : FD
      port map (C=>MCLK_SCLK_FB,
                D=>BPI2S_DIN(1),
                Q=>BPI2S_DAT(1));
   
   BPI2S_IBUF_FD_2 : FD
      port map (C=>MCLK_SCLK_FB,
                D=>BPI2S_DIN(2),
                Q=>BPI2S_DAT(2));
   
   BPI2S_IBUF_FD_3 : FD
      port map (C=>MCLK_SCLK_FB,
                D=>BPI2S_DIN(3),
                Q=>BPI2S_DAT(3));
   
   BPI2S_IBUF_FD_4 : FD
      port map (C=>MCLK_SCLK_FB,
                D=>BPI2S_DIN(4),
                Q=>BPI2S_DAT(4));
   
   BPI2S_IBUF_FD_5 : FD
      port map (C=>MCLK_SCLK_FB,
                D=>BPI2S_DIN(5),
                Q=>BPI2S_DAT(5));
   
   BPI2S_IBUF_FD_6 : FD
      port map (C=>MCLK_SCLK_FB,
                D=>BPI2S_DIN(6),
                Q=>BPI2S_DAT(6));
   
   BPI2S_IBUF_FD_7 : FD
      port map (C=>MCLK_SCLK_FB,
                D=>BPI2S_DIN(7),
                Q=>BPI2S_DAT(7));
   
   BPI2S_IBUF_FD_8 : FD
      port map (C=>MCLK_SCLK_FB,
                D=>BPI2S_DIN(8),
                Q=>BPI2S_DAT(8));
   
   BPI2S_IBUF_FD_9 : FD
      port map (C=>MCLK_SCLK_FB,
                D=>BPI2S_DIN(9),
                Q=>BPI2S_DAT(9));
   
   BPI2S_IBUF_FD_10 : FD
      port map (C=>MCLK_SCLK_FB,
                D=>BPI2S_DIN(10),
                Q=>BPI2S_DAT(10));
   
   BPI2S_IBUF_FD_11 : FD
      port map (C=>MCLK_SCLK_FB,
                D=>BPI2S_DIN(11),
                Q=>BPI2S_DAT(11));
   
   BPI2S_IBUF_FD_12 : FD
      port map (C=>MCLK_SCLK_FB,
                D=>BPI2S_DIN(12),
                Q=>BPI2S_DAT(12));
   
   BPI2S_IBUF_FD_13 : FD
      port map (C=>MCLK_SCLK_FB,
                D=>BPI2S_DIN(13),
                Q=>BPI2S_DAT(13));
   
   BPI2S_IBUF_FD_14 : FD
      port map (C=>MCLK_SCLK_FB,
                D=>BPI2S_DIN(14),
                Q=>BPI2S_DAT(14));
   
   BPI2S_IBUF_FD_15 : FD
      port map (C=>MCLK_SCLK_FB,
                D=>BPI2S_DIN(15),
                Q=>BPI2S_DAT(15));
   
   BPI2S_MSTOR_DTXFIFO_XFER : BPI2S_MEMSTOR_MUSER_KDL
      port map (BPCLK_FB=>BPCLK_FB,
                BPI2S_DAT(15 downto 0)=>BPI2S_DAT(15 downto 0),
                BPI2S_MRD=>BPI2S_MRD,
                BPI2S_MRDADDR(4 downto 0)=>D_TXFIFO_XPT_RADDR(4 downto 0),
                I2S_RSYNC=>I2S_RSYNC_DUMMY,
                RST=>ENABLE_TRANSFERSn_DUMMY,
                S_CLK=>MCLK_SCLK_FB,
                BPI2S_AUD_DATA=>open,
                BPI2S_CHNCNT=>open,
                BPI2S_HOLD=>open,
                BPI2S_MADDR=>open,
                BPI2S_MSTOR_DAT(31 downto 0)=>BPI2S_MSTOR_DAT(31 downto 0),
                BPI2S_MUXSEL=>open,
                BPI2S_MWR=>open,
                BPI2S_MXFR_STATE=>open,
                BPI2S_XFRCYCLE=>BPI2S_XFRCYCLE);
   
   BPI2S_MSTOR_TO_DTXFIFO : BPI2S_MEMXFER
      port map (BPMCLK=>BPCLK_FB,
                MSTOR_CYC_DONE=>BPI2S_XFRCYCLE,
                RST=>ENABLE_TRANSFERSn_DUMMY,
                BPI2S_FIFO_WR=>BPI2S_FIFO_WR,
                BPI2S_MRD=>BPI2S_MRD,
                BPI2S_MRD_ADDR(4 downto 0)=>BPI2S_MRD_ADDR(4 downto 0),
                STATE=>open);
   
   BPSTATE : LRCLK_EdgeCount_1024_3FD
      port map (clk=>BPCLK_FB,
                sclr=>BP_FRAMESYNC_DUMMY,
                q(9 downto 0)=>BP_STATE(9 downto 0),
                q_thresh0=>open);
   
   BPSTATE_BUF_0 : BUF
      port map (I=>BP_STATE(0),
                O=>BP_STATE_FD(0));
   
   BPSTATE_BUF_1 : BUF
      port map (I=>BP_STATE(1),
                O=>BP_STATE_FD(1));
   
   BPSTATE_BUF_2 : BUF
      port map (I=>BP_STATE(2),
                O=>BP_STATE_FD(2));
   
   BPSTATE_BUF_3 : BUF
      port map (I=>BP_STATE(3),
                O=>BP_STATE_FD(3));
   
   BPSTATE_BUF_4 : BUF
      port map (I=>BP_STATE(4),
                O=>BP_STATE_FD(4));
   
   BPSTATE_BUF_5 : BUF
      port map (I=>BP_STATE(5),
                O=>BP_STATE_FD(5));
   
   BPSTATE_BUF_6 : BUF
      port map (I=>BP_STATE(6),
                O=>BP_STATE_FD(6));
   
   BPSTATE_BUF_7 : BUF
      port map (I=>BP_STATE(7),
                O=>BP_STATE_FD(7));
   
   BPSTATE_BUF_8 : BUF
      port map (I=>BP_STATE(8),
                O=>BP_STATE_FD(8));
   
   BPSTATE_BUF_9 : BUF
      port map (I=>BP_STATE(9),
                O=>BP_STATE_FD(9));
   
   BPWRDRSTBLOCK : WDCLKSYNC_TCNT
      port map (CLK=>BP_LRCLK,
                RST=>XLXN_1288,
                TCNT=>BP_DCM_ALLOW_RST);
   
   BP_DCM_RESET : DCM_UNLOCK_RESET_MUSER_KDL
      port map (DCM_LOCKEDn=>BP_LOCKED,
                LRCLK=>BP_LRCLK,
                RESET=>RESET,
                DCM_RESET=>BP_DCM_RST);
   
   BP_LCLK_EDGE : LRCLK_EdgeCount_1024_3FD
      port map (clk=>BPCLK_FB,
                sclr=>XLXN_220,
                q=>open,
                q_thresh0=>BP_FRAMESYNC_DUMMY);
   
   BP_MCLK_DCM : DCM_SP
   -- synopsys translate_off
   generic map( CLKIN_PERIOD => 20.0,
            CLKFX_MULTIPLY => 4,
            CLKFX_DIVIDE => 1,
            PHASE_SHIFT => 0,
            CLKOUT_PHASE_SHIFT => "FIXED",
            DESKEW_ADJUST => "SYSTEM_SYNCHRONOUS",
            DLL_FREQUENCY_MODE => "LOW",
            CLK_FEEDBACK => "1X",
            STARTUP_WAIT => FALSE)
   -- synopsys translate_on
      port map (CLKFB=>BPCLK0_FB,
                CLKIN=>BPMCLK_IN,
                DSSEN=>XLXN_181,
                PSCLK=>XLXN_181,
                PSEN=>XLXN_181,
                PSINCDEC=>XLXN_181,
                RST=>RST,
                CLKDV=>open,
                CLKFX=>open,
                CLKFX180=>open,
                CLK0=>BPCLK0_FB,
                CLK2X=>open,
                CLK2X180=>open,
                CLK90=>open,
                CLK180=>open,
                CLK270=>BPCLK270,
                LOCKED=>BP_LOCKED,
                PSDONE=>open,
                STATUS=>open);
   
   BP_RXFRAMEDLY_REG : SP3A_Reg5En_PS8
      port map (CE=>WR_DEV(0),
                CLK=>BPCLK_FB,
                D(4 downto 0)=>WR_DATA(4 downto 0),
                SINIT=>RESET,
                Q(4 downto 0)=>BP_FRAME_DELAY(4 downto 0));
   
   BP_RXLVDS_RSYNC : LRCLK_EdgeCount_1024_29
      port map (clk=>BPCLK_FB,
                sclr=>BP_FRAMESYNC_DUMMY,
                q=>open,
                q_thresh0=>BP_RSYNC_DUMMY);
   
   BP_TXFRAMEDLY_REG : SP3A_Reg5En_PS8
      port map (CE=>WR_DEV(1),
                CLK=>BPCLK_FB,
                D(4 downto 0)=>WR_DATA(4 downto 0),
                SINIT=>RESET,
                Q(4 downto 0)=>DANTE_FRAME_DELAY(4 downto 0));
   
   BP_WR_ALIGN_REG : SP3A_Reg6
      port map (CLK=>BPCLK_FB,
                D(5)=>BPMEM_WR,
                D(4 downto 0)=>BPMEM_WRADDR(4 downto 0),
                Q(5)=>BPMSTOR_WR,
                Q(4 downto 0)=>BPMSTOR_WRADDR(4 downto 0));
   
   CLK_DISTURB_MON : ClockDisturbance_SM
      port map (Clk=>D_MCLK,
                ClkPhse=>BP_DCM_ALLOW_RST,
                DeadClk=>DEAD_CLOCK,
                LRClk=>D_LRCLK,
                POR=>PWR_ON_RST,
                Reset=>RESET,
                ClkPhse_RST=>CPHS_RST,
                DeadClk_RST=>DC_RST,
                StateOut(3 downto 0)=>CLKDSTRB_ST(3 downto 0));
   
   CLRWINDOW : Rising_Edge
      port map (CLK=>BPCLK_FB,
                R_EDGE=>XLXN_1218,
                EDGE_DETECT=>CLR_ALLOW);
   
   CONTROL_REG : SP3A_Reg8E_PS_12
      port map (CE=>WR_DEV(2),
                CLK=>BPCLK_FB,
                D(7 downto 0)=>WR_DATA(7 downto 0),
                SINIT=>RESET,
                Q(7 downto 0)=>CONTROL(7 downto 0));
   
   DANTE_AUDIO_IF : Dante_RW_Clocking_MUSER_KDL
      port map (BPCLK_FB=>BPCLK_FB,
                BPSCLK_FB=>MCLK_SCLK_FB,
                BP_CHNDAT(31 downto 0)=>BPI2S_MSTOR_DAT(31 downto 0),
                BP_RX_RDEN=>BP_RXRDEN,
                BP_RX_WREN=>BP_RXWREN,
                BP_TX_RDEN=>DTX_FIFO_RD,
                BP_TX_WREN=>BPI2S_FIFO_WR_DLY,
                DANTE_TDM0_LD=>DTDM0_LD,
                DANTE_TDM1_LD=>DTDM1_LD,
                DANTE_TDM2_LD=>XLXN_964,
                DANTE_TDM3_LD=>XLXN_964,
                D_DCM_RST=>D_AUD_RXTX_RST,
                D_LRCLK=>D_LRCLK,
                D_MCLK=>D_MCLK,
                D_RXTX_FIFO_RST=>RELEASE_D_LOGICn,
                D_RXWCH_SEL(1 downto 0)=>D_RXWCH_SEL(1 downto 0),
                D_SCLK=>D_SCLK,
                D_SCLK_SEL=>XLXN_416,
                D_SDIN_0=>D_DIN0,
                D_SDIN_1=>D_DIN1,
                D_SDIN_2=>D_DIN2,
                D_SDIN_3=>D_DIN3,
                RST=>RELEASE_D_LOGICn,
                DANTE_BIT_STATE=>open,
                DANTE_CHNDAT=>open,
                DANTE_PISO_LD=>D_SDOUT_LD,
                DANTE_PISO_LD_DLY=>D_SDOUT_LD_DLY,
                DANTE_RD_RESYNC=>DANTE_RD_RESYNC,
                DANTE_RX_STATE=>open,
                DANTE_TX_STATE=>open,
                DANTE_WR_RESYNC=>DANTE_WR_RESYNC,
                DCLK_25M=>DANTE_SCLK_FX_DUMMY,
                DCLK_25M_INV=>DANTE_SCLK_FX180,
                DDCMS_LOCKED=>DDCMS_LOCKED,
                DDCM_RST=>open,
                D_CHNL_HOLD=>DANTE_CHNL_HOLD,
                D_LRCLK_EDGE=>open,
                D_RXCHNL_COUNT(3 downto 0)=>D_RXCHNL_COUNT(3 downto 0),
                D_RX_BP_DOUT(31 downto 0)=>D_RXFIFO_BPDATA(31 downto 0),
                D_RX_FAEMPTY=>open,
                D_RX_FAFULL=>open,
                D_RX_FEMPTY=>open,
                D_RX_FFULL=>open,
                D_RX_FIFOCNT(9 downto 0)=>RXFIFO_CHNCNT(9 downto 0),
                D_RX_OVRFLOW=>D_RX_OVRFLOW,
                D_RX_RDVALID=>D_RXFIFO_RD_VALID,
                D_RX_UDRFLOW=>D_RX_UDRFLOW,
                D_RX_WR_ACK=>open,
                D_SDO_0=>D_SDO_0,
                D_SDO_1=>D_SDO_1,
                D_SDO_2=>D_SDO_2,
                D_SDO_3=>D_SDO_3,
                D_TXCHNL_COUNT(3 downto 0)=>D_TXCHNL_COUNT(3 downto 0),
                D_TX_BP_DOUT=>open,
                D_TX_FAEMPTY=>open,
                D_TX_FAFULL=>open,
                D_TX_FEMPTY=>open,
                D_TX_FFULL=>open,
                D_TX_FIFOCNT(9 downto 0)=>TXFIFO_CHNCNT(9 downto 0),
                D_TX_OVRFLOW=>D_TX_OVRFLOW,
                D_TX_RDVALID=>open,
                D_TX_UDRFLOW=>D_TX_UDRFLOW,
                D_TX_WR_ACK=>open);
   
   DANTE_DCM_RST_TIMER : TCNT_30SEC
      port map (CLK=>BP_LRCLK,
                RST=>RESET,
                TCNT=>PWR_ON_RST);
   
   DANTE_RX_MSTOR : SP3A_DpRAM_32x32
      port map (addra(4 downto 0)=>BP_DMSTOR_WADDR(4 downto 0),
                addrb(4 downto 0)=>DMSTOR_RDADDR(4 downto 0),
                clka=>BPCLK_FB,
                clkb=>BPCLK_FB,
                dina(31 downto 0)=>D_RXFIFO_BPDATA(31 downto 0),
                enb=>DMSTOR_RD,
                wea(0)=>BP_DMSTOR_WREN,
                doutb(31 downto 0)=>DANTE_MSTOR_DAT(31 downto 0));
   
   DANTE_TXFIFO_FIXED_XPT : krl_dante_rom_32x32
      port map (a(4 downto 0)=>BPI2S_MRD_ADDR(4 downto 0),
                spo(4 downto 0)=>D_TXFIFO_XPT_RADDR(4 downto 0));
   
   DCM3CYCRST : SP3A_Siso4_PSet
      port map (ASET=>XLXN_1276,
                CLK=>BPMCLK_IN,
                SDIN=>XLXN_1284,
                SDOUT=>BROOK_WRD_RSYNC);
   
   DEAD_CLK_MON : DeadClock_MUSER_KDL
      port map (BP_MCLK=>BPMCLK_IN,
                D_MCLK=>D_MCLK,
                POR=>PWR_ON_RST,
                RESET=>RESET,
                BPCLK_CNT=>open,
                DEAD_CLOCK=>DEAD_CLOCK);
   
   DLRCLKOUT_MUX : M2_1_HXILINX_KDL
      port map (D0=>BP_LRCLK,
                D1=>CONTROL(5),
                S0=>XLXN_502,
                O=>XLXN_1291);
   
   DSCLKOUT_MUX : M2_1_HXILINX_KDL
      port map (D0=>CLKGEN_DSCLK,
                D1=>XLXN_502,
                S0=>CONTROL(4),
                O=>DSCKMUX);
   
   D_MODULE_RST : OBUFT
      port map (I=>XLXN_314,
                T=>DANTE_RESET,
                O=>DANTE_RSTn);
   
   D_READ_RXFIFO : DANTE_RX_FIFO_READ
      port map (BP_CLK=>BPCLK_FB,
                BP_DMSTOR_BSWAP=>D_RX_MEM_BSWAP,
                BP_FRAME_DELAY(12)=>ZG,
                BP_FRAME_DELAY(11)=>ZG,
                BP_FRAME_DELAY(10 downto 0)=>BP_RXFRAME_DLY(10 downto 0),
                BP_RESYNC=>BP_RSYNC_DUMMY,
                D_RSYNC_RESET=>ENABLE_TRANSFERSn_DUMMY,
                D_RXFIFO_CHNCNT(12)=>ZG,
                D_RXFIFO_CHNCNT(11)=>ZG,
                D_RXFIFO_CHNCNT(10)=>ZG,
                D_RXFIFO_CHNCNT(9 downto 0)=>RXFIFO_CHNCNT(9 downto 0),
                D_RXFIFO_RDVALID=>D_RXFIFO_RD_VALID,
                RST=>ENABLE_TRANSFERSn_DUMMY,
                BP_DMSTOR_WADDR(4 downto 0)=>BP_DMSTOR_WADDR(4 downto 0),
                BP_DMSTOR_WREN=>BP_DMSTOR_WREN,
                D_RXFIFO_RDEN=>BP_RXRDEN,
                D_RXFIFO_XFREN=>BP_RXFIFO_XFRCYCLE,
                STATE=>open);
   
   D_RXFIFO_TO_BPMEM : DANTE_RXMEM_TO_BPMEM
      port map (BP_CLK=>BPCLK_FB,
                FIFO_XFR_DONE=>BP_RXFIFO_XFRCYCLE,
                RST=>ENABLE_TRANSFERSn_DUMMY,
                MEM_RD=>DMSTOR_RD,
                MEM_RDADDR(4 downto 0)=>DMSTOR_RDADDR(4 downto 0),
                MEM_WR=>BPMEM_WR,
                MEM_WRADDR(4 downto 0)=>BPMEM_WRADDR(4 downto 0),
                STATE=>open);
   
   D_RX_TO_BP_XFER : XFRMEM32_MUSER_KDL
      port map (CLK=>BPCLK_FB,
                LR_CLK=>BP_LRCLK,
                RST=>ENABLE_TRANSFERSn_DUMMY,
                RSYNC=>BP_RSYNC_DUMMY,
                XFRMEM_DIN(31 downto 0)=>DANTE_MSTOR_DAT(31 downto 0),
                XFRMEM_WE=>BPMSTOR_WR,
                XFRMEM_WRADDR(4 downto 0)=>BPMSTOR_WRADDR(4 downto 0),
                BS_DETECT=>D_RX_MEM_BSWAP,
                RSYNC_2LR=>open,
                SDOUT1=>BP_LVDS_OUT_DUMMY,
                XFRHLD_EN=>open,
                XFRMEM_RDADDR=>open,
                XFRMEM_WR=>open,
                XFRRDCNT_EN=>open,
                XFR_PISO_LD=>open);
   
   D_TXHLDREG_LOADER : DANTE_TX_HOLD_WRITE
      port map (BP_CLK=>BPCLK_FB,
                D_CHNCNT(3 downto 0)=>D_TXCHNL_COUNT(3 downto 0),
                D_CHN_LD=>D_SDOUT_LD_DLY,
                D_RDRSYNC=>DANTE_RD_RESYNC,
                D_TXFIFO_CHNCNT(12)=>ZG,
                D_TXFIFO_CHNCNT(11)=>ZG,
                D_TXFIFO_CHNCNT(10)=>ZG,
                D_TXFIFO_CHNCNT(9 downto 0)=>TXFIFO_CHNCNT(9 downto 0),
                D_TXFRAME_DELAY(12)=>ZG,
                D_TXFRAME_DELAY(11)=>ZG,
                D_TXFRAME_DELAY(10 downto 0)=>BP_TXFRAME_DLY(10 downto 0),
                RST=>ENABLE_TRANSFERSn_DUMMY,
                D_TXLD_ENA=>D_TXLD_ENA,
                STATE=>open);
   
   D_TXPISO_LOADER : SP3A_SIPO8_PS1
      port map (CLK=>BPCLK_FB,
                SDIN=>ZG,
                SINIT=>XLXN_291,
                Q(7 downto 0)=>DTXPISO_SIG(7 downto 0));
   
   D_WRITE_RXFIFO : DANTE_RX_FIFO_WRITE
      port map (D_CHNCNT(3 downto 0)=>D_RXCHNL_COUNT(3 downto 0),
                D_CHNHLD=>DANTE_CHNL_HOLD,
                D_RESYNC=>DANTE_WR_RESYNC,
                D_SCLK=>DANTE_SCLK_FX_DUMMY,
                RST=>ENABLE_TRANSFERSn_DUMMY,
                D_CHNSEL(1 downto 0)=>D_RXWCH_SEL(1 downto 0),
                D_FIFO_WR=>BP_RXWREN,
                STATE=>open);
   
   ENABLE_SYNC_CHK : WRDCLKWINDOW
      port map (CLK=>BPCLK_FB,
                RST=>WINDOWRSYNC,
                CHKWINDOW=>CHECK_WINDOW);
   
   ERR_STATUS_REGISTER : ERROR_STATUS_MUSER_KDL
      port map (CLK=>BPCLK_FB,
                ERR_INPUT(7 downto 4)=>BGND(7 downto 4),
                ERR_INPUT(3 downto 0)=>FIFO_STAT(3 downto 0),
                ERR_STATUS_RD=>RD_DEV(5),
                ERR_STATUS_SEL=>RD_DEVSEL(5),
                RST=>RESET,
                ERROR_STATUS(7 downto 0)=>ERROR_STAT(7 downto 0),
                ERR_INTn=>ERR_INTERRUPTn);
   
   GEN_WRD_RSYNC : Falling_Edge
      port map (CLK=>BPCLK_FB,
                F_EDGE=>CHECK_WINDOW,
                EDGE_DETECT=>WORDCLK_RESYNC);
   
   GETH_STATUS_0 : BUF
      port map (I=>GE_STATUS(0),
                O=>GE_STAT(0));
   
   GETH_STATUS_1 : BUF
      port map (I=>GE_STATUS(1),
                O=>GE_STAT(1));
   
   GETH_STATUS_2 : BUF
      port map (I=>GE_STATUS(2),
                O=>GE_STAT(2));
   
   GETH_STATUS_3 : BUF
      port map (I=>GE_STATUS(3),
                O=>GE_STAT(3));
   
   GETH_STATUS_4 : BUF
      port map (I=>GE_STATUS(4),
                O=>GE_STAT(4));
   
   INFINEON_INTERFACE : MICRO_IF_MUSER_KDL
      port map (CLK=>BPCLK_FB,
                CPU_ADD(6 downto 0)=>MCU_ADDR(6 downto 0),
                CPU_DIN(7 downto 0)=>MCU_DIN(7 downto 0),
                CPU_READn=>MCU_RDn,
                CPU_WRITEn=>MCU_WRn,
                FPGA_SELECTn=>FPGA_CSn,
                RESET=>RESET,
                DevRDSel(7 downto 0)=>RD_DEVSEL(7 downto 0),
                DevWRSel=>open,
                RdOEn=>RD_OEn,
                RdSel(2 downto 0)=>RDMUX_SEL(2 downto 0),
                RD_PULSE(7 downto 0)=>RD_DEV(7 downto 0),
                WR_DEV_ADDR=>open,
                WR_DEV_DATA(7 downto 0)=>WR_DATA(7 downto 0),
                WR_PULSE(7 downto 0)=>WR_DEV(7 downto 0));
   
   I2SLRCLK_EDGE : LRCLK_I2SEdgeCount_64_3E
      port map (clk=>MCLK_SCLK_FB,
                sclr=>XLXN_290,
                q=>open,
                q_thresh0=>I2S_FRAMESYNC_DUMMY);
   
   I2SSTATE : LRCLK_I2SEdgeCount_64_3E
      port map (clk=>MCLK_SCLK_FB,
                sclr=>I2S_FRAMESYNC_DUMMY,
                q(5 downto 0)=>I2S_STATE(5 downto 0),
                q_thresh0=>open);
   
   I2STX_RSYNC : LRCLK_I2SEdgeCount_64
      port map (clk=>MCLK_SCLK_FB,
                sclr=>I2S_FRAMESYNC_DUMMY,
                q=>open,
                q_thresh0=>I2S_RSYNC_DUMMY);
   
   LRCLK_FALLING_EDGE : Falling_Edge
      port map (CLK=>BPCLK_FB,
                F_EDGE=>BP_LRCLK,
                EDGE_DETECT=>BP_LRCLK_EDGE);
   
   MCU_DOUT_MUX : BUSMUX8X1X8
      port map (DAT_A(7 downto 0)=>FPGATYPE(7 downto 0),
                DAT_B(7 downto 0)=>FPGAVERS(7 downto 0),
                DAT_C(7)=>ZG,
                DAT_C(6)=>ZG,
                DAT_C(5)=>BP_LOCKED,
                DAT_C(4 downto 0)=>BP_FRAME_DELAY(4 downto 0),
                DAT_D(7)=>ZG,
                DAT_D(6)=>ZG,
                DAT_D(5)=>ZG,
                DAT_D(4 downto 0)=>DANTE_FRAME_DELAY(4 downto 0),
                DAT_E(7 downto 0)=>CONTROL(7 downto 0),
                DAT_F(7 downto 0)=>ERROR_STAT(7 downto 0),
                DAT_G(7)=>ZG,
                DAT_G(6)=>ZG,
                DAT_G(5)=>ZG,
                DAT_G(4 downto 0)=>GE_STAT(4 downto 0),
                DAT_H(7 downto 0)=>BGND(7 downto 0),
                SEL(2 downto 0)=>RDMUX_SEL(2 downto 0),
                MUXOUT(7 downto 0)=>MCU_DOUT(7 downto 0));
   
   MGND_0 : GND
      port map (G=>BGND(0));
   
   MGND_1 : GND
      port map (G=>BGND(1));
   
   MGND_2 : GND
      port map (G=>BGND(2));
   
   MGND_3 : GND
      port map (G=>BGND(3));
   
   MGND_4 : GND
      port map (G=>BGND(4));
   
   MGND_5 : GND
      port map (G=>BGND(5));
   
   MGND_6 : GND
      port map (G=>BGND(6));
   
   MGND_7 : GND
      port map (G=>BGND(7));
   
   PHYRST : OBUFT
      port map (I=>XLXN_314,
                T=>PHY_RESET,
                O=>PHY_RSTn);
   
   RX_BUFFER_DELAY : MULTx32
      port map (a(4 downto 0)=>BP_FRAME_DELAY(4 downto 0),
                ce=>XLXN_301,
                clk=>BPCLK_FB,
                sclr=>RESET,
                p(10 downto 0)=>BP_RXFRAME_DLY(10 downto 0));
   
   SETWINDOW : Rising_Edge
      port map (CLK=>BPCLK_FB,
                R_EDGE=>CHECK_WINDOW,
                EDGE_DETECT=>SET_ALLOW);
   
   TX_BUFFER_DELAY : MULTx32
      port map (a(4 downto 0)=>DANTE_FRAME_DELAY(4 downto 0),
                ce=>XLXN_301,
                clk=>BPCLK_FB,
                sclr=>RESET,
                p(10 downto 0)=>BP_TXFRAME_DLY(10 downto 0));
   
   TYPE_VERS_INFO : VerTypeInfo
      port map (FPGA_TYPE(7 downto 0)=>FPGATYPE(7 downto 0),
                FPGA_VERS(7 downto 0)=>FPGAVERS(7 downto 0));
   
   WRDRSYNC_BLOCK : WDCLKSYNC_TCNT
      port map (CLK=>BPCLK_FB,
                RST=>XLXN_1267,
                TCNT=>THREE_SEC_BLOCK);
   
   WRDSYNCCNT_LREDGE : Falling_Edge
      port map (CLK=>BPCLK_FB,
                F_EDGE=>BP_LRCLK,
                EDGE_DETECT=>WRDCNTSYNC);
   
   XLXI_145 : GND
      port map (G=>XLXN_181);
   
   XLXI_185 : OR2
      port map (I0=>RST,
                I1=>BP_LRCLK_EDGE,
                O=>XLXN_220);
   
   XLXI_186 : GND
      port map (G=>ZG);
   
   XLXI_263 : FD
      port map (C=>MCLK_SCLK_FB,
                D=>BP_LRCLK,
                Q=>XLXN_277);
   
   XLXI_264 : FD
      port map (C=>MCLK_SCLK_FB,
                D=>XLXN_277,
                Q=>XLXN_278);
   
   XLXI_265 : AND2B1
      port map (I0=>XLXN_277,
                I1=>XLXN_278,
                O=>I2S_LRCLK_EDGE);
   
   XLXI_267 : OR2
      port map (I0=>RST,
                I1=>I2S_LRCLK_EDGE,
                O=>XLXN_290);
   
   XLXI_270 : INV
      port map (I=>D_TXLD_ENA,
                O=>XLXN_291);
   
   XLXI_272 : OR2
      port map (I0=>DTXPISO_SIG(5),
                I1=>DTXPISO_SIG(1),
                O=>DTX_FIFO_RD);
   
   XLXI_273 : BUF
      port map (I=>DTXPISO_SIG(3),
                O=>DTDM0_LD);
   
   XLXI_274 : BUF
      port map (I=>DTXPISO_SIG(7),
                O=>DTDM1_LD);
   
   XLXI_278 : VCC
      port map (P=>XLXN_301);
   
   XLXI_284 : GND
      port map (G=>ZG);
   
   XLXI_285 : VCC
      port map (P=>ZV);
   
   XLXI_296 : BUF
      port map (I=>D_RX_UDRFLOW,
                O=>FIFO_STAT(3));
   
   XLXI_297 : BUF
      port map (I=>D_RX_OVRFLOW,
                O=>FIFO_STAT(2));
   
   XLXI_298 : BUF
      port map (I=>D_TX_UDRFLOW,
                O=>FIFO_STAT(1));
   
   XLXI_299 : BUF
      port map (I=>D_TX_OVRFLOW,
                O=>FIFO_STAT(0));
   
   XLXI_300 : OR2
      port map (I0=>CONTROL(1),
                I1=>ERR_INTERRUPTn,
                O=>ERR_INTn);
   
   XLXI_306 : VCC
      port map (P=>XLXN_314);
   
   XLXI_374 : IBUFG
      port map (I=>BP_MCLK,
                O=>AT_MCLK);
   
   XLXI_376 : IBUFG
      port map (I=>DANTE_MCLK,
                O=>D_MCLK);
   
   XLXI_377 : IBUFG
      port map (I=>DANTE_SCLK,
                O=>D_SCLK);
   
   XLXI_378 : IBUFG
      port map (I=>DANTE_LRCLK,
                O=>D_LRCLK);
   
   XLXI_381 : GND
      port map (G=>XLXN_416);
   
   XLXI_392 : OBUF
      port map (I=>XLXN_1120,
                O=>TP_B7);
   
   XLXI_393 : OBUF
      port map (I=>XLXN_1121,
                O=>TP_B6);
   
   XLXI_394 : OBUF
      port map (I=>XLXN_1123,
                O=>TP_B5);
   
   XLXI_395 : OBUF
      port map (I=>XLXN_1125,
                O=>TP_B4);
   
   XLXI_396 : OBUF
      port map (I=>XLXN_1127,
                O=>TP_B3);
   
   XLXI_397 : OBUF
      port map (I=>XLXN_1128,
                O=>TP_B2);
   
   XLXI_398 : OBUF
      port map (I=>XLXN_1129,
                O=>TP_B1);
   
   XLXI_399 : OBUF
      port map (I=>XLXN_1194,
                O=>TP_B0);
   
   XLXI_427 : GND
      port map (G=>XLXN_502);
   
   XLXI_449 : OBUF
      port map (I=>XLXN_954,
                O=>TP_A3);
   
   XLXI_450 : OBUF
      port map (I=>XLXN_955,
                O=>TP_A2);
   
   XLXI_451 : OBUF
      port map (I=>XLXN_956,
                O=>TP_A1);
   
   XLXI_452 : OBUF
      port map (I=>XLXN_957,
                O=>TP_A0);
   
   XLXI_501 : NAND3B3
      port map (I0=>RST,
                I1=>D_AUD_RXTX_RST,
                I2=>CONTROL(0),
                O=>XLXN_1299);
   
   XLXI_502 : OBUF
      port map (I=>XLXN_950,
                O=>TP_A7);
   
   XLXI_503 : OBUF
      port map (I=>XLXN_951,
                O=>TP_A6);
   
   XLXI_504 : OBUF
      port map (I=>XLXN_952,
                O=>TP_A5);
   
   XLXI_505 : OBUF
      port map (I=>XLXN_953,
                O=>TP_A4);
   
   XLXI_649 : GND
      port map (G=>XLXN_964);
   
   XLXI_675 : INV
      port map (I=>RSTn,
                O=>RESET);
   
   XLXI_679 : OR3
      port map (I0=>ZG,
                I1=>RESET,
                I2=>BP_DCM_RST,
                O=>RST);
   
   XLXI_689 : OR3B1
      port map (I0=>DANTE_PHY_RST,
                I1=>CONTROL(7),
                I2=>RESET,
                O=>PHY_RESET);
   
   XLXI_690 : OR2
      port map (I0=>BKII_RST,
                I1=>RESET,
                O=>DANTE_RESET);
   
   XLXI_692 : OR2
      port map (I0=>CLK_DCM_RST_DUMMY,
                I1=>PWR_ON_RST,
                O=>D_AUD_RXTX_RST);
   
   XLXI_725 : NAND2B2
      port map (I0=>D_AUD_RXTX_RST,
                I1=>D_AUD_RXTX_RST,
                O=>RELEASE_D_LOGICn);
   
   XLXI_726 : NAND3B3
      port map (I0=>RD_OEn,
                I1=>FPGA_CSn,
                I2=>MCU_RDn,
                O=>READ_DATAn);
   
   XLXI_752 : BUF
      port map (I=>ZV,
                O=>GE_LED(0));
   
   XLXI_753 : NAND3B3
      port map (I0=>CONTROL(3),
                I1=>CONTROL(2),
                I2=>GE_STAT(0),
                O=>GE_LED(1));
   
   XLXI_759 : BUF
      port map (I=>RELEASE_D_LOGICn,
                O=>XLXN_1120);
   
   XLXI_760 : BUF
      port map (I=>DEAD_CLOCK,
                O=>XLXN_1121);
   
   XLXI_767 : BUF
      port map (I=>BP_LRCLK,
                O=>XLXN_950);
   
   XLXI_768 : BUF
      port map (I=>BP_FRAMESYNC_DUMMY,
                O=>XLXN_951);
   
   XLXI_769 : BUF
      port map (I=>AT_MCLK,
                O=>XLXN_952);
   
   XLXI_770 : BUF
      port map (I=>BPI2S_DIN(0),
                O=>XLXN_954);
   
   XLXI_771 : BUF
      port map (I=>BPCLK_FB,
                O=>XLXN_953);
   
   XLXI_772 : BUF
      port map (I=>BPI2S_DIN(1),
                O=>XLXN_955);
   
   XLXI_773 : BUF
      port map (I=>MCLK_SCLK_FB,
                O=>XLXN_956);
   
   XLXI_774 : BUF
      port map (I=>BP_LVDS_OUT_DUMMY,
                O=>XLXN_957);
   
   XLXI_779 : BUF
      port map (I=>BP_DCM_ALLOW_RST,
                O=>XLXN_1123);
   
   XLXI_780 : BUF
      port map (I=>D_MCLK,
                O=>XLXN_1125);
   
   XLXI_781 : BUF
      port map (I=>D_LRCLK,
                O=>XLXN_1127);
   
   XLXI_782 : BUF
      port map (I=>RESET,
                O=>XLXN_1128);
   
   XLXI_783 : BUF
      port map (I=>XLXN_1289,
                O=>XLXN_1129);
   
   XLXI_800 : BUFG
      port map (I=>AT_MCLK,
                O=>BPMCLK_IN);
   
   XLXI_801 : BUF
      port map (I=>CLK_DCM_RST_DUMMY,
                O=>XLXN_1194);
   
   XLXI_852 : GND
      port map (G=>XLXN_1289);
   
   XLXI_855 : BUF
      port map (I=>DSCKMUX,
                O=>DSCLK_OUT);
   
   XLXI_856 : BUF
      port map (I=>XLXN_1291,
                O=>DLRCLK_OUT);
   
   XLXI_862 : OR2
      port map (I0=>RESET,
                I1=>WRDCNTSYNC,
                O=>WINDOWRSYNC);
   
   XLXI_864 : FDCP
      port map (C=>BPCLK_FB,
                CLR=>CLR_ALLOW,
                D=>ALLOW_WRDCLK_RSYNC,
                PRE=>SET_ALLOW,
                Q=>ALLOW_WRDCLK_RSYNC);
   
   XLXI_867 : AND2B1
      port map (I0=>D_LRCLK,
                I1=>CHECK_WINDOW,
                O=>XLXN_1218);
   
   XLXI_891 : OR2
      port map (I0=>BP_DCM_ALLOW_RST,
                I1=>PWR_ON_RST,
                O=>XLXN_1267);
   
   XLXI_892 : AND4B2
      port map (I0=>THREE_SEC_BLOCK,
                I1=>PWR_ON_RST,
                I2=>WORDCLK_RESYNC,
                I3=>ALLOW_WRDCLK_RSYNC,
                O=>XLXN_1266);
   
   XLXI_893 : FD
      port map (C=>BPMCLK_IN,
                D=>XLXN_1266,
                Q=>XLXN_1276);
   
   XLXI_902 : GND
      port map (G=>XLXN_1284);
   
   XLXI_903 : AND2B1
      port map (I0=>BP_DCM_ALLOW_RST,
                I1=>BROOK_WRD_RSYNC,
                O=>BPDCM_WRD_RSYNC);
   
   XLXI_905 : OR2
      port map (I0=>BPDCM_WRD_RSYNC,
                I1=>PWR_ON_RST,
                O=>XLXN_1288);
   
   XLXI_907 : OR2
      port map (I0=>CPHS_RST,
                I1=>DC_RST,
                O=>CLK_DCM_RST_DUMMY);
   
   XLXI_908 : BUFG
      port map (I=>BPCLK270,
                O=>BPCLK_FB);
   
   XLXI_910 : FD
      port map (C=>XLXN_1296,
                D=>DDCMS_LOCKED,
                Q=>XLXN_1300);
   
   XLXI_911 : INV
      port map (I=>BP_LRCLK,
                O=>XLXN_1296);
   
   XLXI_912 : NAND2B2
      port map (I0=>XLXN_1300,
                I1=>XLXN_1299,
                O=>ENABLE_TRANSFERSn_DUMMY);
   
end BEHAVIORAL;


