-- Dante Word Clock Lock
-- Jan 25, 2012
-- Anthony Medina
-- Made this a sync reset
--
LIBRARY IEEE ;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY LRCLKLOCK IS
	GENERIC(WIDTH	: INTEGER	:= 9);
PORT(
			CLK			:IN	STD_LOGIC;
			RST			:IN	STD_LOGIC;
			COUNT		:OUT	STD_LOGIC_VECTOR (WIDTH-1 DOWNTO 0);
			ENA_LOCK	:OUT	STD_LOGIC
	);
END LRCLKLOCK;

ARCHITECTURE Behave OF LRCLKLOCK IS

SIGNAL	QTMP			: STD_LOGIC_VECTOR (WIDTH-1 DOWNTO 0);
SIGNAL	WINDOW_ENA	: STD_LOGIC;

BEGIN
PROCESS(CLK,RST,QTMP)

BEGIN

IF RISING_EDGE (CLK) THEN
	IF(RST = '1') THEN
		QTMP			<= CONV_STD_LOGIC_VECTOR(2,WIDTH);
		WINDOW_ENA	<= '0';
	ELSIF( (QTMP >= CONV_STD_LOGIC_VECTOR(0,WIDTH) AND QTMP <= CONV_STD_LOGIC_VECTOR(23,WIDTH)) ) THEN
		WINDOW_ENA	<= '0';
		QTMP			<= QTMP + '1';
	ELSIF( (QTMP >= CONV_STD_LOGIC_VECTOR(229,WIDTH) AND QTMP <= CONV_STD_LOGIC_VECTOR(279,WIDTH)) ) THEN
		WINDOW_ENA	<= '0';
		QTMP			<= QTMP + '1';
	ELSIF( (QTMP >= CONV_STD_LOGIC_VECTOR(485,WIDTH) AND QTMP <= CONV_STD_LOGIC_VECTOR(511,WIDTH)) ) THEN
		WINDOW_ENA	<= '0';
		QTMP			<= QTMP + '1';
	ELSE
		WINDOW_ENA	<= '1';
		QTMP			<= QTMP + '1';
	END IF;

	ENA_LOCK	<=	WINDOW_ENA;
	COUNT		<=	QTMP;

END IF;
END PROCESS;
	
END Behave;
