--------------------------------------------------------------------------------
-- Copyright (c) 1995-2012 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 14.1
--  \   \         Application : sch2hdl
--  /   /         Filename : MICRO_IF.vhf
-- /___/   /\     Timestamp : 08/04/2018 13:57:30
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: sch2hdl -intstyle ise -family spartan3a -flat -suppress -vhdl C:/XilinxDesigns/KDL_V34_TestPoints/MICRO_IF.vhf -w C:/XilinxDesigns/KDL_V34_TestPoints/MICRO_IF.sch
--Design Name: MICRO_IF
--Device: spartan3a
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--
----- CELL OR8_HXILINX_MICRO_IF -----
  
library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity OR8_HXILINX_MICRO_IF is
  
port(
    O  : out std_logic;

    I0  : in std_logic;
    I1  : in std_logic;
    I2  : in std_logic;
    I3  : in std_logic;
    I4  : in std_logic;
    I5  : in std_logic;
    I6  : in std_logic;
    I7  : in std_logic
  );
end OR8_HXILINX_MICRO_IF;

architecture OR8_HXILINX_MICRO_IF_V of OR8_HXILINX_MICRO_IF is
begin
  O <= (I0 or I1 or I2 or I3 or I4 or I5 or I6 or I7);
end OR8_HXILINX_MICRO_IF_V;

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity FallingEdgeDetect_MUSER_MICRO_IF is
   port ( CLK       : in    std_logic; 
          EDGEn     : in    std_logic; 
          ENA       : in    std_logic; 
          RST       : in    std_logic; 
          DET_PULSE : out   std_logic);
end FallingEdgeDetect_MUSER_MICRO_IF;

architecture BEHAVIORAL of FallingEdgeDetect_MUSER_MICRO_IF is
   attribute BOX_TYPE   : string ;
   signal Q         : std_logic_vector (2 downto 0);
   signal XLXN_1    : std_logic;
   component SP3A_SipoAClr3_Lsb
      port ( SDIN : in    std_logic; 
             Q    : out   std_logic_vector (2 downto 0); 
             CLK  : in    std_logic; 
             ACLR : in    std_logic);
   end component;
   
   component NAND2B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of NAND2B1 : component is "BLACK_BOX";
   
   component AND2B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2B1 : component is "BLACK_BOX";
   
begin
   EDGEDET_SIPO : SP3A_SipoAClr3_Lsb
      port map (ACLR=>RST,
                CLK=>CLK,
                SDIN=>XLXN_1,
                Q(2 downto 0)=>Q(2 downto 0));
   
   XLXI_5 : NAND2B1
      port map (I0=>EDGEn,
                I1=>ENA,
                O=>XLXN_1);
   
   XLXI_6 : AND2B1
      port map (I0=>Q(0),
                I1=>Q(1),
                O=>DET_PULSE);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity RD_DEVICE_MUSER_MICRO_IF is
   port ( CLK      : in    std_logic; 
          DevRD    : in    std_logic; 
          DevRDSel : in    std_logic_vector (7 downto 0); 
          RST      : in    std_logic; 
          RD_PULSE : out   std_logic_vector (7 downto 0));
end RD_DEVICE_MUSER_MICRO_IF;

architecture BEHAVIORAL of RD_DEVICE_MUSER_MICRO_IF is
   attribute BOX_TYPE   : string ;
   signal RDEDGE   : std_logic_vector (7 downto 0);
   signal XLXN_56  : std_logic;
   component FallingEdgeDetect_MUSER_MICRO_IF
      port ( EDGEn     : in    std_logic; 
             ENA       : in    std_logic; 
             CLK       : in    std_logic; 
             RST       : in    std_logic; 
             DET_PULSE : out   std_logic);
   end component;
   
   component NAND2B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of NAND2B1 : component is "BLACK_BOX";
   
   component VCC
      port ( P : out   std_logic);
   end component;
   attribute BOX_TYPE of VCC : component is "BLACK_BOX";
   
begin
   RDDETECT_0 : FallingEdgeDetect_MUSER_MICRO_IF
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(0),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(0));
   
   RDDETECT_1 : FallingEdgeDetect_MUSER_MICRO_IF
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(1),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(1));
   
   RDDETECT_2 : FallingEdgeDetect_MUSER_MICRO_IF
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(2),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(2));
   
   RDDETECT_3 : FallingEdgeDetect_MUSER_MICRO_IF
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(3),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(3));
   
   RDDETECT_4 : FallingEdgeDetect_MUSER_MICRO_IF
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(4),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(4));
   
   RDDETECT_5 : FallingEdgeDetect_MUSER_MICRO_IF
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(5),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(5));
   
   RDDETECT_6 : FallingEdgeDetect_MUSER_MICRO_IF
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(6),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(6));
   
   RDDETECT_7 : FallingEdgeDetect_MUSER_MICRO_IF
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(7),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(7));
   
   RDNAND_0 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(0),
                O=>RDEDGE(0));
   
   RDNAND_1 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(1),
                O=>RDEDGE(1));
   
   RDNAND_2 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(2),
                O=>RDEDGE(2));
   
   RDNAND_3 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(3),
                O=>RDEDGE(3));
   
   RDNAND_4 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(4),
                O=>RDEDGE(4));
   
   RDNAND_5 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(5),
                O=>RDEDGE(5));
   
   RDNAND_6 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(6),
                O=>RDEDGE(6));
   
   RDNAND_7 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(7),
                O=>RDEDGE(7));
   
   XLXI_43 : VCC
      port map (P=>XLXN_56);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity WR_DEVICE_MUSER_MICRO_IF is
   port ( CLK         : in    std_logic; 
          DevAddr     : in    std_logic_vector (6 downto 0); 
          DevData     : in    std_logic_vector (7 downto 0); 
          DevWR       : in    std_logic; 
          DevWRSel    : in    std_logic_vector (7 downto 0); 
          RST         : in    std_logic; 
          WR_DEV_ADDR : out   std_logic_vector (6 downto 0); 
          WR_DEV_DATA : out   std_logic_vector (7 downto 0); 
          WR_PULSE    : out   std_logic_vector (7 downto 0));
end WR_DEVICE_MUSER_MICRO_IF;

architecture BEHAVIORAL of WR_DEVICE_MUSER_MICRO_IF is
   attribute BOX_TYPE   : string ;
   attribute HU_SET     : string ;
   signal DEVICE_WRITE : std_logic;
   signal WR_HOLD_EN   : std_logic;
   signal XLXN_53      : std_logic;
   component FallingEdgeDetect_MUSER_MICRO_IF
      port ( EDGEn     : in    std_logic; 
             ENA       : in    std_logic; 
             CLK       : in    std_logic; 
             RST       : in    std_logic; 
             DET_PULSE : out   std_logic);
   end component;
   
   component SP3A_Reg7AClrEn
      port ( D    : in    std_logic_vector (6 downto 0); 
             CE   : in    std_logic; 
             CLK  : in    std_logic; 
             Q    : out   std_logic_vector (6 downto 0); 
             ACLR : in    std_logic);
   end component;
   
   component SP3A_Reg8AClrEn
      port ( D    : in    std_logic_vector (7 downto 0); 
             CE   : in    std_logic; 
             CLK  : in    std_logic; 
             Q    : out   std_logic_vector (7 downto 0); 
             ACLR : in    std_logic);
   end component;
   
   component AND2B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2B1 : component is "BLACK_BOX";
   
   component OR8_HXILINX_MICRO_IF
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             I3 : in    std_logic; 
             I4 : in    std_logic; 
             I5 : in    std_logic; 
             I6 : in    std_logic; 
             I7 : in    std_logic; 
             O  : out   std_logic);
   end component;
   
   component VCC
      port ( P : out   std_logic);
   end component;
   attribute BOX_TYPE of VCC : component is "BLACK_BOX";
   
   attribute HU_SET of XLXI_88 : label is "XLXI_88_1";
begin
   WRDETECT_0 : FallingEdgeDetect_MUSER_MICRO_IF
      port map (CLK=>CLK,
                EDGEn=>DevWRSel(0),
                ENA=>XLXN_53,
                RST=>RST,
                DET_PULSE=>WR_PULSE(0));
   
   WRDETECT_1 : FallingEdgeDetect_MUSER_MICRO_IF
      port map (CLK=>CLK,
                EDGEn=>DevWRSel(1),
                ENA=>XLXN_53,
                RST=>RST,
                DET_PULSE=>WR_PULSE(1));
   
   WRDETECT_2 : FallingEdgeDetect_MUSER_MICRO_IF
      port map (CLK=>CLK,
                EDGEn=>DevWRSel(2),
                ENA=>XLXN_53,
                RST=>RST,
                DET_PULSE=>WR_PULSE(2));
   
   WRDETECT_3 : FallingEdgeDetect_MUSER_MICRO_IF
      port map (CLK=>CLK,
                EDGEn=>DevWRSel(3),
                ENA=>XLXN_53,
                RST=>RST,
                DET_PULSE=>WR_PULSE(3));
   
   WRDETECT_4 : FallingEdgeDetect_MUSER_MICRO_IF
      port map (CLK=>CLK,
                EDGEn=>DevWRSel(4),
                ENA=>XLXN_53,
                RST=>RST,
                DET_PULSE=>WR_PULSE(4));
   
   WRDETECT_5 : FallingEdgeDetect_MUSER_MICRO_IF
      port map (CLK=>CLK,
                EDGEn=>DevWRSel(5),
                ENA=>XLXN_53,
                RST=>RST,
                DET_PULSE=>WR_PULSE(5));
   
   WRDETECT_6 : FallingEdgeDetect_MUSER_MICRO_IF
      port map (CLK=>CLK,
                EDGEn=>DevWRSel(6),
                ENA=>XLXN_53,
                RST=>RST,
                DET_PULSE=>WR_PULSE(6));
   
   WRDETECT_7 : FallingEdgeDetect_MUSER_MICRO_IF
      port map (CLK=>CLK,
                EDGEn=>DevWRSel(7),
                ENA=>XLXN_53,
                RST=>RST,
                DET_PULSE=>WR_PULSE(7));
   
   WR_DEVADDR_HOLD : SP3A_Reg7AClrEn
      port map (ACLR=>RST,
                CE=>WR_HOLD_EN,
                CLK=>CLK,
                D(6 downto 0)=>DevAddr(6 downto 0),
                Q(6 downto 0)=>WR_DEV_ADDR(6 downto 0));
   
   WR_DEVDATA_HOLD : SP3A_Reg8AClrEn
      port map (ACLR=>RST,
                CE=>WR_HOLD_EN,
                CLK=>CLK,
                D(7 downto 0)=>DevData(7 downto 0),
                Q(7 downto 0)=>WR_DEV_DATA(7 downto 0));
   
   XLXI_35 : AND2B1
      port map (I0=>DevWR,
                I1=>DEVICE_WRITE,
                O=>WR_HOLD_EN);
   
   XLXI_88 : OR8_HXILINX_MICRO_IF
      port map (I0=>DevWRSel(0),
                I1=>DevWRSel(1),
                I2=>DevWRSel(2),
                I3=>DevWRSel(3),
                I4=>DevWRSel(4),
                I5=>DevWRSel(5),
                I6=>DevWRSel(6),
                I7=>DevWRSel(7),
                O=>DEVICE_WRITE);
   
   XLXI_91 : VCC
      port map (P=>XLXN_53);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity MICRO_IF is
   port ( CLK          : in    std_logic; 
          CPU_ADD      : in    std_logic_vector (6 downto 0); 
          CPU_DIN      : in    std_logic_vector (7 downto 0); 
          CPU_READn    : in    std_logic; 
          CPU_WRITEn   : in    std_logic; 
          FPGA_SELECTn : in    std_logic; 
          RESET        : in    std_logic; 
          DevRDSel     : out   std_logic_vector (7 downto 0); 
          DevWRSel     : out   std_logic_vector (7 downto 0); 
          RdOEn        : out   std_logic; 
          RdSel        : out   std_logic_vector (2 downto 0); 
          RD_PULSE     : out   std_logic_vector (7 downto 0); 
          WR_DEV_ADDR  : out   std_logic_vector (6 downto 0); 
          WR_DEV_DATA  : out   std_logic_vector (7 downto 0); 
          WR_PULSE     : out   std_logic_vector (7 downto 0));
end MICRO_IF;

architecture BEHAVIORAL of MICRO_IF is
   signal DevAddr        : std_logic_vector (6 downto 0);
   signal DevData        : std_logic_vector (7 downto 0);
   signal DevRD          : std_logic;
   signal DevWR          : std_logic;
   signal DevRDSel_DUMMY : std_logic_vector (7 downto 0);
   signal DevWRSel_DUMMY : std_logic_vector (7 downto 0);
   component KRL_DANTE_ADDR_DECODE
      port ( CPU_CSn  : in    std_logic; 
             CPU_RDn  : in    std_logic; 
             CPU_WRn  : in    std_logic; 
             FPGA_Clk : in    std_logic; 
             FPGA_Rst : in    std_logic; 
             CPU_ADDR : in    std_logic_vector (6 downto 0); 
             CPU_DATA : in    std_logic_vector (7 downto 0); 
             DevRd    : out   std_logic; 
             DevWr    : out   std_logic; 
             RdOE     : out   std_logic; 
             DevAddr  : out   std_logic_vector (6 downto 0); 
             DevData  : out   std_logic_vector (7 downto 0); 
             DevRdSel : out   std_logic_vector (7 downto 0); 
             DevWrSel : out   std_logic_vector (7 downto 0); 
             RdSel    : out   std_logic_vector (2 downto 0));
   end component;
   
   component RD_DEVICE_MUSER_MICRO_IF
      port ( RST      : in    std_logic; 
             CLK      : in    std_logic; 
             DevRD    : in    std_logic; 
             DevRDSel : in    std_logic_vector (7 downto 0); 
             RD_PULSE : out   std_logic_vector (7 downto 0));
   end component;
   
   component WR_DEVICE_MUSER_MICRO_IF
      port ( RST         : in    std_logic; 
             CLK         : in    std_logic; 
             DevWRSel    : in    std_logic_vector (7 downto 0); 
             DevWR       : in    std_logic; 
             DevData     : in    std_logic_vector (7 downto 0); 
             DevAddr     : in    std_logic_vector (6 downto 0); 
             WR_PULSE    : out   std_logic_vector (7 downto 0); 
             WR_DEV_DATA : out   std_logic_vector (7 downto 0); 
             WR_DEV_ADDR : out   std_logic_vector (6 downto 0));
   end component;
   
begin
   DevRDSel(7 downto 0) <= DevRDSel_DUMMY(7 downto 0);
   DevWRSel(7 downto 0) <= DevWRSel_DUMMY(7 downto 0);
   ADDRESS_DECODER : KRL_DANTE_ADDR_DECODE
      port map (CPU_ADDR(6 downto 0)=>CPU_ADD(6 downto 0),
                CPU_CSn=>FPGA_SELECTn,
                CPU_DATA(7 downto 0)=>CPU_DIN(7 downto 0),
                CPU_RDn=>CPU_READn,
                CPU_WRn=>CPU_WRITEn,
                FPGA_Clk=>CLK,
                FPGA_Rst=>RESET,
                DevAddr(6 downto 0)=>DevAddr(6 downto 0),
                DevData(7 downto 0)=>DevData(7 downto 0),
                DevRd=>DevRD,
                DevRdSel(7 downto 0)=>DevRDSel_DUMMY(7 downto 0),
                DevWr=>DevWR,
                DevWrSel(7 downto 0)=>DevWRSel_DUMMY(7 downto 0),
                RdOE=>RdOEn,
                RdSel(2 downto 0)=>RdSel(2 downto 0));
   
   READDEVICESELECT : RD_DEVICE_MUSER_MICRO_IF
      port map (CLK=>CLK,
                DevRD=>DevRD,
                DevRDSel(7 downto 0)=>DevRDSel_DUMMY(7 downto 0),
                RST=>RESET,
                RD_PULSE(7 downto 0)=>RD_PULSE(7 downto 0));
   
   WRITEDEVICESELECT : WR_DEVICE_MUSER_MICRO_IF
      port map (CLK=>CLK,
                DevAddr(6 downto 0)=>DevAddr(6 downto 0),
                DevData(7 downto 0)=>DevData(7 downto 0),
                DevWR=>DevWR,
                DevWRSel(7 downto 0)=>DevWRSel_DUMMY(7 downto 0),
                RST=>RESET,
                WR_DEV_ADDR(6 downto 0)=>WR_DEV_ADDR(6 downto 0),
                WR_DEV_DATA(7 downto 0)=>WR_DEV_DATA(7 downto 0),
                WR_PULSE(7 downto 0)=>WR_PULSE(7 downto 0));
   
end BEHAVIORAL;


