--------------------------------------------------------------------------------
-- Copyright (c) 1995-2012 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 14.1
--  \   \         Application : sch2hdl
--  /   /         Filename : RD_DEVICE.vhf
-- /___/   /\     Timestamp : 08/04/2018 13:57:30
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: sch2hdl -intstyle ise -family spartan3a -flat -suppress -vhdl C:/XilinxDesigns/KDL_V34_TestPoints/RD_DEVICE.vhf -w C:/XilinxDesigns/KDL_V34_TestPoints/RD_DEVICE.sch
--Design Name: RD_DEVICE
--Device: spartan3a
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity FallingEdgeDetect_MUSER_RD_DEVICE is
   port ( CLK       : in    std_logic; 
          EDGEn     : in    std_logic; 
          ENA       : in    std_logic; 
          RST       : in    std_logic; 
          DET_PULSE : out   std_logic);
end FallingEdgeDetect_MUSER_RD_DEVICE;

architecture BEHAVIORAL of FallingEdgeDetect_MUSER_RD_DEVICE is
   attribute BOX_TYPE   : string ;
   signal Q         : std_logic_vector (2 downto 0);
   signal XLXN_1    : std_logic;
   component SP3A_SipoAClr3_Lsb
      port ( SDIN : in    std_logic; 
             Q    : out   std_logic_vector (2 downto 0); 
             CLK  : in    std_logic; 
             ACLR : in    std_logic);
   end component;
   
   component NAND2B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of NAND2B1 : component is "BLACK_BOX";
   
   component AND2B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2B1 : component is "BLACK_BOX";
   
begin
   EDGEDET_SIPO : SP3A_SipoAClr3_Lsb
      port map (ACLR=>RST,
                CLK=>CLK,
                SDIN=>XLXN_1,
                Q(2 downto 0)=>Q(2 downto 0));
   
   XLXI_5 : NAND2B1
      port map (I0=>EDGEn,
                I1=>ENA,
                O=>XLXN_1);
   
   XLXI_6 : AND2B1
      port map (I0=>Q(0),
                I1=>Q(1),
                O=>DET_PULSE);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity RD_DEVICE is
   port ( CLK      : in    std_logic; 
          DevRD    : in    std_logic; 
          DevRDSel : in    std_logic_vector (7 downto 0); 
          RST      : in    std_logic; 
          RD_PULSE : out   std_logic_vector (7 downto 0));
end RD_DEVICE;

architecture BEHAVIORAL of RD_DEVICE is
   attribute BOX_TYPE   : string ;
   signal RDEDGE   : std_logic_vector (7 downto 0);
   signal XLXN_56  : std_logic;
   component FallingEdgeDetect_MUSER_RD_DEVICE
      port ( EDGEn     : in    std_logic; 
             ENA       : in    std_logic; 
             CLK       : in    std_logic; 
             RST       : in    std_logic; 
             DET_PULSE : out   std_logic);
   end component;
   
   component NAND2B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of NAND2B1 : component is "BLACK_BOX";
   
   component VCC
      port ( P : out   std_logic);
   end component;
   attribute BOX_TYPE of VCC : component is "BLACK_BOX";
   
begin
   RDDETECT_0 : FallingEdgeDetect_MUSER_RD_DEVICE
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(0),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(0));
   
   RDDETECT_1 : FallingEdgeDetect_MUSER_RD_DEVICE
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(1),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(1));
   
   RDDETECT_2 : FallingEdgeDetect_MUSER_RD_DEVICE
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(2),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(2));
   
   RDDETECT_3 : FallingEdgeDetect_MUSER_RD_DEVICE
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(3),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(3));
   
   RDDETECT_4 : FallingEdgeDetect_MUSER_RD_DEVICE
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(4),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(4));
   
   RDDETECT_5 : FallingEdgeDetect_MUSER_RD_DEVICE
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(5),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(5));
   
   RDDETECT_6 : FallingEdgeDetect_MUSER_RD_DEVICE
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(6),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(6));
   
   RDDETECT_7 : FallingEdgeDetect_MUSER_RD_DEVICE
      port map (CLK=>CLK,
                EDGEn=>RDEDGE(7),
                ENA=>XLXN_56,
                RST=>RST,
                DET_PULSE=>RD_PULSE(7));
   
   RDNAND_0 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(0),
                O=>RDEDGE(0));
   
   RDNAND_1 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(1),
                O=>RDEDGE(1));
   
   RDNAND_2 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(2),
                O=>RDEDGE(2));
   
   RDNAND_3 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(3),
                O=>RDEDGE(3));
   
   RDNAND_4 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(4),
                O=>RDEDGE(4));
   
   RDNAND_5 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(5),
                O=>RDEDGE(5));
   
   RDNAND_6 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(6),
                O=>RDEDGE(6));
   
   RDNAND_7 : NAND2B1
      port map (I0=>DevRD,
                I1=>DevRDSel(7),
                O=>RDEDGE(7));
   
   XLXI_43 : VCC
      port map (P=>XLXN_56);
   
end BEHAVIORAL;


