-- Generic Terminal counter
-- Dec 22, 2004
-- Anthony Medina
-- Made this a sync reset
--
LIBRARY IEEE ;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY TCNT128 IS
	GENERIC(WIDTH	: INTEGER	:= 9);
PORT(
			ENAn	:IN	STD_LOGIC;
			CLK		:IN	STD_LOGIC;
			RST		:IN	STD_LOGIC;
			TCNT	:OUT	STD_LOGIC
	);
END TCNT128;

ARCHITECTURE Behave OF TCNT128 IS

SIGNAL	QTMP			: STD_LOGIC_VECTOR (WIDTH-1 DOWNTO 0);
SIGNAL	ENDCOUNT	: STD_LOGIC;

BEGIN
PROCESS(CLK,RST,QTMP,ENAn)

BEGIN

IF(RST = '1') THEN
	QTMP			<= CONV_STD_LOGIC_VECTOR(0,WIDTH);
	ENDCOUNT	<= '0';
ELSIF rising_edge(CLK) THEN
	IF((QTMP	<	CONV_STD_LOGIC_VECTOR(511,WIDTH)) AND ENAn = '0') THEN
		QTMP	<= QTMP + '1';
		IF(QTMP = CONV_STD_LOGIC_VECTOR(447,WIDTH))THEN
			ENDCOUNT	<= '1';
		ELSE
			ENDCOUNT	<= '0';
		END IF;
	ELSE
		QTMP			<= CONV_STD_LOGIC_VECTOR(0,WIDTH);
		ENDCOUNT	<= '0';
	END IF;
END IF;

END PROCESS;

	TCNT		<= ENDCOUNT;

END Behave;
