-- Generic Terminal counter
-- Dec 22, 2004
-- Anthony Medina
-- Made this a sync reset
--
LIBRARY IEEE ;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY TCNT8 IS
	GENERIC(WIDTH	: INTEGER	:= 3);
PORT(
			CLK		:IN	STD_LOGIC;
			RST		:IN	STD_LOGIC;
			TCNT	:OUT	STD_LOGIC
	);
END TCNT8;

ARCHITECTURE Behave OF TCNT8 IS

SIGNAL	QTMP			: STD_LOGIC_VECTOR (WIDTH-1 DOWNTO 0);
SIGNAL	ENDCOUNT	: STD_LOGIC;

BEGIN
PROCESS(CLK,RST,QTMP)

BEGIN

IF(RST = '1') THEN
	QTMP			<= CONV_STD_LOGIC_VECTOR(0,WIDTH);
	ENDCOUNT	<= '1';
ELSIF rising_edge(CLK) THEN
	IF(QTMP			<	CONV_STD_LOGIC_VECTOR(7,WIDTH)) THEN
		QTMP			<= QTMP + '1';
		ENDCOUNT	<= '1';
	ELSE
		QTMP			<= CONV_STD_LOGIC_VECTOR(7,WIDTH);
		ENDCOUNT	<= '0';
	END IF;
END IF;

END PROCESS;

	TCNT		<= ENDCOUNT;

END Behave;
