----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    02:51:42 03/26/2014 
-- Design Name: 
-- Module Name:    VerTypeInfo - BEHAVE 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
--
--	Sep 17, 2016
--	Ver 1.2 created to adjust mclk. Try to pull in by 3nS +/-1nS
--	
--	Oct 24, 2016
--	Ver 2.0 created for shipping version release
--
----------------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE ieee.numeric_std.ALL;

ENTITY VerTypeInfo is
	PORT(
			FPGA_VERS	:OUT	STD_LOGIC_VECTOR(7	DOWNTO	0);
			FPGA_TYPE	:OUT	STD_LOGIC_VECTOR(7	DOWNTO	0)
		);
END VerTypeInfo;

ARCHITECTURE BEHAVE of VerTypeInfo is
-- put declarations here.
	CONSTANT VERSION_INFO	: INTEGER RANGE 0 TO 16#FF#	:= 16#38#;  --	FPGA VERSION, 3.0, Clock Disturb SM + Dead Clock + Phase shift
																	--	And longer reset timeout to 4 seconds at 48K sample rate
																	--	Modified to account for BP DCM reset as well
																	--	Ver 3.2 will automatically reset the Brooklyn-II module for
																	--		about 1 second leaving all other dead clock/disturb timing
																	--		alone
																	--	Ver 3.4 is clean start where 3.2 left off
																	--	Ver 3.5 is LVDS output delayed 90 degrees to tiny logic
																	--	Ver 3.6 is LVDS output advanced 90 degrees (delayed 270)
																	--		requires resync adj to allow data to come out one clk cycle
																	--		sooner than current, state 73 instead of state 74
																	--		This allows reclocking using phase delays to adj up to
																	--		State 74 release to tiny logic
																	--	Ver 3.7 is 270 phs shift internally globally for MCLK
	CONSTANT TYPE_INFO1		: INTEGER RANGE 0 TO 16#FF#	:= 16#E0#;  --	FPGA TYPE

BEGIN

	FPGA_VERS	<=	CONV_STD_LOGIC_VECTOR(VERSION_INFO,8);
	FPGA_TYPE	<=	CONV_STD_LOGIC_VECTOR(TYPE_INFO1,8);

END BEHAVE;



