--------------------------------------------------------------------------------
-- Copyright (c) 1995-2012 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 14.1
--  \   \         Application : sch2hdl
--  /   /         Filename : XFRMEM32.vhf
-- /___/   /\     Timestamp : 08/04/2018 13:57:29
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: sch2hdl -intstyle ise -family spartan3a -flat -suppress -vhdl C:/XilinxDesigns/KDL_V34_TestPoints/XFRMEM32.vhf -w C:/XilinxDesigns/KDL_V34_TestPoints/XFRMEM32.sch
--Design Name: XFRMEM32
--Device: spartan3a
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity BNK_SWAP_DET_MUSER_XFRMEM32 is
   port ( BANK_MSB        : in    std_logic; 
          CLK             : in    std_logic; 
          BANK_SWAP_PULSE : out   std_logic);
end BNK_SWAP_DET_MUSER_XFRMEM32;

architecture BEHAVIORAL of BNK_SWAP_DET_MUSER_XFRMEM32 is
   attribute BOX_TYPE   : string ;
   signal FE_Q            : std_logic_vector (2 downto 0);
   signal RE_Q            : std_logic_vector (2 downto 0);
   signal XLXN_5          : std_logic;
   signal XLXN_6          : std_logic;
   component SP3A_Sipo3_Lsb
      port ( SDIN : in    std_logic; 
             Q    : out   std_logic_vector (2 downto 0); 
             CLK  : in    std_logic);
   end component;
   
   component AND2B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2B1 : component is "BLACK_BOX";
   
   component OR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2 : component is "BLACK_BOX";
   
begin
   FALL_EDGE_SIPO : SP3A_Sipo3_Lsb
      port map (CLK=>CLK,
                SDIN=>BANK_MSB,
                Q(2 downto 0)=>FE_Q(2 downto 0));
   
   RISE_EDGE_SIPO : SP3A_Sipo3_Lsb
      port map (CLK=>CLK,
                SDIN=>BANK_MSB,
                Q(2 downto 0)=>RE_Q(2 downto 0));
   
   XLXI_4 : AND2B1
      port map (I0=>RE_Q(2),
                I1=>RE_Q(1),
                O=>XLXN_6);
   
   XLXI_5 : AND2B1
      port map (I0=>FE_Q(1),
                I1=>FE_Q(2),
                O=>XLXN_5);
   
   XLXI_25 : OR2
      port map (I0=>XLXN_6,
                I1=>XLXN_5,
                O=>BANK_SWAP_PULSE);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity XFRMEM32 is
   port ( CLK           : in    std_logic; 
          LR_CLK        : in    std_logic; 
          RST           : in    std_logic; 
          RSYNC         : in    std_logic; 
          XFRMEM_DIN    : in    std_logic_vector (31 downto 0); 
          XFRMEM_WE     : in    std_logic; 
          XFRMEM_WRADDR : in    std_logic_vector (4 downto 0); 
          BS_DETECT     : out   std_logic; 
          RSYNC_2LR     : out   std_logic; 
          SDOUT1        : out   std_logic; 
          XFRHLD_EN     : out   std_logic; 
          XFRMEM_RDADDR : out   std_logic_vector (5 downto 0); 
          XFRMEM_WR     : out   std_logic_vector (5 downto 0); 
          XFRRDCNT_EN   : out   std_logic; 
          XFR_PISO_LD   : out   std_logic);
end XFRMEM32;

architecture BEHAVIORAL of XFRMEM32 is
   attribute BOX_TYPE   : string ;
   signal DSP_ZERO          : std_logic_vector (7 downto 0);
   signal INIT              : std_logic;
   signal RSYNC_2LR_ENABLE  : std_logic;
   signal WR_BANK           : std_logic;
   signal XFRMEM_DHOLD_A    : std_logic_vector (31 downto 0);
   signal XFRMEM_DOUT       : std_logic_vector (31 downto 0);
   signal XFRMEM_RD         : std_logic_vector (5 downto 0);
   signal XLXN_14           : std_logic;
   signal XLXN_99           : std_logic;
   signal RSYNC_2LR_DUMMY   : std_logic;
   signal XFRMEM_WR_DUMMY   : std_logic_vector (5 downto 0);
   signal XFRHLD_EN_DUMMY   : std_logic;
   signal XFR_PISO_LD_DUMMY : std_logic;
   signal XFRRDCNT_EN_DUMMY : std_logic;
   component BNK_SWAP_DET_MUSER_XFRMEM32
      port ( BANK_SWAP_PULSE : out   std_logic; 
             CLK             : in    std_logic; 
             BANK_MSB        : in    std_logic);
   end component;
   
   component SP3A_Piso32_Lsb
      port ( D      : in    std_logic_vector (31 downto 0); 
             P_LOAD : in    std_logic; 
             CLK    : in    std_logic; 
             SDOUT  : out   std_logic);
   end component;
   
   component SP3A_DpRAM_64x32
      port ( addra : in    std_logic_vector (5 downto 0); 
             dina  : in    std_logic_vector (31 downto 0); 
             wea   : in    std_logic_vector (0 downto 0); 
             clka  : in    std_logic; 
             addrb : in    std_logic_vector (5 downto 0); 
             doutb : out   std_logic_vector (31 downto 0); 
             enb   : in    std_logic; 
             clkb  : in    std_logic);
   end component;
   
   component BUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of BUF : component is "BLACK_BOX";
   
   component SP3A_RegEn32
      port ( D   : in    std_logic_vector (31 downto 0); 
             CE  : in    std_logic; 
             CLK : in    std_logic; 
             Q   : out   std_logic_vector (31 downto 0));
   end component;
   
   component SP3A_CntPS15_5
      port ( CLK       : in    std_logic; 
             SINIT     : in    std_logic; 
             THRESH0   : out   std_logic; 
             Q_THRESH0 : out   std_logic; 
             Q         : out   std_logic_vector (4 downto 0));
   end component;
   
   component SP3A_CntSClrEn6
      port ( CE        : in    std_logic; 
             CLK       : in    std_logic; 
             SCLR      : in    std_logic; 
             THRESH0   : out   std_logic; 
             Q_THRESH0 : out   std_logic; 
             Q         : out   std_logic_vector (5 downto 0));
   end component;
   
   component SP3A_CntSClr5
      port ( CLK       : in    std_logic; 
             SCLR      : in    std_logic; 
             THRESH0   : out   std_logic; 
             Q_THRESH0 : out   std_logic; 
             Q         : out   std_logic_vector (4 downto 0));
   end component;
   
   component SP3A_CntSClrThrErly5
      port ( CLK       : in    std_logic; 
             SCLR      : in    std_logic; 
             THRESH0   : out   std_logic; 
             Q_THRESH0 : out   std_logic; 
             Q         : out   std_logic_vector (4 downto 0));
   end component;
   
   component VCC
      port ( P : out   std_logic);
   end component;
   attribute BOX_TYPE of VCC : component is "BLACK_BOX";
   
   component OR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2 : component is "BLACK_BOX";
   
   component INV
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of INV : component is "BLACK_BOX";
   
   component FD
      generic( INIT : bit :=  '0');
      port ( C : in    std_logic; 
             D : in    std_logic; 
             Q : out   std_logic);
   end component;
   attribute BOX_TYPE of FD : component is "BLACK_BOX";
   
   component AND2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2 : component is "BLACK_BOX";
   
   component GND
      port ( G : out   std_logic);
   end component;
   attribute BOX_TYPE of GND : component is "BLACK_BOX";
   
begin
   RSYNC_2LR <= RSYNC_2LR_DUMMY;
   XFRHLD_EN <= XFRHLD_EN_DUMMY;
   XFRMEM_WR(5 downto 0) <= XFRMEM_WR_DUMMY(5 downto 0);
   XFRRDCNT_EN <= XFRRDCNT_EN_DUMMY;
   XFR_PISO_LD <= XFR_PISO_LD_DUMMY;
   BSDETECT : BNK_SWAP_DET_MUSER_XFRMEM32
      port map (BANK_MSB=>WR_BANK,
                CLK=>CLK,
                BANK_SWAP_PULSE=>BS_DETECT);
   
   CH_XFERPISO_LSB : SP3A_Piso32_Lsb
      port map (CLK=>CLK,
                D(31 downto 0)=>XFRMEM_DHOLD_A(31 downto 0),
                P_LOAD=>XFR_PISO_LD_DUMMY,
                SDOUT=>SDOUT1);
   
   LVDS_TO_DSP_XFERMEM : SP3A_DpRAM_64x32
      port map (addra(5 downto 0)=>XFRMEM_WR_DUMMY(5 downto 0),
                addrb(5 downto 0)=>XFRMEM_RD(5 downto 0),
                clka=>CLK,
                clkb=>CLK,
                dina(31 downto 0)=>XFRMEM_DIN(31 downto 0),
                enb=>XLXN_14,
                wea(0)=>XFRMEM_WE,
                doutb(31 downto 0)=>XFRMEM_DOUT(31 downto 0));
   
   RDADDRBUF_0 : BUF
      port map (I=>XFRMEM_RD(0),
                O=>XFRMEM_RDADDR(0));
   
   RDADDRBUF_1 : BUF
      port map (I=>XFRMEM_RD(1),
                O=>XFRMEM_RDADDR(1));
   
   RDADDRBUF_2 : BUF
      port map (I=>XFRMEM_RD(2),
                O=>XFRMEM_RDADDR(2));
   
   RDADDRBUF_3 : BUF
      port map (I=>XFRMEM_RD(3),
                O=>XFRMEM_RDADDR(3));
   
   RDADDRBUF_4 : BUF
      port map (I=>XFRMEM_RD(4),
                O=>XFRMEM_RDADDR(4));
   
   RDADDRBUF_5 : BUF
      port map (I=>XFRMEM_RD(5),
                O=>XFRMEM_RDADDR(5));
   
   WRADDRBUF_0 : BUF
      port map (I=>XFRMEM_WRADDR(0),
                O=>XFRMEM_WR_DUMMY(0));
   
   WRADDRBUF_1 : BUF
      port map (I=>XFRMEM_WRADDR(1),
                O=>XFRMEM_WR_DUMMY(1));
   
   WRADDRBUF_2 : BUF
      port map (I=>XFRMEM_WRADDR(2),
                O=>XFRMEM_WR_DUMMY(2));
   
   WRADDRBUF_3 : BUF
      port map (I=>XFRMEM_WRADDR(3),
                O=>XFRMEM_WR_DUMMY(3));
   
   WRADDRBUF_4 : BUF
      port map (I=>XFRMEM_WRADDR(4),
                O=>XFRMEM_WR_DUMMY(4));
   
   WRADDRBUF_5 : BUF
      port map (I=>WR_BANK,
                O=>XFRMEM_WR_DUMMY(5));
   
   XFERHOLD_REG : SP3A_RegEn32
      port map (CE=>XFRHLD_EN_DUMMY,
                CLK=>CLK,
                D(31 downto 28)=>DSP_ZERO(7 downto 4),
                D(27 downto 4)=>XFRMEM_DOUT(31 downto 8),
                D(3 downto 0)=>DSP_ZERO(3 downto 0),
                Q(31 downto 0)=>XFRMEM_DHOLD_A(31 downto 0));
   
   XFERMEM_HOLD : SP3A_CntPS15_5
      port map (CLK=>CLK,
                SINIT=>INIT,
                Q=>open,
                Q_THRESH0=>XFRHLD_EN_DUMMY,
                THRESH0=>open);
   
   XFERMEM_RDCNT : SP3A_CntSClrEn6
      port map (CE=>XFRRDCNT_EN_DUMMY,
                CLK=>CLK,
                SCLR=>INIT,
                Q(5 downto 0)=>XFRMEM_RD(5 downto 0),
                Q_THRESH0=>open,
                THRESH0=>open);
   
   XFERMEM_RDEN : SP3A_CntSClr5
      port map (CLK=>CLK,
                SCLR=>INIT,
                Q=>open,
                Q_THRESH0=>XFRRDCNT_EN_DUMMY,
                THRESH0=>open);
   
   XFERPISO_LOAD : SP3A_CntSClrThrErly5
      port map (CLK=>CLK,
                SCLR=>INIT,
                Q=>open,
                Q_THRESH0=>XFR_PISO_LD_DUMMY,
                THRESH0=>open);
   
   XLXI_7 : VCC
      port map (P=>XLXN_14);
   
   XLXI_10 : OR2
      port map (I0=>RST,
                I1=>RSYNC_2LR_DUMMY,
                O=>INIT);
   
   XLXI_11 : INV
      port map (I=>XFRMEM_RD(5),
                O=>WR_BANK);
   
   XLXI_24 : FD
      port map (C=>LR_CLK,
                D=>RSYNC_2LR_ENABLE,
                Q=>XLXN_99);
   
   XLXI_25 : INV
      port map (I=>XLXN_99,
                O=>RSYNC_2LR_ENABLE);
   
   XLXI_26 : AND2
      port map (I0=>RSYNC,
                I1=>XLXN_99,
                O=>RSYNC_2LR_DUMMY);
   
   ZERODSPGND_0 : GND
      port map (G=>DSP_ZERO(0));
   
   ZERODSPGND_1 : GND
      port map (G=>DSP_ZERO(1));
   
   ZERODSPGND_2 : GND
      port map (G=>DSP_ZERO(2));
   
   ZERODSPGND_3 : GND
      port map (G=>DSP_ZERO(3));
   
   ZERODSPGND_4 : GND
      port map (G=>DSP_ZERO(4));
   
   ZERODSPGND_5 : GND
      port map (G=>DSP_ZERO(5));
   
   ZERODSPGND_6 : GND
      port map (G=>DSP_ZERO(6));
   
   ZERODSPGND_7 : GND
      port map (G=>DSP_ZERO(7));
   
end BEHAVIORAL;


