-- Vhdl test bench created from schematic C:\XilinxWebPack92Designs\SuperRIO\SRIO_MainProcessor\KRL_Dante.sch - Mon Nov 09 14:21:07 2009
--
-- Notes: 
-- 1) This testbench template has been automatically generated using types
-- std_logic and std_logic_vector for the ports of the unit under test.
-- Xilinx recommends that these types always be used for the top-level
-- I/O of a design in order to guarantee that the testbench will bind
-- correctly to the timing (post-route) simulation model.
-- 2) To use this template as your testbench, change the filename to any
-- name of your choice with the extension .vhd, and use the "Source->Add"
-- menu in Project Navigator to import the testbench. Then
-- edit the user defined section below, adding code to generate the 
-- stimulus for your design.
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
--use IEEE.NUMERIC_STD.ALL;
LIBRARY UNISIM;
USE UNISIM.Vcomponents.ALL;

ENTITY KRL_Dante_KRL_Dante_sch_tb IS
END KRL_Dante_KRL_Dante_sch_tb;

ARCHITECTURE behavioral OF 
      KRL_Dante_KRL_Dante_sch_tb IS 

COMPONENT KRL_Dante
	PORT(
				RSTn							:IN	STD_LOGIC; 
				D_DIN0							:IN	STD_LOGIC; 
				D_DIN1							:IN	STD_LOGIC; 
				D_DIN2							:IN	STD_LOGIC; 
				D_DIN3							:IN	STD_LOGIC; 
				DANTE_MCLK				:IN	STD_LOGIC; 
				DANTE_SCLK					:IN	STD_LOGIC; 
				DANTE_LRCLK				:IN	STD_LOGIC; 
				DANTE_PHY_RST			:IN	STD_LOGIC; 
				BP_MCLK						:IN	STD_LOGIC; 
				BP_LRCLK						:IN	STD_LOGIC; 
				BPI2S_DIN					:IN	STD_LOGIC_VECTOR (15 DOWNTO 0); 
				MCU_ADDR					:IN	STD_LOGIC_VECTOR (6 DOWNTO 0); 
				MCU_WRn						:IN	STD_LOGIC; 
				MCU_RDn						:IN	STD_LOGIC; 
				FPGA_CSn						:IN	STD_LOGIC;
				GE_STATUS					:IN	STD_LOGIC_VECTOR	(4 DOWNTO 0);
				ENABLE_TRANSFERSn	:OUT	STD_LOGIC;
				D_SDO_0						:OUT	STD_LOGIC; 
				D_SDO_1						:OUT	STD_LOGIC; 
				D_SDO_2						:OUT	STD_LOGIC; 
				D_SDO_3						:OUT	STD_LOGIC; 
				D_SDOUT_LD				:OUT	STD_LOGIC; 
				BP_FRAMESYNC				:OUT	STD_LOGIC; 
				BP_RSYNC					:OUT	STD_LOGIC; 
				BP_LVDS_OUT				:OUT	STD_LOGIC; 
				I2S_FRAMESYNC			:OUT	STD_LOGIC; 
				I2S_RSYNC					:OUT	STD_LOGIC;
				MCU_BIDAT					:INOUT	STD_LOGIC_VECTOR (7 DOWNTO 0) 
		  );
END COMPONENT;

-- 	INPUTS
	SIGNAL RSTn							:	STD_LOGIC											:=	'0';
	SIGNAL D_DIN0							:	STD_LOGIC											:=	'0';
	SIGNAL D_DIN1							:	STD_LOGIC											:=	'0';
	SIGNAL D_DIN2							:	STD_LOGIC											:=	'0';
	SIGNAL D_DIN3							:	STD_LOGIC											:=	'0';
	SIGNAL DANTE_MCLK				:	STD_LOGIC											:=	'0';
	SIGNAL DANTE_SCLK					:	STD_LOGIC											:=	'0';
	SIGNAL DANTE_LRCLK				:	STD_LOGIC											:=	'0';
	SIGNAL DANTE_PHY_RST			:	STD_LOGIC											:=	'1';
	SIGNAL BP_MCLK						:	STD_LOGIC											:=	'0';
	SIGNAL BP_LRCLK						:	STD_LOGIC											:=	'0';
	SIGNAL	BPI2S_DIN					:	STD_LOGIC_VECTOR (15 DOWNTO 0)		:=	CONV_STD_LOGIC_VECTOR(0,16);
	SIGNAL MCU_ADDR					:	STD_LOGIC_VECTOR (6 DOWNTO 0)		:=	(OTHERS	=>	'0');
	SIGNAL MCU_WRn						:	STD_LOGIC											:=	'1';
	SIGNAL MCU_RDn						:	STD_LOGIC											:=	'1';
	SIGNAL FPGA_CSn						:	STD_LOGIC											:=	'1';
	SIGNAL	GE_STATUS					:	STD_LOGIC_VECTOR	(4 DOWNTO 0)		:=	(OTHERS	=>	'0');
	SIGNAL MCU_BIDAT					:	STD_LOGIC_VECTOR (7 DOWNTO 0)		:=	(OTHERS	=>	'Z');
	
--	OUTPUTS
	SIGNAL ENABLE_TRANSFERSn	:	STD_LOGIC;
	SIGNAL D_SDO_0						:	STD_LOGIC; 
	SIGNAL D_SDO_1						:	STD_LOGIC; 
	SIGNAL D_SDO_2						:	STD_LOGIC; 
	SIGNAL D_SDO_3						:	STD_LOGIC; 
	SIGNAL D_SDOUT_LD				:	STD_LOGIC; 
	SIGNAL BP_FRAMESYNC				:	STD_LOGIC; 
	SIGNAL BP_RSYNC					:	STD_LOGIC; 
	SIGNAL BP_LVDS_OUT				:	STD_LOGIC; 
	SIGNAL I2S_FRAMESYNC			:	STD_LOGIC; 
	SIGNAL I2S_RSYNC					:	STD_LOGIC; 
--
--#####################################################################################
--=====================================================================================
--	Temp Signals for Simulation
--=====================================================================================
--#####################################################################################
-- 
	SIGNAL DATA_IN		:	STD_LOGIC_VECTOR (31 DOWNTO 0)	:= (others => '0');
	SIGNAL I2SDAT_IN	:	STD_LOGIC_VECTOR (31 DOWNTO 0)	:= (others => '0');
--
--#####################################################################################
--=====================================================================================
--	Clock and reset constants
--	For SuperRIO, TDM-8 timing, MCLK is half 32KD MCLK so that here it equals 512 bits * sample rate (48K * 512 = 24.576MHz)
--	TDM-8	=	8chnls LEFT (8 * 32bits = 256bits) + 8chnls RIGHT (8 * 32bits = 256bits) = 512bits total per sample period.
--	TDM-16	=	16chnls LEFT (16 * 32bits = 512bits) + 16chnls RIGHT (16 * 32bits = 512bits) = 1024bits total per sample period.
--=====================================================================================
--#####################################################################################
	CONSTANT	BPMCLKPER	:	time		:=	20 ns;		-- Bit clk	@ 48.821KHz     This is for 1024 bits or 32 channels/sample
--	CONSTANT	BPSCLKPER	:	time		:=	160 ns;		-- I2S clk	@ 48.821KHz 
	CONSTANT	BPLCLKPER	:	time		:=	20480 ns;	-- LR  clk	@ 48.821KHz
--#####################################################################################
--	CONSTANT	MCLKPER		:	time		:=	20 ns;			-- Bit clk	@ 97.6563KHz
--	CONSTANT	LCLKPER		:	time		:=	10240 ns;		-- LR  clk	@ 97.6563KHz
--#####################################################################################
	CONSTANT	DSCLKPER	:	time		:=	40 ns;			-- Bit clk	@ 48.821KHz     This is for 512 bits or 16 channels/sample
	CONSTANT	LCLKPER		:	time		:=	20480 ns;		-- LR  clk	@ 48.821KHz
--#####################################################################################
--	CONSTANT	MCLKPER		:	time		:=	40500 ps;		-- Bit clk	@ 48KHz	| These get as close to actual frequencies but are
--	CONSTANT	LCLKPER		:	time		:=	20736 ns;		-- LR  clk	@ 48KHz	| can keep the edges aligned perfectly.
--#####################################################################################
--	CONSTANT	MCLKPER		:	time		:=	44250 ps;		-- Bit clk	@ 44.1KHz	| These get as close to actual frequencies but are 
--	CONSTANT	LCLKPER		:	time		:=	22656 ns;		-- LR  clk	@ 44.1KHz	| can keep the edges aligned perfectly.
--#####################################################################################
--	CONSTANT	SCLKPER		:	time		:=	354000 ps;	-- I2S clk	@ 44.1KHz		| still evenly divisable for the simulator.
	CONSTANT	SCLKPER		:	time		:=	320 ns;			-- I2S clk	@ 48.821KHz
--	CONSTANT	SCLKPER		:	time		:=	324000 ps;	-- I2S clk	@ 48KHz		| still evenly divisable for the simulator. 
--	CONSTANT	SCLKPER		:	time		:=	160 ns;			-- I2S clk	@ 97.6563KHz
--#####################################################################################
	CONSTANT	RSTPER				:	TIME			:=	500 ns;	--	Reset
	CONSTANT	CPUWR				:	TIME			:=	100 ns;	--	CPU WR CYCLE
	CONSTANT	CPURD				:	TIME			:=	100 ns;	--	CPU RD CYCLE
	CONSTANT	Clk1_T				:	TIME			:=	10 ns;		--	Bracket RD/WR with CS
	CONSTANT	SCLKDELAY		:	INTEGER	:=	28;			--	Set to 28 for 48KHz, 23 for 96KHz sample rates
	CONSTANT	SCLKSTIMDLY	:	INTEGER	:=	27;			--	Set to 27 for 48KHz, 23 for 96KHz sample rates
	CONSTANT	MCKDLY			:	INTEGER	:=	474;			--	Align incoming data with RESYNC
																							--	263 @ 48.821KHz / 226 @ 97.6563KHz, due to RST constant
	CONSTANT	STIMDLY			:	INTEGER	:=	473;			--	Align incoming data with RESYNC
																							--	262 @ 48.821KHz / 225 @ 97.6563KHz, due to RST constant
	CONSTANT	FRAMEDLY			:	INTEGER	RANGE	15 DOWNTO 0	:=	4;
--=====================================================================================
--#####################################################################################

BEGIN

UUT: KRL_Dante
	PORT MAP(
					RSTn							=> RSTn, 
					BP_RSYNC					=> BP_RSYNC, 
					BP_LRCLK						=> BP_LRCLK, 
					D_SDO_0						=> D_SDO_0, 
					D_SDO_1						=> D_SDO_1, 
					D_SDO_2						=> D_SDO_2, 
					D_SDO_3						=> D_SDO_3, 
					D_SDOUT_LD				=> D_SDOUT_LD, 
					D_DIN0							=> D_DIN0, 
					D_DIN1							=> D_DIN1, 
					D_DIN2							=> D_DIN2, 
					D_DIN3							=> D_DIN3, 
					DANTE_MCLK				=> DANTE_MCLK, 
					DANTE_SCLK					=> DANTE_SCLK, 
					DANTE_LRCLK				=> DANTE_LRCLK, 
					DANTE_PHY_RST			=> DANTE_PHY_RST,
					BP_MCLK						=> BP_MCLK, 
					BP_LVDS_OUT				=> BP_LVDS_OUT, 
					BP_FRAMESYNC				=> BP_FRAMESYNC, 
					I2S_FRAMESYNC			=> I2S_FRAMESYNC, 
					I2S_RSYNC					=> I2S_RSYNC, 
					BPI2S_DIN					=> BPI2S_DIN, 
					MCU_ADDR					=> MCU_ADDR, 
					MCU_WRn						=> MCU_WRn, 
					MCU_RDn						=> MCU_RDn, 
					FPGA_CSn						=> FPGA_CSn,
					GE_STATUS					=> GE_STATUS,
					MCU_BIDAT					=> MCU_BIDAT,
					ENABLE_TRANSFERSn	=> ENABLE_TRANSFERSn
				);
--
--#####################################################################################
--=====================================================================================
--	CLOCKS AND RESET
--=====================================================================================
--#####################################################################################
--
TB_RSTn:
Process
Begin

	RSTn	<= '0';
	wait for (RSTPER * 3);
	RSTn	<= '1';
	wait;

End Process TB_RSTn;
--
--####### DANTE SCLK/LCLK
--
TB_DMCLK:
Process
Begin

	DANTE_MCLK	<= '0';		-- DANTE MCLK IS SAME PERIOD
	wait for (BPMCLKPER/2);	-- AS 32KD FRAME MCLK BUT NOT
	DANTE_MCLK	<= '1';		-- PHASE ALIGNED
	wait for (BPMCLKPER/2);	--

End Process TB_DMCLK;

TB_SCLK:
Process
Begin

	DANTE_SCLK	<= '0';			-- DANTE SCLK aligned internally via
	wait for (DSCLKPER/2);		-- DCM to line up outgoing data more
	DANTE_SCLK	<= '1';			-- centered to better allow for setup
	wait for (DSCLKPER/2);		-- to the DANTE module, this TBD at prototype test

End Process TB_SCLK;

TB_LRCLK:
Process
Begin

	DANTE_LRCLK	<= '0';		-- Phase opposite to simulate
	wait for (LCLKPER/2);		-- rate lock but not phase lock
	DANTE_LRCLK	<= '1';		-- In phase simulates word clk lock (LRCLK)
	wait for (LCLKPER/2);		-- to backplane word clk (LRCLK) Default '0' then '1'

End Process TB_LRCLK;
--
--####### BACKPLANE MCLK/LCLK
--
TB_BPMCLK:
Process
Begin

	BP_MCLK	<= '0';				--
	wait for (BPMCLKPER/2);	--
	BP_MCLK	<= '1';				--
	wait for (BPMCLKPER/2);	--

End Process TB_BPMCLK;

TB_BPLRCLK:
Process
Begin

	BP_LRCLK	<= '0';
	wait for (BPLCLKPER/2);
	BP_LRCLK	<= '1';
	wait for (BPLCLKPER/2);

End Process TB_BPLRCLK;
--
--#####################################################################################
--=====================================================================================
--	CONTINUOUS I2S STIM DATA FOR DANTE INPUT
--=====================================================================================
--#####################################################################################
--
STIM_DIN:
Process

Variable	DIN		:	Integer	:= 0;

Begin

	DATA_IN		<= X"00000000";
	wait for ((RSTPER * 3) + (2 * LCLKPER) + (STIMDLY*DSCLKPER) + (DSCLKPER/4) + (DSCLKPER/4));

	for z in 511 downto 0 loop
--=====================================================================================
--		L/R CLK 'LO' (Left channel)
--=====================================================================================
--		DATA_IN	<= X"4AAAAAA0";			-- Use this section to check bit alignment
--		wait for DSCLKPER * 256;				-- 
		DATA_IN	<= X"8AAAAAA0";			-- Use this section to check bit alignment
		wait for DSCLKPER * 64;				-- TDM0/TDM1 (TDM1/TDM2 OR TDM17/TDM18 IF ON INPUT STREAM 2)
--		DATA_IN	<= X"4AAAAAA0";			-- Use this section to check bit alignment
--		wait for DSCLKPER * 32;				-- TDM0
--		DATA_IN	<= X"00000000";			-- 
--		wait for DSCLKPER * 224;				-- 
--		DATA_IN	<= X"4AAAAAA0";			-- 
--		wait for DSCLKPER * 32;				-- 
		DATA_IN	<= X"00000000";			-- 
		wait for DSCLKPER * 192;				-- 
															-- 
--=====================================================================================
--		L/R CLK 'HI' (Right channel)
--=====================================================================================
--		DATA_IN	<= X"69696900";			-- Use this section to check bit alignment
--		wait for DSCLKPER * 256;				-- TDM8
--		DATA_IN	<= X"69696900";			-- Use this section to check bit alignment
--		wait for DSCLKPER * 32;				-- TDM8
--		DATA_IN	<= X"00000000";			-- 
--		wait for DSCLKPER * 224;				-- 
--		DATA_IN	<= X"69696900";			-- 
--		wait for DSCLKPER * 32;				-- 
		DATA_IN	<= X"00000000";			-- 
		wait for DSCLKPER * 256;				-- 
															-- 
	end loop;

	wait;
End Process STIM_DIN;
--
--#####################################################################################
--=====================================================================================
--	CONTINUOUS I2S DATA INTO FPGA FROM DANTE
--=====================================================================================
--#####################################################################################
--
STIM_DAT:
Process
Begin
	wait for ((RSTPER * 3) + (3 * LCLKPER) + (MCKDLY*DSCLKPER) + (DSCLKPER/4) + (DSCLKPER/4));

	for x in 65535 downto 0 loop
			for y in 31 downto 0 loop

				D_DIN0		<=	DATA_IN(y);	-- TDM0 thru TDM15 on LVDS backplane		(TDM1 to TDM16 DANTE)
--				D_DIN1		<=	DATA_IN(y);	-- TDM16 thru TDM 31 on LVDS backplane	(TDM17 to TDM32 DANTE)
--				D_DIN2		<=	DATA_IN(y);	-- TDM32 thru TDM 47 on LVDS backplane	(TDM33 to TDM48 DANTE)
--				D_DIN3		<=	DATA_IN(y);	-- TDM48 thru TDM 63 on LVDS backplane	(TDM49 to TDM64 DANTE)

				wait for DSCLKPER;
			end loop;
	end loop;

	wait;
End Process STIM_DAT;
--
--#####################################################################################
--=====================================================================================
--	CONTINUOUS I2S STIM DATA FROM OUT1 FPGA
--=====================================================================================
--#####################################################################################
--
STIM_BPI2S_DIN:
Process

Variable	I2SSTIMDATA		:	 Integer	:= 0;

Begin

	I2SDAT_IN		<= CONV_STD_LOGIC_VECTOR(I2SSTIMDATA,32);
	wait for ((RSTPER * 3) + (LCLKPER/2 * 3) + (SCLKPER * SCLKSTIMDLY) + (SCLKPER/4) + BPMCLKPER);

	for z in 65535 downto 0 loop
		I2SSTIMDATA	:= 16#AAAAAA00#;												-- Left TDM
		I2SDAT_IN		<= CONV_STD_LOGIC_VECTOR(I2SSTIMDATA,32);	-- Use this section to check bit alignment
		wait for SCLKPER * 32;																	-- 32-bit channels X 1 channels
																											--
		I2SSTIMDATA	:= 16#96969600#;												-- Right TDM
		I2SDAT_IN		<= CONV_STD_LOGIC_VECTOR(I2SSTIMDATA,32);	-- Use this section to check bit alignment
		wait for SCLKPER * 32;																	-- 32-bit channels X 1 channels
	end loop;
	
	wait;

End Process STIM_BPI2S_DIN;
--
--#####################################################################################
--=====================================================================================
--	CONTINUOUS I2S DATA INTO FPGA FROM OUT1 FPGA
--=====================================================================================
--#####################################################################################
--
STIM_I2SDAT:
Process

Begin

	BPI2S_DIN	<= CONV_STD_LOGIC_VECTOR(0,16);
	wait for ((RSTPER * 3) + (LCLKPER/2 * 3) + (SCLKPER * SCLKDELAY) + (SCLKPER/4) + BPMCLKPER + (LCLKPER * 3));

	for x in 65535 downto 0 loop
		for y in 31 downto 0 loop

--=====================================================================================
--	16 AUDIO CHANNELS TO DANTE SERIAL INPUT 1
--
				BPI2S_DIN(0)	<= I2SDAT_IN(y);
--				BPI2S_DIN(1)	<= I2SDAT_IN(y);
--				BPI2S_DIN(2)	<= I2SDAT_IN(y);
--				BPI2S_DIN(3)	<= I2SDAT_IN(y);
--				BPI2S_DIN(4)	<= I2SDAT_IN(y);
--				BPI2S_DIN(5)	<= I2SDAT_IN(y);
--				BPI2S_DIN(6)	<= I2SDAT_IN(y);
--				BPI2S_DIN(7)	<= I2SDAT_IN(y);
--=====================================================================================
--	16 AUDIO CHANNELS TO DANTE SERIAL INPUT 2
--
--				BPI2S_DIN(8)	<= I2SDAT_IN(y);
--				BPI2S_DIN(9)	<= I2SDAT_IN(y);
--				BPI2S_DIN(10)	<= I2SDAT_IN(y);
--				BPI2S_DIN(11)	<= I2SDAT_IN(y);
--				BPI2S_DIN(12)	<= I2SDAT_IN(y);
--				BPI2S_DIN(13)	<= I2SDAT_IN(y);
--				BPI2S_DIN(14)	<= I2SDAT_IN(y);
--				BPI2S_DIN(15)	<= I2SDAT_IN(y);

			wait for SCLKPER;
		end loop;
	end loop;

	BPI2S_DIN	<= CONV_STD_LOGIC_VECTOR(0,16);
	wait;

End Process STIM_I2SDAT;
--
--#####################################################################################
--=====================================================================================
--	PROCESSOR STIMULUS
--=====================================================================================
--#####################################################################################
--
STIM_MCU:
Process

Variable	MPUADDR	:	INTEGER	RANGE 16#FFF# DOWNTO 0	:=  0;
Variable	MPUDATA	:	INTEGER	RANGE 16#FFF# DOWNTO 0	:=  0;

Begin

	MPUADDR		:=	16#000#;
	MPUDATA		:=	16#000#;
	MCU_ADDR	<=	CONV_STD_LOGIC_VECTOR(MPUADDR,7);
	MCU_BIDAT	<=	(OTHERS	=>	'Z');
	WAIT FOR BPLCLKPER * 8;
--=====================================================================================
--	ENABLE ERR INTERRUPT, BUT KEEP AUDIO TRANSFERS DISABLED UNTIL LATER IN THE SIM, A 0 TO BIT 1 (3h TO 1h)
--=====================================================================================
	MPUADDR		:=	16#20#;	-- ADDRESS FOR CONTROL REGISTER
	MPUDATA		:=	1;				--	DEFAULT FOR THIS REG IS 3h ON PWR UP, 1h ENABLES INT, KEEP AUDIO TRANSFERS DISABLED
	MCU_ADDR	<= CONV_STD_LOGIC_VECTOR(MPUADDR,7);
	MCU_BIDAT	<= CONV_STD_LOGIC_VECTOR(MPUDATA,8);
		WAIT FOR (Clk1_T);
			FPGA_CSn	<= '0';
			WAIT FOR (Clk1_T);
				MCU_WRn	<= '0';
				WAIT FOR (CPUWR);
				MCU_WRn	<= '1';
			WAIT FOR (Clk1_T);
			FPGA_CSn	<= '1';
		WAIT FOR (Clk1_T);
	FPGA_CSn		<=	'1';
	MCU_WRn		<=	'1';
	MCU_RDn		<=	'1';
	MPUADDR		:=	0;
	MPUDATA		:=	0;
	MCU_ADDR	<=	(OTHERS	=>	'0');
	MCU_BIDAT	<=	(OTHERS	=>	'Z');
	WAIT FOR RSTPER;
--=====================================================================================
--	CYCLE THRU ALL READ ADDRESSES TO CHECK FOR PROPER FUNCTION OF DEFINED READ ADDRESSING
--=====================================================================================
	FOR X IN 127 DOWNTO 0 LOOP
		MCU_ADDR	<= CONV_STD_LOGIC_VECTOR(MPUADDR,7);
		WAIT FOR (Clk1_T);
			FPGA_CSn	<= '0';
			WAIT FOR (Clk1_T);
				MCU_RDn	<= '0';
				WAIT FOR (CPURD);
				MCU_RDn	<= '1';
			WAIT FOR (Clk1_T);
			FPGA_CSn	<= '1';
		WAIT FOR (Clk1_T);
		MCU_ADDR	<=	(OTHERS	=>	'0');
		MPUADDR		:=	MPUADDR + 1;
		WAIT FOR (CPURD * 2);
	END LOOP;

	FPGA_CSn		<=	'1';
	MCU_WRn		<=	'1';
	MCU_RDn		<=	'1';
	MPUADDR		:=	0;
	MPUDATA		:=	0;
	MCU_ADDR	<=	(OTHERS	=>	'0');
	MCU_BIDAT	<=	(OTHERS	=>	'Z');
--=====================================================================================
--	CHANGE THE TX/RX FRAME DELAY BUFFERS TO 2 FOR SIMULATION. REGISTERS PRESET FOR 8 FRAME DELAY
--=====================================================================================
	MPUADDR		:=	16#000#;
	MPUDATA		:=	FRAMEDLY;
	MCU_ADDR	<=	CONV_STD_LOGIC_VECTOR(MPUADDR,7);
	MCU_BIDAT	<=	(OTHERS	=>	'Z');

	FOR X IN 1 DOWNTO 0 LOOP
		MCU_ADDR	<= CONV_STD_LOGIC_VECTOR(MPUADDR,7);
		MCU_BIDAT	<= CONV_STD_LOGIC_VECTOR(MPUDATA,8);
		WAIT FOR (Clk1_T);
			FPGA_CSn	<= '0';
			WAIT FOR (Clk1_T);
				MCU_WRn	<= '0';
				WAIT FOR (CPUWR);
				MCU_WRn	<= '1';
			WAIT FOR (Clk1_T);
			FPGA_CSn	<= '1';
		WAIT FOR (Clk1_T);
		MCU_ADDR	<=	(OTHERS	=>	'0');
		MCU_BIDAT	<=	(OTHERS	=>	'Z');
		MPUADDR		:=	MPUADDR + 16#10#;	--	ADDR 0h = RX FRAME DELAY, ADDR 20h = TX FRAME DELAY
		MPUDATA		:=	MPUDATA;
		WAIT FOR (CPUWR * 2);
	END LOOP;

	FPGA_CSn		<=	'1';
	MCU_WRn		<=	'1';
	MCU_RDn		<=	'1';
	MPUADDR		:=	0;
	MPUDATA		:=	0;
	MCU_ADDR	<=	(OTHERS	=>	'0');
	MCU_BIDAT	<=	(OTHERS	=>	'Z');
	WAIT FOR RSTPER;
--=====================================================================================
--	RELEASE ALL THE AUDIO TRANSFER LOGIC FROM RESET
--=====================================================================================
	MPUADDR		:=	16#20#;	-- ADDRESS FOR RESET RELEASE SINGLE BIT REGISTER
	MPUDATA		:=	16#00#;	-- KEEP DANTE LRCLK/SCLK DISABLED
	MCU_ADDR	<= CONV_STD_LOGIC_VECTOR(MPUADDR,7);
	MCU_BIDAT	<= CONV_STD_LOGIC_VECTOR(MPUDATA,8);
		WAIT FOR (Clk1_T);
			FPGA_CSn	<= '0';
			WAIT FOR (Clk1_T);
				MCU_WRn	<= '0';
				WAIT FOR (CPUWR);
				MCU_WRn	<= '1';
			WAIT FOR (Clk1_T);
			FPGA_CSn	<= '1';
		WAIT FOR (Clk1_T);
	FPGA_CSn		<=	'1';
	MCU_WRn		<=	'1';
	MCU_RDn		<=	'1';
	MPUADDR		:=	0;
	MPUDATA		:=	0;
	MCU_ADDR	<=	(OTHERS	=>	'0');
	MCU_BIDAT	<=	(OTHERS	=>	'Z');
--=====================================================================================

	WAIT;

End Process STIM_MCU;

END;
