onerror {resume}
quietly WaveActivateNextPane {} 0
add wave -noupdate -format Logic -height 20 -label RST /krl_dante_krl_dante_sch_tb/rst
add wave -noupdate -divider -height 20 {Processor Interface}
add wave -noupdate -format Literal -height 20 -label {MCU ADDR} -radix hexadecimal /krl_dante_krl_dante_sch_tb/mcu_addr
add wave -noupdate -format Literal -height 20 -label {MCU BIDATA} -radix hexadecimal /krl_dante_krl_dante_sch_tb/mcu_bidat
add wave -noupdate -format Logic -height 20 -label {FPGA CSn} -radix hexadecimal /krl_dante_krl_dante_sch_tb/fpga_csn
add wave -noupdate -format Logic -height 20 -label {MCU RDn} -radix hexadecimal /krl_dante_krl_dante_sch_tb/mcu_rdn
add wave -noupdate -format Logic -height 20 -label {MCU WRn} -radix hexadecimal /krl_dante_krl_dante_sch_tb/mcu_wrn
add wave -noupdate -format Literal -height 20 -label {CONTROL REG} -radix hexadecimal /krl_dante_krl_dante_sch_tb/uut/control
add wave -noupdate -format Literal -height 20 -label {GE STATUS INPUTS} -radix hexadecimal /krl_dante_krl_dante_sch_tb/ge_status
add wave -noupdate -format Literal -height 20 -label {BP RX FRAME DLY} -radix unsigned /krl_dante_krl_dante_sch_tb/uut/bp_rxframe_dly
add wave -noupdate -format Literal -height 20 -label {BP TX FRAME DLY} -radix unsigned /krl_dante_krl_dante_sch_tb/uut/bp_txframe_dly
add wave -noupdate -divider -height 20 {TX/RX FIFO ERR status}
add wave -noupdate -format Literal -height 20 -label {SIM ERROR TEST} -radix unsigned /krl_dante_krl_dante_sch_tb/sim_err_tst
add wave -noupdate -color Violet -format Logic -height 20 -label {D RX FIFO OVERFLOW} /krl_dante_krl_dante_sch_tb/uut/d_rx_ovrflow
add wave -noupdate -color Violet -format Logic -height 20 -label {D RX FIFO UNDERFLOW} /krl_dante_krl_dante_sch_tb/uut/d_rx_udrflow
add wave -noupdate -color {Slate Blue} -format Logic -height 20 -label {D TX FIFO OVERFLOW} /krl_dante_krl_dante_sch_tb/uut/d_tx_ovrflow
add wave -noupdate -color {Slate Blue} -format Logic -height 20 -label {D TX FIFO UNDERFLOW} /krl_dante_krl_dante_sch_tb/uut/d_tx_udrflow
add wave -noupdate -format Logic -height 20 -label {ENABLE AUD TRANSFERS} /krl_dante_krl_dante_sch_tb/uut/enable_transfers
add wave -noupdate -format Logic -height 20 -label {ERROR INTn} /krl_dante_krl_dante_sch_tb/uut/err_intn
add wave -noupdate -format Logic -height 20 -label {PHY RSTn} /krl_dante_krl_dante_sch_tb/uut/phy_rstn
add wave -noupdate -format Logic -height 20 -label {DANTE RSTn} /krl_dante_krl_dante_sch_tb/uut/dante_rstn
add wave -noupdate -format Logic -height 20 -label {DANTE SCLK SEL} -radix hexadecimal /krl_dante_krl_dante_sch_tb/uut/control(4)
add wave -noupdate -divider -height 20 {Dante Input Logic}
add wave -noupdate -color Firebrick -format Logic -height 20 -label {D LRCLK} /krl_dante_krl_dante_sch_tb/dante_lrclk
add wave -noupdate -format Logic -height 20 -label {D SCLK} /krl_dante_krl_dante_sch_tb/dante_sclk
add wave -noupdate -format Literal -height 20 -label {DANTE STIM DATA} -radix hexadecimal /krl_dante_krl_dante_sch_tb/data_in
add wave -noupdate -color Gold -format Logic -height 20 -label {D DIN0} /krl_dante_krl_dante_sch_tb/d_din0
add wave -noupdate -color Gold -format Logic -height 20 -label {D DIN1} /krl_dante_krl_dante_sch_tb/d_din1
add wave -noupdate -color Gold -format Logic -height 20 -label {D DIN2} /krl_dante_krl_dante_sch_tb/d_din2
add wave -noupdate -color Gold -format Logic -height 20 -label {D DIN3} /krl_dante_krl_dante_sch_tb/d_din3
add wave -noupdate -format Logic -height 20 -label {BP LRCLK} /krl_dante_krl_dante_sch_tb/bp_lrclk
add wave -noupdate -format Logic -height 20 -label {BP MCLK} /krl_dante_krl_dante_sch_tb/bp_mclk
add wave -noupdate -format Logic -height 20 -label {BP FRAMESYNC} /krl_dante_krl_dante_sch_tb/uut/bp_framesync
add wave -noupdate -format Logic -height 20 -label {BP RESYNC} /krl_dante_krl_dante_sch_tb/uut/bp_rsync
add wave -noupdate -format Literal -height 20 -label {BP STATE} -radix unsigned /krl_dante_krl_dante_sch_tb/uut/bp_state
add wave -noupdate -divider -height 20 {Dante Rx Fifo Write Logic}
add wave -noupdate -color Sienna -format Logic -height 20 -label {DANTE LRCLK} -radix hexadecimal /krl_dante_krl_dante_sch_tb/dante_lrclk
add wave -noupdate -color Sienna -format Logic -height 20 -label {BP MCLK} /krl_dante_krl_dante_sch_tb/bp_mclk
add wave -noupdate -format Literal -height 20 -label {D RXFIFO WCH SEL} /krl_dante_krl_dante_sch_tb/uut/d_rxwch_sel
add wave -noupdate -format Logic -height 20 -label {D RXFIFO WREN} /krl_dante_krl_dante_sch_tb/uut/bp_rxwren
add wave -noupdate -divider -height 20 {Dante Rx Fifo Read Logic}
add wave -noupdate -color Wheat -format Logic -height 20 -label {BP MCLK} /krl_dante_krl_dante_sch_tb/bp_mclk
add wave -noupdate -format Logic -height 20 -label {D RXFIFO XFERCYCLE} /krl_dante_krl_dante_sch_tb/uut/bp_rxfifo_xfrcycle
add wave -noupdate -color Wheat -format Literal -height 20 -label {BP DMSTOR WADDR} -radix unsigned /krl_dante_krl_dante_sch_tb/uut/bp_dmstor_waddr
add wave -noupdate -color Wheat -format Logic -height 20 -label {BP DMSTOR WREN} /krl_dante_krl_dante_sch_tb/uut/bp_dmstor_wren
add wave -noupdate -format Literal -height 20 -label {BP RXFIFO CHNCNT} -radix unsigned /krl_dante_krl_dante_sch_tb/uut/rxfifo_chncnt
add wave -noupdate -divider -height 20 {DMSTOR TO BPMSTOR XFER LOGIC}
add wave -noupdate -color {Cornflower Blue} -format Logic -height 20 -label {D RXFIFO XFERCYCLE} /krl_dante_krl_dante_sch_tb/uut/bp_rxfifo_xfrcycle
add wave -noupdate -color {Cornflower Blue} -format Literal -height 20 -label {DMSTOR RDADDR} -radix unsigned /krl_dante_krl_dante_sch_tb/uut/dmstor_rdaddr
add wave -noupdate -color {Cornflower Blue} -format Logic -height 20 -label {DMSTOR RD} -radix unsigned /krl_dante_krl_dante_sch_tb/uut/dmstor_rd
add wave -noupdate -color {Cornflower Blue} -format Logic -height 20 -label {BP MCLK} /krl_dante_krl_dante_sch_tb/bp_mclk
add wave -noupdate -color {Cornflower Blue} -format Literal -height 20 -label {DANTE MSTOR DAT} -radix hexadecimal /krl_dante_krl_dante_sch_tb/uut/dante_mstor_dat
add wave -noupdate -format Literal -height 20 -label {BPMSTOR WR ADDR} -radix unsigned /krl_dante_krl_dante_sch_tb/uut/bpmstor_wraddr
add wave -noupdate -format Logic -height 20 -label {BPMSTOR WR} -radix unsigned /krl_dante_krl_dante_sch_tb/uut/bpmstor_wr
add wave -noupdate -format Literal -height 20 -label {BP STATE} -radix unsigned /krl_dante_krl_dante_sch_tb/uut/bp_state
add wave -noupdate -format Logic -height 20 -label {BP LVDS OUT} /krl_dante_krl_dante_sch_tb/uut/bp_lvds_out
add wave -noupdate -divider -height 20 {I2S Timing and Logic}
add wave -noupdate -color Maroon -format Logic -height 20 -label {I2S CLK} /krl_dante_krl_dante_sch_tb/uut/s_clk
add wave -noupdate -color Maroon -format Logic -height 20 -label {BP LRCLK} /krl_dante_krl_dante_sch_tb/bp_lrclk
add wave -noupdate -format Logic -label {MCLK SCLK ALIGN} /krl_dante_krl_dante_sch_tb/uut/mclk_sclk_fb
add wave -noupdate -color Maroon -format Literal -height 20 -label {I2S STATE} -radix unsigned /krl_dante_krl_dante_sch_tb/uut/i2s_state
add wave -noupdate -format Literal -height 20 -label {I2S STIM DATA} -radix hexadecimal /krl_dante_krl_dante_sch_tb/i2sdat_in
add wave -noupdate -color Maroon -format Logic -height 20 -label {I2S FRAMESYNC} /krl_dante_krl_dante_sch_tb/uut/i2s_framesync
add wave -noupdate -color Maroon -format Logic -height 20 -label {I2S RESYNC} /krl_dante_krl_dante_sch_tb/uut/i2s_rsync
add wave -noupdate -format Logic -height 20 -label {I2S IN(0) PIN} -radix hexadecimal /krl_dante_krl_dante_sch_tb/bpi2s_din(0)
add wave -noupdate -format Logic -height 20 -label {I2S IN(0) FD} -radix hexadecimal /krl_dante_krl_dante_sch_tb/uut/bpi2s_dat(0)
add wave -noupdate -format Logic -height 20 -label {BPI2S XFER CYCLE} /krl_dante_krl_dante_sch_tb/uut/bpi2s_xfrcycle
add wave -noupdate -format Logic -height 20 -label {BPI2S MSTOR RD} /krl_dante_krl_dante_sch_tb/uut/bpi2s_mrd
add wave -noupdate -format Literal -height 20 -label {BPI2S MSTOR RD DATA} -radix hexadecimal /krl_dante_krl_dante_sch_tb/uut/bpi2s_mstor_dat
add wave -noupdate -format Logic -height 20 -label {BPI2S DTX FIFO WR DLY} /krl_dante_krl_dante_sch_tb/uut/bpi2s_fifo_wr_dly
add wave -noupdate -color {Cornflower Blue} -format Logic -height 20 -label {BP MCLK} /krl_dante_krl_dante_sch_tb/bp_mclk
add wave -noupdate -format Literal -height 20 -label {DANTE TX FIFO CHNCNT} -radix unsigned /krl_dante_krl_dante_sch_tb/uut/txfifo_chncnt
add wave -noupdate -divider -height 20 {Dante Tx Fifo Timing}
add wave -noupdate -color Plum -format Logic -height 20 -label {DANTE LRCLK} /krl_dante_krl_dante_sch_tb/dante_lrclk
add wave -noupdate -format Logic -label {DANTE SCLK} /krl_dante_krl_dante_sch_tb/uut/dante_sclk
add wave -noupdate -color Cyan -format Literal -height 20 -label {DANTE TXCHNL COUNT} -radix unsigned /krl_dante_krl_dante_sch_tb/uut/d_txchnl_count
add wave -noupdate -format Logic -height 20 -label {DANTE TXLD ENA} /krl_dante_krl_dante_sch_tb/uut/d_txld_ena
add wave -noupdate -format Logic -height 20 -label {DANTE TX FIFO RD} /krl_dante_krl_dante_sch_tb/uut/dtx_fifo_rd
add wave -noupdate -color Yellow -format Logic -height 20 -label {D SDOUT LD} /krl_dante_krl_dante_sch_tb/uut/d_sdout_ld
add wave -noupdate -color Plum -format Logic -height 20 -label {D SDO 0} /krl_dante_krl_dante_sch_tb/uut/d_sdo_0
add wave -noupdate -color Plum -format Logic -height 20 -label {D SDO 1} /krl_dante_krl_dante_sch_tb/uut/d_sdo_1
add wave -noupdate -color Plum -format Logic -height 20 -label {D SDO 2} /krl_dante_krl_dante_sch_tb/uut/d_sdo_2
add wave -noupdate -color Plum -format Logic -height 20 -label {D SDO 3} /krl_dante_krl_dante_sch_tb/uut/d_sdo_3
add wave -noupdate -format Logic -label {DANTE LRCLK OUT} /krl_dante_krl_dante_sch_tb/uut/dlrclk_out
add wave -noupdate -format Logic -label {DANTE SCLK OUT} /krl_dante_krl_dante_sch_tb/uut/dsclk_out
TreeUpdate [SetDefaultTree]
WaveRestoreCursors {{Cursor 1} {0 ps} 0}
configure wave -namecolwidth 216
configure wave -valuecolwidth 68
configure wave -justifyvalue left
configure wave -signalnamewidth 0
configure wave -snapdistance 10
configure wave -datasetprefix 0
configure wave -rowmargin 4
configure wave -childrowmargin 2
configure wave -gridoffset 0
configure wave -gridperiod 1
configure wave -griddelta 40
configure wave -timeline 0
configure wave -timelineunits ps
update
WaveRestoreZoom {0 ps} {368550 ns}
