-- Vhdl test bench created from schematic C:\XilinxWebPack92Designs\SuperRIO\SRIO_MainProcessor\SRIO_MainProcessorModule.sch - Mon Nov 09 14:21:07 2009
--
-- Notes: 
-- 1) This testbench template has been automatically generated using types
-- std_logic and std_logic_vector for the ports of the unit under test.
-- Xilinx recommends that these types always be used for the top-level
-- I/O of a design in order to guarantee that the testbench will bind
-- correctly to the timing (post-route) simulation model.
-- 2) To use this template as your testbench, change the filename to any
-- name of your choice with the extension .vhd, and use the "Source->Add"
-- menu in Project Navigator to import the testbench. Then
-- edit the user defined section below, adding code to generate the 
-- stimulus for your design.
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
LIBRARY UNISIM;
USE UNISIM.Vcomponents.ALL;

ENTITY SRIO_MainProcessorModule_SRIO_MainProcessorModule_sch_tb IS
END SRIO_MainProcessorModule_SRIO_MainProcessorModule_sch_tb;

ARCHITECTURE behavioral OF 
      SRIO_MainProcessorModule_SRIO_MainProcessorModule_sch_tb IS 

COMPONENT SRIO_MainProcessorModule
	PORT(
			RST								:IN	STD_LOGIC; 
			D_DIN0							:IN	STD_LOGIC; 
			D_DIN1							:IN	STD_LOGIC; 
			D_DIN2							:IN	STD_LOGIC; 
			D_DIN3							:IN	STD_LOGIC; 
			DANTE_MCLK				:IN	STD_LOGIC; 
			DANTE_LRCLK				:IN	STD_LOGIC; 
			BP_TXRDEN					:IN	STD_LOGIC; 
			BP_TXWREN					:IN	STD_LOGIC; 
			TXFIFO_BPDATA			:IN	STD_LOGIC_VECTOR (31 DOWNTO 0);
			BP_MCLK						:IN	STD_LOGIC; 
			BP_LRCLK						:IN	STD_LOGIC;
			BP_FRAME_DELAY			:IN	STD_LOGIC_VECTOR (7 DOWNTO 0);
			BP_RXRDEN					:OUT	STD_LOGIC; 
			BP_RXWREN					:OUT	STD_LOGIC; 
			D_RXWCH_SEL				:OUT	STD_LOGIC_VECTOR (1 DOWNTO 0); 
			DANTE_CHNL_COUNT		:OUT	STD_LOGIC_VECTOR (3 DOWNTO 0);
			DANTE_WR_RESYNC		:OUT	STD_LOGIC; 
			DANTE_LRCLK_EDGE		:OUT	STD_LOGIC; 
			DANTE_RX_STATE			:OUT	STD_LOGIC_VECTOR (8 DOWNTO 0); 
			DANTE_CHNL_HOLD		:OUT	STD_LOGIC; 
			DANTE_CHNDAT			:OUT	STD_LOGIC_VECTOR (31 DOWNTO 0); 
			D_RXFIFO_CHNCNT		:OUT	STD_LOGIC_VECTOR (9 DOWNTO 0); 
			D_RXFIFO_WR_ACK		:OUT	STD_LOGIC; 
			D_RXFIFO_BPDATA		:OUT	STD_LOGIC_VECTOR (31 DOWNTO 0);
			D_RXFIFO_RD_VALID		:OUT	STD_LOGIC; 
			D_RXFIFO_FULL				:OUT	STD_LOGIC; 
			D_RXFIFO_EMPTY			:OUT	STD_LOGIC
		);
END COMPONENT;

-- 	INPUTS
	SIGNAL RST							:	STD_LOGIC										:=	'1';
	SIGNAL D_DIN0						:	STD_LOGIC										:=	'0';
	SIGNAL D_DIN1						:	STD_LOGIC										:=	'0';
	SIGNAL D_DIN2						:	STD_LOGIC										:=	'0';
	SIGNAL D_DIN3						:	STD_LOGIC										:=	'0';
	SIGNAL DANTE_MCLK			:	STD_LOGIC										:=	'0';
	SIGNAL DANTE_LRCLK			:	STD_LOGIC										:=	'0';
	SIGNAL BP_TXRDEN				:	STD_LOGIC										:=	'0';
	SIGNAL BP_TXWREN				:	STD_LOGIC										:=	'0';
	SIGNAL TXFIFO_BPDATA		:	STD_LOGIC_VECTOR (31 DOWNTO 0)	:=	(OTHERS	=>	'Z');
	SIGNAL BP_MCLK					:	STD_LOGIC										:=	'0';
	SIGNAL BP_LRCLK					:	STD_LOGIC										:=	'0';
	SIGNAL	BP_FRAME_DELAY		:	STD_LOGIC_VECTOR (7 DOWNTO 0)	:=	CONV_STD_LOGIC_VECTOR(1,8);

--	OUTPUTS
	SIGNAL BP_RXRDEN				:	STD_LOGIC;
	SIGNAL BP_RXWREN				:	STD_LOGIC;
	SIGNAL D_RXWCH_SEL			:	STD_LOGIC_VECTOR (1 DOWNTO 0);
	SIGNAL	DANTE_CHNL_COUNT	:	STD_LOGIC_VECTOR (3 DOWNTO 0);
	SIGNAL DANTE_WR_RESYNC	:	STD_LOGIC;
	SIGNAL DANTE_LRCLK_EDGE	:	STD_LOGIC;
	SIGNAL DANTE_RX_STATE		:	STD_LOGIC_VECTOR (8 DOWNTO 0);
	SIGNAL DANTE_CHNL_HOLD	:	STD_LOGIC;
	SIGNAL DANTE_CHNDAT		:	STD_LOGIC_VECTOR (31 DOWNTO 0);
	SIGNAL D_RXFIFO_CHNCNT	:	STD_LOGIC_VECTOR (9 DOWNTO 0);
	SIGNAL D_RXFIFO_WR_ACK	:	STD_LOGIC;
	SIGNAL D_RXFIFO_BPDATA	:	STD_LOGIC_VECTOR (31 DOWNTO 0);
	SIGNAL D_RXFIFO_RD_VALID	:	STD_LOGIC;
	SIGNAL D_RXFIFO_FULL			:	STD_LOGIC;
	SIGNAL D_RXFIFO_EMPTY		:	STD_LOGIC;
--
--#####################################################################################
--=====================================================================================
--	Temp Signals for Simulation
--=====================================================================================
--#####################################################################################
-- 
	SIGNAL DATA_IN	:	UNSIGNED (31 DOWNTO 0)	:= (others => '0');
--
--#####################################################################################
--=====================================================================================
--	Clock and reset constants
--	For SuperRIO, TDM-8 timing, MCLK is half 32KD MCLK so that here it equals 512 bits * sample rate (48K * 512 = 24.576MHz)
--	TDM-8	=	8chnls LEFT (8 * 32bits = 256bits) + 8chnls RIGHT (8 * 32bits = 256bits) = 512bits total per sample period.
--	TDM-16	=	16chnls LEFT (16 * 32bits = 512bits) + 16chnls RIGHT (16 * 32bits = 512bits) = 1024bits total per sample period.
--=====================================================================================
--#####################################################################################
	CONSTANT	BPMCLKPER	:	time		:=		  20 ns;	-- Bit clk	@ 48.821KHz     This is for 1024 bits or 32 channels/sample
--	CONSTANT	BPSCLKPER	:	time		:=		160 ns;	-- I2S clk	@ 48.821KHz 
	CONSTANT	BPLCLKPER	:	time		:=	 20480 ns;	-- LR  clk	@ 48.821KHz
--#####################################################################################
--	CONSTANT	MCLKPER	:	time		:=		  20 ns;	-- Bit clk	@ 97.6563KHz
--	CONSTANT	SCLKPER	:	time		:=		160 ns;	-- I2S clk	@ 97.6563KHz
--	CONSTANT	LCLKPER	:	time		:=	 10240 ns;	-- LR  clk	@ 97.6563KHz
--#####################################################################################
	CONSTANT	MCLKPER	:	time		:=		  40 ns;	-- Bit clk	@ 48.821KHz     This is for 512 bits or 16 channels/sample
--	CONSTANT	SCLKPER	:	time		:=		320 ns;	-- I2S clk	@ 48.821KHz
	CONSTANT	LCLKPER	:	time		:=	 20480 ns;	-- LR  clk	@ 48.821KHz
--#####################################################################################
--	CONSTANT	MCLKPER	:	time		:=	  40500 ps;-- Bit clk	@ 48KHz	| These get as close to actual frequencies but are
--	CONSTANT	SCLKPER	:	time		:=	324000 ps;-- I2S clk	@ 48KHz	| still evenly divisable for the simulator. That way I 
--	CONSTANT	LCLKPER	:	time		:=	  20736 ns;-- LR  clk	@ 48KHz	| can keep the edges aligned perfectly.
--#####################################################################################
--	CONSTANT	MCLKPER	:	time		:=	  44250 ps;-- Bit clk	@ 44.1KHz	| These get as close to actual frequencies but are 
--	CONSTANT	SCLKPER	:	time		:=	354000 ps;-- I2S clk	@ 44.1KHz	| still evenly divisable for the simulator. That way I
--	CONSTANT	LCLKPER	:	time		:=	  22656 ns;-- LR  clk	@ 44.1KHz	| can keep the edges aligned perfectly.
--#####################################################################################
	CONSTANT	RSTPER		:	time		:=	500 ns;	-- Reset
	CONSTANT	MCKDLY	:	Integer	:=	474;		-- Align incoming data with RESYNC
																			--	263 @ 48.821KHz / 226 @ 97.6563KHz, due to RST constant
	CONSTANT	STIMDLY	:	Integer	:=	474;		-- Align incoming data with RESYNC
																			--	262 @ 48.821KHz / 225 @ 97.6563KHz, due to RST constant

BEGIN

UUT: SRIO_MainProcessorModule
	PORT MAP(
					RST							=> RST, 
					D_DIN0						=> D_DIN0, 
					D_DIN1						=> D_DIN1, 
					D_DIN2						=> D_DIN2, 
					D_DIN3						=> D_DIN3, 
					DANTE_MCLK			=> DANTE_MCLK, 
					DANTE_LRCLK			=> DANTE_LRCLK, 
					D_RXWCH_SEL			=> D_RXWCH_SEL, 
					DANTE_CHNL_COUNT	=> DANTE_CHNL_COUNT,
					DANTE_WR_RESYNC	=> DANTE_WR_RESYNC, 
					DANTE_LRCLK_EDGE	=> DANTE_LRCLK_EDGE, 
					DANTE_RX_STATE		=> DANTE_RX_STATE, 
					DANTE_CHNL_HOLD	=> DANTE_CHNL_HOLD, 
					DANTE_CHNDAT		=> DANTE_CHNDAT, 
					BP_MCLK					=> BP_MCLK, 
					BP_LRCLK					=> BP_LRCLK, 
					BP_FRAME_DELAY		=> BP_FRAME_DELAY,
					BP_RXWREN				=> BP_RXWREN, 
					BP_RXRDEN				=> BP_RXRDEN, 
					BP_TXWREN				=> BP_TXWREN, 
					BP_TXRDEN				=> BP_TXRDEN,
					TXFIFO_BPDATA		=> TXFIFO_BPDATA,
					D_RXFIFO_CHNCNT	=> D_RXFIFO_CHNCNT, 
					D_RXFIFO_WR_ACK	=> D_RXFIFO_WR_ACK, 
					D_RXFIFO_BPDATA	=> D_RXFIFO_BPDATA, 
					D_RXFIFO_RD_VALID	=> D_RXFIFO_RD_VALID, 
					D_RXFIFO_FULL			=> D_RXFIFO_FULL, 
					D_RXFIFO_EMPTY		=> D_RXFIFO_EMPTY
				);
--
--#####################################################################################
--=====================================================================================
--	CLOCKS AND RESET
--=====================================================================================
--#####################################################################################
--
TB_RST:
Process
Begin

	RST	<= '1';
	wait for (RSTPER * 3);
	RST	<= '0';
	wait;

End Process TB_RST;
--
--####### DANTE MCLK/LCLK
--
TB_MCLK:
Process
Begin

	DANTE_MCLK	<= '0';	--
	wait for (MCLKPER/2);	--
	DANTE_MCLK	<= '1';	--
	wait for (MCLKPER/2);	--

End Process TB_MCLK;

TB_LRCLK:
Process
Begin

	DANTE_LRCLK	<= '0';
	wait for (LCLKPER/2);
	DANTE_LRCLK	<= '1';
	wait for (LCLKPER/2);

End Process TB_LRCLK;
--
--####### BACKPLANE MCLK/LCLK
--
TB_BPMCLK:
Process
Begin

	BP_MCLK	<= '0';				--
	wait for (BPMCLKPER/2);	--
	BP_MCLK	<= '1';				--
	wait for (BPMCLKPER/2);	--

End Process TB_BPMCLK;

TB_BPLRCLK:
Process
Begin

	BP_LRCLK	<= '0';
	wait for (BPLCLKPER/2);
	BP_LRCLK	<= '1';
	wait for (BPLCLKPER/2);

End Process TB_BPLRCLK;
--
--#####################################################################################
--=====================================================================================
--	CONTINUOUS LVDS STIM DATA
--=====================================================================================
--#####################################################################################
--
STIM_DIN:
Process

Variable	DIN		:	Integer	:= 0;

Begin

	DATA_IN		<= X"00000000";
	wait for ((RSTPER * 3) + (2 * LCLKPER) + (MCKDLY*MCLKPER) + (MCLKPER/4));

	for z in 511 downto 0 loop
--=====================================================================================
--		Left channel
--=====================================================================================
		DATA_IN	<= X"4AAAAAA0";			-- Use this section to check bit alignment
		wait for MCLKPER * 256;				-- 32-bit channels X 8 channels
--		DATA_IN	<= X"4AAAAAA0";			-- Use this section to check bit alignment
--		wait for MCLKPER * 32;					-- 32-bit channels X 8 channels
--		DATA_IN	<= X"00000000";			-- Use this section to check bit alignment
--		wait for MCLKPER * 32;					-- 32-bit channels X 8 channels
--		DATA_IN	<= X"00000000";			-- Use this section to check bit alignment
--		wait for MCLKPER * 224;				-- 32-bit channels X 8 channels
--=====================================================================================
--		Right channel
--=====================================================================================
		DATA_IN	<= X"4AAAAAA0";			-- Use this section to check bit alignment
		wait for MCLKPER * 256;				-- 32-bit channels X 8 channels
--		DATA_IN	<= X"4AAAAAA0";			-- Use this section to check bit alignment
--		wait for MCLKPER * 32;					-- 32-bit channels X 8 channels
--		DATA_IN	<= X"00000000";			-- Use this section to check bit alignment
--		wait for MCLKPER * 32;					-- 32-bit channels X 8 channels
--		DATA_IN	<= X"00000000";			-- Use this section to check bit alignment
--		wait for MCLKPER * 224;				-- 32-bit channels X 8 channels

	end loop;

	wait;
End Process STIM_DIN;
--
--#####################################################################################
--=====================================================================================
--	CONTINUOUS LVDS DATA INTO FPGA
--=====================================================================================
--#####################################################################################
--
STIM_DAT:
Process
Begin
	wait for ((RSTPER * 3) + (3 * LCLKPER) + (MCKDLY*MCLKPER) + (MCLKPER/4));

	for x in 65535 downto 0 loop
			for y in 31 downto 0 loop

				D_DIN0		<=	DATA_IN(y);
--				D_DIN1		<=	DATA_IN(y);
--				D_DIN2		<=	DATA_IN(y);
--				D_DIN3		<=	DATA_IN(y);

				wait for MCLKPER;
			end loop;
	end loop;

	wait;
End Process STIM_DAT;

END;
